package edu.bu.signstream.codingScheme.ui.importLegacyCodingScheme;

import java.util.*;
import javax.swing.table.*;

public class SortableTableModel extends AbstractTableModel {
	protected Object[] columnNames = null;

	protected Object[][] data = null;

	public SortableTableModel(Object[] columnNames, Object[][] data) {
		this.columnNames = columnNames;
		this.data = data;
	}

	public ArrayList getData() {
		ArrayList list = new ArrayList();
		for (int i = 0; i < data.length; i++) {
			list.add(data[i]);
		}
		return list;
	}

	@Override
	public int getColumnCount() {
		return columnNames.length;
	}

	@Override
	public int getRowCount() {
		return data == null ? 0 : data.length;
	}

	@Override
	public String getColumnName(int col) {
		return (String) columnNames[col];
	}

	@Override
	public Object getValueAt(int row, int col) {
		return data[row][col];
	}

	/*
	 * Don't need to implement this method unless your table's editable.
	 */
	@Override
	public boolean isCellEditable(int row, int col) {
		return false;
	}

	public void update(int row, int col) {
	}

	public void reloadData(Object[][] dataToUpdate) {
		this.data = dataToUpdate;
	}

	public ArrayList getSelectedFields() {
		ArrayList selectedFields = new ArrayList();

		for (int i = 0; i < data.length; i++) {
			Object[] obj = data[i];
			Boolean selected = (Boolean) obj[0];

			if (selected.booleanValue()) {
				selectedFields.add(obj[4]);
			}
		}
		return selectedFields;
	}
}
