package edu.bu.signstream.common.util.vo.ss3.codingScheme;

import java.util.HashMap;

import edu.bu.signstream.common.util.Util;

public class SS3CodingSchemeCollection {
   private HashMap<String, SS3CodingScheme> schemes = new HashMap<String, SS3CodingScheme>();

   private String defaultCodingSchemeID = "default";

   public void setDefaultCodingScheme(SS3CodingScheme scheme) {
	  if (scheme.getID() == null) {
		  scheme.setID(Util.getUniqueNumber());
	  }
      this.defaultCodingSchemeID = scheme.getID();
      setSS3CodingScheme(scheme);
   }

   public SS3CodingScheme getDefaultCodingScheme() {
      return getSS3CodingScheme(this.defaultCodingSchemeID);
   }

   public SS3CodingScheme getSS3CodingScheme(String schemeID) {
      return schemes.get(schemeID);
   }

   public void setSS3CodingScheme(SS3CodingScheme scheme) {
		  if (scheme.getID() == null) {
			  scheme.setID(Util.getUniqueNumber());
		  }
      schemes.put(scheme.getID(), scheme);
   }
}
