package edu.bu.signstream.common.util.vo.ss3.codingScheme.handShapes;

import java.util.HashMap;
import java.util.ArrayList;

public class CSHandShapeTemplate {

   public static String LETTERS = "1"; 
   public static String LETTERS_UNMARKED = "11";   
   public static String NUMBERS = "2"; 
   public static String NUMBERS_UNMARKED = "12";  
   public static String NOT_LETTERS_NOT_NUMBERS = "3"; 
   public static String NOT_LETTERS_NOT_NUMBERS_UNMARKED = "13";  
   public static String ALL = "4"; 
   public static String ALL_UNMARKED = "14";  
   public static String FINGERSPELLED = "5";
   public static String FINGERSPELLED_UNMARKED = "15";  
   public static String GESTURE = "60";

   private String id;
   private String name;
   private String label;
   
   private String selectedPaletteID = null;
   // use only for DblHandShapePalette
   private String selectedPaletteID2 = null;

   private HashMap handShapePalettes = new HashMap();
   
   public void selectPaletteWithName(String name) {
      ArrayList list = getHandShapePalettes();
      
      for(int i = 0; i < list.size(); i++) {
         CSHandShapePalette palette = (CSHandShapePalette) list.get(i);
         
         if(palette.getName().equals(name))
            selectPalette(palette.getId());
      }
   } 

   public void addHandShapePalette(CSHandShapePalette palette) {
      handShapePalettes.put(palette.getId(), palette);
      
      if(selectedPaletteID == null)
         selectedPaletteID = palette.getId();
   }
   
   public void selectPalette(String paletteId) {
      this.selectedPaletteID = paletteId;
   }
   
   public String getSelectedPaletteID() {
	   return selectedPaletteID;
   }
   
   public void selectPalette2(String paletteId) {
      this.selectedPaletteID2 = paletteId;
   }
   
   public CSHandShapePalette getSelectedHandShapePalette() {
      return getHandShapePalette(selectedPaletteID);
   }
   
   public CSHandShapePalette getSelectedHandShapePalette2() {
      if(selectedPaletteID2 == null || selectedPaletteID2.length() == 0) {
         return getSelectedHandShapePalette();
      } else {
         return getHandShapePalette(selectedPaletteID2);
      }     
   }
   
   public CSHandShapePalette getHandShapePalette(String handShapePaletteId) {
      return (CSHandShapePalette)handShapePalettes.get(handShapePaletteId);
   }

   public String getId() {
      return id;
   }

   public String getName() {
      return name;
   }

   public void setId(String string) {
      id = string;
   }

   public void setName(String string) {
      name = string;
   }

   // returns CSHandShapePalette
   public ArrayList getHandShapePalettes() {
      return new ArrayList(handShapePalettes.values());
   }

   public void setHandShapePalettes(ArrayList list) {
      for(int i = 0; i < list.size(); i++) {
         CSHandShapePalette palette = (CSHandShapePalette)list.get(i);
         addHandShapePalette(palette);
      }
      
   }
   /**
    * @return
    */
   public String getLabel() {
      return label;
   }

   /**
    * @param string
    */
   public void setLabel(String string) {
      label = string;
   }
   
   @Override
public String toString() {
      String lbl = getName().length() < 18 ? getName() : getName().substring(0, 18)+"...";
      return lbl;
   }

}
