package edu.bu.signstream.common.util.vo.ss3.participants;

import java.util.*;

public class ParticipantsLibrary {
	// private ArrayList references = new ArrayList();
	private HashMap<String, SS3Participant> localParticipants = new HashMap<String, SS3Participant>();
	private HashMap<String, SS3Participant> globalParticipants = new HashMap<String, SS3Participant>();
	
	private String globalParticipantsFileName = null;
	private String localParticipantsFileName = null;
	
	public String getGlobalParticipantsFileName() {
		return globalParticipantsFileName;
	}

	public void setGlobalParticipantsFileName(String globalParticipantsFileName) {
		this.globalParticipantsFileName = globalParticipantsFileName;
	}

	public String getLocalParticipantsFileName() {
		return localParticipantsFileName;
	}

	public void setLocalParticipantsFileName(String localParticipantsFileName) {
		this.localParticipantsFileName = localParticipantsFileName;
	}

	public void addLocalParticipant(SS3Participant participant) {
		localParticipants.put(participant.getId(), participant);
	}
	
	public SS3Participant getLocalParticipant(String participantID) {
		return localParticipants.get(participantID);
	}
	
	public SS3Participant removeLocalParticipant(String participantID) {
		return localParticipants.remove(participantID);
	}
	
	public HashMap<String, SS3Participant> getLocalParticipants() {
		return localParticipants;
	}

	public void setLocalParticipants(HashMap<String, SS3Participant> map) {
		localParticipants = map;
	}

	public void addGlobalParticipant(SS3Participant participant) {
		globalParticipants.put(participant.getId(), participant);
	}
	
//	public SS3Participant getGlobalParticipant(String participantID) {
//		return localParticipants.get(participantID);
//	}
	
	public HashMap<String, SS3Participant> getGlobalParticipants() {
		return globalParticipants;
	}

	public void setGlobalParticipants(HashMap<String, SS3Participant> map) {
		globalParticipants = map;
	}
	
	public boolean isLocalParticipant(String participantID) {
		return (localParticipants.get(participantID) != null);
	}
	
	public boolean isGlobalParticipant(String participantID) {
		return (globalParticipants.get(participantID) != null);
	}
	
	/*
	 * returns local participant is exist, otherwise returns global participant
	 * */
	public SS3Participant getParticipant(String participantID) {
		
		SS3Participant participant = localParticipants.get(participantID);
		
		if(participant != null) {
			return participant;
		} 
			
		participant = globalParticipants.get(participantID);	
		
		if(participant != null) {
			return participant;
		}
		
		participant = new SS3Participant();
		participant.setDomHand("R");
		return participant;
	}
	
	public void editParticipant(SS3Participant participant) {
		if ( !isLocalParticipant(participant.getId())) {
			return;
		}
		
		localParticipants.put(participant.getId(), participant);
	}
}
