package edu.bu.signstream.grepresentation.fields.apexField;

import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;

import edu.bu.signstream.common.util.UserInterfaceUtil;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;

public class ApexDblRightClickedDelegate {
   private ApexField nmField = null;

   public ApexDblRightClickedDelegate(ApexField nmField) {
      this.nmField = nmField;
   }

   public ApexField getNonManualField() {
      return nmField;
   }

   public void dblClick(
      ChainedApexEvent event,
      final ApexChainedApexEventsEntity entity,
      final Point point,
      final JPanel panel) {

	   if(event == null)
		   return;
	   
      Event value = entity.getValueOrTextValueEvent();
      Event iHold = entity.getInitialHold();
      Event fHold = entity.getFinalHold();
      Event onset = entity.getOnset();
      Event offset = entity.getOffset();

      if (event.equals(value)) {
    	  //SS3Singleton.getNonManuelFieldDialogs().getAssociatedElelmentsMenu(entity, point, panel);
         //valueDblClick(event, entity, point, panel);
      } else {
         final JPopupMenu popup = new JPopupMenu();
         JMenuItem mi = null;

         if (event.equals(onset)) {
            mi = new JMenuItem("Delete Onset");
            mi.addActionListener(new ActionListener() {
               @Override
			public void actionPerformed(ActionEvent e) {
                  entity.deleteOnset();
                  SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
                  panel.repaint();
               }
            });
         } else if (event.equals(offset)) {
            mi = new JMenuItem("Delete Offset");
            mi.addActionListener(new ActionListener() {
               @Override
			public void actionPerformed(ActionEvent e) {
                  entity.deleteOffset();
                  SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
                  panel.repaint();
               }
            });
         }
         UserInterfaceUtil.setMenuItemLNF(mi);
         popup.add(mi);
         JMenuItem cancel = new JMenuItem("Cancel");
         UserInterfaceUtil.setMenuItemLNF(cancel);
         popup.add(cancel);
         popup.setPreferredSize(popup.getPreferredSize());
         popup.show(panel, point.x, point.y);
         popup.setVisible(true);
 		
 		SS3Singleton.getSignStreamApplication().forcePopupInvisibleOnWindowLostFocus(popup);
      }
   }

   public void entityDblClick(
      final ChainedApexEventsEntity entity,
      final Point point,
      final JPanel panel) {

      final JPopupMenu popup = new JPopupMenu();

      JMenuItem delete = new JMenuItem("Delete");
      UserInterfaceUtil.setMenuItemLNF(delete);
      //delete.addActionListener(new DeleteActionListener(entity, panel));
      popup.add(delete);
      
      JMenuItem cancel = new JMenuItem("Cancel");
      UserInterfaceUtil.setMenuItemLNF(cancel);
      popup.add(cancel);

      popup.setPreferredSize(popup.getPreferredSize());
      popup.show(panel, point.x, point.y);
      popup.setVisible(true);
		
	  SS3Singleton.getSignStreamApplication().forcePopupInvisibleOnWindowLostFocus(popup);
   }
}
