package edu.bu.signstream.grepresentation.fields.apexField;

import java.awt.Color;

import edu.bu.signstream.common.util.CoordinateTimeConverter;
import edu.bu.signstream.time.Interval;
import edu.bu.signstream.time.Time;
import edu.bu.signstream.time.TimeUnit;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.EventsEntity;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.grepresentation.view.main.Slider;

public class NewChainedApexEvent implements Event {
	private Color color = null;
	private boolean highlighted = false;

	private SignStreamSegmentPanel segmentPanel;

	private EventsEntity previousEntity = null;
	private EventsEntity nextEntity = null;
	
	private Time startTimeInfo;
	private Time endTimeInfo;

	public NewChainedApexEvent(Time time, SignStreamSegmentPanel segmentPanel) {
		this.segmentPanel = segmentPanel;

		startTimeInfo = time;
        endTimeInfo = time;
	}

	@Deprecated
	public double getStartTime() {
		return startTimeInfo.value();
	}

	@Deprecated
	public double getEndTime() {
		return endTimeInfo.value();
	}

	@Deprecated
	public void setStartTime(double startTime) {
	    startTimeInfo = startTimeInfo.range().time(Math.round(startTime), TimeUnit.TIMESTAMP);
	}

	@Deprecated
	public void setEndTime(double endTime) {
        endTimeInfo = endTimeInfo.range().time(Math.round(endTime), TimeUnit.TIMESTAMP);
	}

	@Override
	public double getStartTimeCoordinate() {
		return segmentPanel.getZoomer().getCoordinateTimeConvertor().convertTimeInfoToCoordinate(startTimeInfo);
	}

	@Override
	public double getEndTimeCoordinate() {
		return segmentPanel.getZoomer().getCoordinateTimeConvertor().convertTimeInfoToCoordinate(endTimeInfo);
	}

	@Override
	public void setEndTimeCoordinate(double X2) {
		CoordinateTimeConverter convertor = segmentPanel.getZoomer()
				.getCoordinateTimeConvertor();
		
		Time endTimeInfo = getEndTimeInfo();
		TimeUnit endTimeUnit = endTimeInfo.unit();
		Time timeInfo = convertor.convertCoordinateToTimeInfo(X2);
				
		setEndTimeInfo(timeInfo);
		moveSlider(X2);
	}

	@Override
	public void setStartTimeCoordinate(double X1) {
		CoordinateTimeConverter convertor = segmentPanel.getZoomer()
				.getCoordinateTimeConvertor();
		
		Time startTimeInfo = getStartTimeInfo();
		TimeUnit startTimeUnit = startTimeInfo.unit();
		Time timeInfo = convertor.convertCoordinateToTimeInfo(X1);
		
		setStartTimeInfo(timeInfo);
	}

	@Override
	public boolean select() {
		return false;
	}

	@Override
	public boolean unselect() {
		return false;
	}

	@Override
	public void highlight() {
		this.highlighted = true;
	}

	@Override
	public void unhighlight() {
		this.highlighted = false;
	}

	@Override
	public boolean isHighlighted() {
		return highlighted;
	}

	private void moveSlider(double x) {
		Slider slider = segmentPanel.getSlider();

		if (slider != null)
			slider.setSliderPosition(x, true);
	}
	
	@Override
	public Time getStartTimeInfo() {
		return startTimeInfo;
	}

	@Override
	public Time getEndTimeInfo() {
		return endTimeInfo;
	}

	@Override
	public void setStartTimeInfo(Time startTimeInfo) {
		this.startTimeInfo = startTimeInfo;
	}

	@Override
	public void setEndTimeInfo(Time endTimeInfo) {
		this.endTimeInfo = endTimeInfo;
	}
	
	public EventsEntity getPreviousEntity() {
		return previousEntity;
	}

	public void setPreviousEntity(EventsEntity previousEntity) {
		this.previousEntity = previousEntity;
	}

	public EventsEntity getNextEntity() {
		return nextEntity;
	}

	public void setNextEntity(EventsEntity nextEntity) {
		this.nextEntity = nextEntity;
	}

	@Override
	public String getID() {
		return "";
	}

	@Override
	public void setID(String uniqueID) {
	}

	@Override
	public void setColor(Color color) {
		this.color = color;
	}

	@Override
	public Color getColor() {
		return color;
	}

	@Override
	public boolean isSelected() {
		return false;
	}

	@Override
	public String getToolTipText() {
		return "";
	}

	@Override
	public Interval interval() {
		// TODO Auto-generated method stub
		return null;
	}
}
