package edu.bu.signstream.grepresentation.fields.apexField.mouseDelegateListeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import edu.bu.signstream.common.util.ErrorMessages;
import edu.bu.signstream.time.Rounding;
import edu.bu.signstream.time.Time;
import edu.bu.signstream.common.util.Util;
import edu.bu.signstream.time.TimeUnit;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.FieldWrappersCollection;
import edu.bu.signstream.grepresentation.fields.apexField.ApexChainedApexEventsEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureEventsEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureFieldWrapper;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.grepresentation.view.mediaControl.MediaToolBar;

public class AddApexOffsetActionListener implements ActionListener {

   private ApexChainedApexEventsEntity selectedEntity = null;

   public AddApexOffsetActionListener(ApexChainedApexEventsEntity selectedEntity) {
	   this.selectedEntity = selectedEntity;
   }
   
   @Override
public void actionPerformed(ActionEvent e) {
//		MediaToolBar mediaToolBar = SS3Singleton.getMediaToolBar(null);
//		Event utterance = selectedEntity.getParentEntity().getEvent();

		SignStreamSegmentPanel segmentPanel = SS3Singleton
				.getSignStreamApplication().getSignStreamSegmentPanel();

//		Time minOffsetStartTimeInfo = segmentPanel.getMultipleMovieController()
//				.getFollowingFrameTimeInfo(
//						selectedEntity.getEndTimeInfo());

//		if (minOffsetStartTimeInfo.greaterThan(utterance.getEndTimeInfo())) {
//			SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.EVENT_EXTEND_BEYOND_UTTERANCE);
//			return;
//		} 
			
		ApexChainedApexEventsEntity nextEntity = selectedEntity.getNextEntity();
		
		if(nextEntity != null) {
			Time nextEntiyStartTimeInfo = nextEntity.getStartTimeInfo();
			Time maxOffsetTimeInfo = segmentPanel.getMultipleMovieController().getPrecedingFrameTimeInfo(nextEntiyStartTimeInfo);
			if(selectedEntity.getEndTimeInfo().greaterThan(maxOffsetTimeInfo)) {
				SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.APEX_EXTENDS_PAST_GESTURE);
				return;
			}
		}
		
		
		FieldWrappersCollection gestureWrappers = segmentPanel.getUtteranceView().getSpeechView().getFieldWrappersCollection();
		GestureFieldWrapper gestureWrapper;
		if (selectedEntity.getField().getFieldID().equals(Util.DOM_GESTURE_APEX_FIELD_ID)) {
			gestureWrapper = (GestureFieldWrapper) gestureWrappers.getFieldWrapperWithFieldID(Util.DOM_GESTURE_FIELD_ID);
		} else {
			gestureWrapper = (GestureFieldWrapper) gestureWrappers.getFieldWrapperWithFieldID(Util.NDOM_GESTURE_FIELD_ID);
		}
		GestureEventsEntity parentGestureEntity = (GestureEventsEntity) gestureWrapper.getGestureField()
				.getEntityAt((selectedEntity.getStartTimeCoordinate() + selectedEntity.getEndTimeCoordinate()) / 2);
		
		Time valueEndTimeInfo = selectedEntity.getValueOrTextValueEvent().getEndTimeInfo();
		Time nextFrame = segmentPanel.getMultipleMovieController().getFollowingFrameTimeInfo(valueEndTimeInfo);
		if (nextFrame.greaterThan(parentGestureEntity.getValueOrTextValueEvent().getEndTimeInfo())) {
			SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.CHAINS_CANNOT_OVERLAP); // TODO: change error message
			return;
		}
		
		String seWarning = selectedEntity.addOffsetEvent();
		if (seWarning != null) {
			SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.CHAINS_CANNOT_OVERLAP);
			return;
		}
		Event offset = selectedEntity.getOffset(); 
		selectedEntity.getValueOrTextValueEvent().unselect();
		offset.select();
		MediaToolBar mToolBar = SS3Singleton.getMediaToolBar(segmentPanel);
		mToolBar.selectEvent(offset, selectedEntity, selectedEntity.getField());

       double currentTime = offset.getEndTimeInfo().as(TimeUnit.TIMESTAMP, Rounding.NEAREST);
		segmentPanel.getSlider().setSliderPositionTime(currentTime);
//		segmentPanel.getMultipleMovieController().setCurrentTime(currentTime);
		
		SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
		
		segmentPanel.repaint();
   }
}
