package edu.bu.signstream.grepresentation.fields.freeTextField;

import edu.bu.signstream.common.util.vo.ss3.db.SS3Item;
import edu.bu.signstream.time.TimeUnit;
import edu.bu.signstream.grepresentation.fields.glossField.GlossChainedEvent;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class FreeTextEvent extends GlossChainedEvent {
	private int length = 0;

	public FreeTextEvent(SS3Item item, SignStreamSegmentPanel segmentPanel) {
		super(item, segmentPanel);
	}

	public FreeTextEvent(SignStreamSegmentPanel segmentPanel) {
		super(segmentPanel);
	}

	public void setLenght(int lenght) {
		this.length = lenght;
		setStartTime(getStartTimeInfo().doubleValue());
	}

	// Event interface
	public void setStartTime(double startTime) {
	    setStartTimeInfo(SS3Singleton.getVideoTimeRange().time(Math.round(startTime), TimeUnit.TIMESTAMP));
		if (length > 0) {
			double duration = (length / segmentPanel.getZoomer()
					.getPixelsInTimeFrame());
            setEndTimeInfo(SS3Singleton.getVideoTimeRange().time(Math.round(startTime + duration), TimeUnit.TIMESTAMP));
		}
	}

	// Event interface
	@Override
	public void setStartTimeCoordinate(double coord) {
		double startTime = coord / segmentPanel.getZoomer()
				.getPixelsInTimeFrame();
		setStartTime(startTime);
	}
}
