package edu.bu.signstream.grepresentation.fields.gestureField;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.SwingUtilities;

import edu.bu.signstream.common.util.UserInterfaceUtil;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;

public class GestureDeleteTextActionListener implements ActionListener {
	private GestureText textToDelete = null;
	private GestureEnteredText enteredText = null;
	private JPanel panel = null;

	public GestureDeleteTextActionListener(GestureText textToDelete, GestureEnteredText enteredText, JPanel panel) {
		this.textToDelete = textToDelete;
		this.enteredText = enteredText;
		this.panel = panel;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		final JPopupMenu popup = new JPopupMenu();

		JLabel msgLabel = new JLabel("Are you sure you want to delete the object?");
		UserInterfaceUtil.setLabelLNF(msgLabel);

		final JButton okBtn = new JButton("Proceed");
		final JButton cancelBtn = new JButton("Cancel");

		JPanel msgPanel = new JPanel();
		GridBagConstraints gbc = new GridBagConstraints();

		msgPanel.setLayout(new GridBagLayout());
		gbc.anchor = GridBagConstraints.WEST;

		gbc.gridwidth = 3;
		gbc.gridx = 0;
		gbc.gridy = 0;
		msgPanel.add(msgLabel, gbc);

		gbc.gridy = 1;
		gbc.gridx = 1;
		msgPanel.add(new JLabel(" "), gbc);

		gbc.gridwidth = 1;
		gbc.anchor = GridBagConstraints.EAST;
		gbc.gridy = 3;
		gbc.gridx = 0;
		msgPanel.add(new JLabel(" "), gbc);
		gbc.gridx = 1;
		msgPanel.add(okBtn, gbc);
		gbc.gridx = 2;
		msgPanel.add(cancelBtn, gbc);

		cancelBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				popup.setVisible(false);
			}
		});

		okBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				enteredText.deleteText(textToDelete);
				
				SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
				
				panel.repaint();
				popup.setVisible(false);
			}
		});

		SwingUtilities.invokeLater(new Runnable() {
			@Override
			public void run() {
				okBtn.requestFocus();
			}
		});

		int width = msgPanel.getPreferredSize().width + 30;
		int height = msgPanel.getPreferredSize().height + 20;

		popup.add(msgPanel);
		popup.setPopupSize(new Dimension(width, height));
		popup.setLocation((int) textToDelete.getStartCoord(), 200);
		popup.setVisible(true);
		
		SS3Singleton.getSignStreamApplication().forcePopupInvisibleOnWindowLostFocus(popup);
	}
}
