package edu.bu.signstream.grepresentation.fields.gestureField;

import javax.swing.JTextField;

import edu.bu.signstream.common.util.vo.TrackValue;
import edu.bu.signstream.common.util.vo.ss3.db.SS3Item;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class GestureEvent extends GestureChainedEvent {
	private boolean updatable = false;

	private int prevEventEndCoord = -1;
	private int nextEventStartCoord = -1;

	private JTextField tf = new JTextField();

	private GestureEvent dependentEvent = null;

	private boolean startTimeFinilized = true;
	private boolean endTimeFinilized = false;

	private GestureClassifications classifications = new GestureClassifications();

	public GestureEvent(TrackValue value, SignStreamSegmentPanel segmentPanel) {
		super(value, segmentPanel);
	}

	public GestureEvent(SS3Item item, SignStreamSegmentPanel segmentPanel) {
		super(item, segmentPanel);
	}

	public GestureEvent(SignStreamSegmentPanel segmentPanel) {
		super(segmentPanel);
	}

	public GestureClassifications getGestureClassifications() {
		return classifications;
	}

	public void setClassifications(GestureClassifications classifications) {
		this.classifications = classifications;
	}

	public void setStartTimeFinilized(boolean isFinilized) {
		this.startTimeFinilized = isFinilized;
	}

	public void setEndTimeFinalized(boolean isFinilized) {
		this.endTimeFinilized = isFinilized;
	}

	public boolean isStartTimeFinilized() {
		return startTimeFinilized;
	}

	public boolean isEndTimeFiilized() {
		return endTimeFinilized;
	}

	public int getPreviousEventEndCoord() {
		return prevEventEndCoord;
	}

	public void setPreviousEventEndCoord(int prevEventEndCoord) {
		this.prevEventEndCoord = prevEventEndCoord;
	}

	public void setNextEventStartCoord(int nextEventStartCoord) {
		this.nextEventStartCoord = nextEventStartCoord;
	}

	public int getNextEventStartCoord() {
		return nextEventStartCoord;
	}

	public void setDependentEvent(GestureEvent dependentEvent) {
		this.dependentEvent = dependentEvent;
	}

	public GestureEvent getDependentEvent() {
		return dependentEvent;
	}

	public void removeDependentEvent() {
		this.dependentEvent = null;
	}

	@Override
	public void setText(String text) {
		this.text = text;

		tf.setText(text);

		if (dependentEvent != null)
			dependentEvent.setText(text);
	}

	public JTextField getTextField() {
		return tf;
	}

	@Override
	public boolean unselect() {
		super.unselect();

		if (updatable)
			this.text = tf.getText();

		this.updatable = false;
		return true;
	}

	public boolean isUpdatable() {
		return updatable;
	}

	public void setUpdatable(boolean updatable) {
		this.updatable = updatable;
	}

	@Override
	public void reset() {
		super.reset();
		updatable = false;
	}

	public GestureEvent cloneGestureEvent() {
		return new GestureEvent(getSS3Item(), segmentPanel);
	}
}
