package edu.bu.signstream.grepresentation.fields.gestureField;

import edu.bu.signstream.time.Time;
import edu.bu.signstream.time.TimeUnit;
import edu.bu.signstream.common.util.vo.ss3.db.SS3Item;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class GestureText { //extends  ChainedEvent {
	private String text = "";
	
	private Time startTimeInfo;
	private Time endTimeInfo;
			
	private boolean visible = true;
	private boolean selected = false;
	
	public GestureText(String text, double startCoord, double endCoord) {
		this.text = text;
		
		SignStreamSegmentPanel segmentPanel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();

		// JACK TODO: getCurrentRange(field?)
//      var range = Util.getCurrentRange(field);
//      startTimeInfo = TimeRange.ABSOLUTE.time(TimeUnit.COORDINATE, Math.round(startCoord)).in(range);
//      startTimeInfo = TimeRange.ABSOLUTE.time(TimeUnit.COORDINATE, Math.round(endCoord)).in(range);

		Time startMovieTimeInfo = segmentPanel.getZoomer().getCoordinateTimeConvertor()
				.convertCoordinateToTimeInfo(startCoord);
		Time endMovieTimeInfo = segmentPanel.getZoomer().getCoordinateTimeConvertor()
				.convertCoordinateToTimeInfo(endCoord);
		startTimeInfo = startMovieTimeInfo;
		endTimeInfo = endMovieTimeInfo;
	}

	public GestureText(String text) {
		this.text = text;
	}
	
	public Time getStartTime() {
		return startTimeInfo;
	}
	
	public void setStartTime(double time) {
	    startTimeInfo = SS3Singleton.getVideoTimeRange().time(Math.round(time), TimeUnit.TIMESTAMP);
	}
	
	public Time getEndTime() {
		return endTimeInfo;
	}
	
	public void setEndTime(double time) {
        endTimeInfo = SS3Singleton.getVideoTimeRange().time(Math.round(time), TimeUnit.TIMESTAMP);
	}

	public SS3Item getSS3Item() {
		SS3Item item = new SS3Item(text, startTimeInfo);
		item.setEndTimeInfo(endTimeInfo);
		item.setTextOnly(true);
		return item;		
	}
	
	public void setSelected(boolean selected) {
		this.selected = selected;
	}
	
	public boolean isSelected() {
		return selected;
	}

	public void setVisible(boolean visible) {
		this.visible = visible;
	}
	
	public boolean isVisible() {
		return visible;
	}
	
	public String getText() {
		return text;
	}

	public void setText(String text) {
		this.text = text;
	}

	public double getStartCoord() {
		SignStreamSegmentPanel segmentPanel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();
		return segmentPanel.getZoomer().getCoordinateTimeConvertor().convertTimeInfoToCoordinate(startTimeInfo);
	}

	public void setStartCoord(double startCoord) {
		SignStreamSegmentPanel segmentPanel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();
		Time startMovieTimeInfo = segmentPanel.getZoomer().getCoordinateTimeConvertor().convertCoordinateToTimeInfo(
				startCoord);
		startTimeInfo = startMovieTimeInfo;
		
		if(getEndCoord() < startCoord) {
			endTimeInfo = startMovieTimeInfo;
		}
	}

	public double getEndCoord() {
		SignStreamSegmentPanel segmentPanel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();
		return segmentPanel.getZoomer().getCoordinateTimeConvertor().convertTimeInfoToCoordinate(endTimeInfo);
	}

	public void setEndCoord(double endCoord) {
		SignStreamSegmentPanel segmentPanel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();
		Time endMovieTimeInfo = segmentPanel.getZoomer().getCoordinateTimeConvertor().convertCoordinateToTimeInfo(
				endCoord);
		endTimeInfo = endMovieTimeInfo;
	}
	
	@Override
	public String toString() {
		return text;
	}
}