package edu.bu.signstream.grepresentation.fields.gestureField.dialog;

import java.util.ArrayList;

import edu.bu.signstream.grepresentation.fields.gestureField.dialog.handShapes.OrientationImage;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.HandShapeImage;

public class GestureHandShapeBean {

	private char type;

    private boolean isRightHandSelected = true;

    private boolean updated = false;

	private ArrayList<HandShapeImage> selectedDomHandShapeImages = new ArrayList<HandShapeImage>();
	private ArrayList<HandShapeImage> selectedNdomHandShapeImages = new ArrayList<HandShapeImage>();
	private ArrayList<OrientationImage> selectedDomOrientationImages = new ArrayList<>();
	private ArrayList<OrientationImage> selectedNdomOrientationImages = new ArrayList<>();

    public void setUpdated(boolean updated) {
        this.updated = updated;
    }

    public boolean isUpdated() {
        return updated;
    }

    public void clearNdomHandShapeImages() {
        selectedNdomHandShapeImages.clear();
    }

    public void clearDomHandShapeImages() {
        selectedDomHandShapeImages.clear();
    }
    
    public void clearDomOrientationImages() {
    	selectedDomOrientationImages.clear();
    }
    
    public void clearNdomOrientationImages() {
    	selectedNdomOrientationImages.clear();
    }

    public void setRightHandSelected(boolean isRightHandSelected) {
        this.isRightHandSelected = isRightHandSelected;
    }

	/**
	 * @return
	 */
	public ArrayList<HandShapeImage> getSelectedNdomHandShapeImages() {
		return selectedNdomHandShapeImages;
	}

	/**
	 * @return
	 */
	public ArrayList<HandShapeImage> getSelectedDomHandShapeImages() {
		return selectedDomHandShapeImages;
	}
	
	public ArrayList<OrientationImage> getSelectedDomOrientationImages() {
		return selectedDomOrientationImages;
	}
	
	public ArrayList<OrientationImage> getSelectedNdomOrientationImages() {
		return selectedNdomOrientationImages;
	}

	/**
	 * @return
	 */
	public char getType() {
		return type;
	}

	/**
	 * @param list
	 */
	public void setSelectedNdomHandShapeImages(ArrayList<HandShapeImage> list) {
		clearNdomHandShapeImages();
		selectedNdomHandShapeImages.addAll(list);
	}

	/**
	 * @param list
	 */
	public void setSelectedDomHandShapeImages(ArrayList<HandShapeImage> list) {
		clearDomHandShapeImages();
		selectedDomHandShapeImages.addAll(list);
	}
	
	public void setSelectedNdomOrientationImages(ArrayList<OrientationImage> list) {
		clearNdomOrientationImages();
		selectedNdomOrientationImages.addAll(list);
	}

	/**
	 * @param list
	 */
	public void setSelectedDomOrientationImages(ArrayList<OrientationImage> list) {
		clearDomOrientationImages();
		selectedDomOrientationImages.addAll(list);
	}

	/**
	 * @param c
	 */
	public void setType(char c) {
		type = c;
	}
}
