package edu.bu.signstream.grepresentation.fields.gestureField.dialog;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ArrayList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.swing.*;
import javax.swing.border.EmptyBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import edu.bu.signstream.common.util.ErrorMessages;
import edu.bu.signstream.common.util.Util;
import edu.bu.signstream.time.Bound;
import edu.bu.signstream.time.Time;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3Field;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3FieldValue;
import edu.bu.signstream.common.util.vo.ss3.db.*;
import edu.bu.signstream.time.TimeUnit;
import edu.bu.signstream.grepresentation.fields.*;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.apexField.ApexChainedApexEventsEntity;
import edu.bu.signstream.grepresentation.fields.apexField.ApexFieldWrapper;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureFieldWrapper;
import edu.bu.signstream.grepresentation.fields.gestureField.handshapes.GestureHandShapeEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.handshapes.GestureHandShapeEvent;
import edu.bu.signstream.grepresentation.fields.gestureField.handshapes.GestureHandShapeFieldWrapper;
import edu.bu.signstream.grepresentation.fields.gestureField.dialog.handShapes.OrientationImage;
import edu.bu.signstream.grepresentation.fields.gestureField.domNdomField.GestureDomNdomHandField;
import edu.bu.signstream.grepresentation.fields.gestureField.domNdomField.GestureDomNdomHandFieldWrapper;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.handshapeTypes.DomNdomHandshapesType;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.handshapeTypes.StartEndHandshapesType;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.locations.LocationInfo;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.locations.LocationType;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureEvent;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureEventsEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureClassifications;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureField;
import edu.bu.signstream.grepresentation.fields.gestureField.locationField.GestureLocationEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.locationField.GestureLocationEvent;
import edu.bu.signstream.grepresentation.fields.gestureField.locationField.GestureLocationEventsCollection;
import edu.bu.signstream.grepresentation.fields.gestureField.locationField.GestureLocationFieldWrapper;
import edu.bu.signstream.grepresentation.fields.gestureField.locationField.GestureLocationType;
import edu.bu.signstream.grepresentation.fields.gestureField.orientationField.GestureOrientationEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.orientationField.GestureOrientationEvent;
import edu.bu.signstream.grepresentation.fields.gestureField.orientationField.GestureOrientationFieldWrapper;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.HandShapeImage;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureChainedEvent;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureChainedEventsCollection;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureChainedEventsEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureEntityProperties;
import edu.bu.signstream.grepresentation.fields.nonManualField.NonManualField;
import edu.bu.signstream.grepresentation.fields.nonManualField.mouseDelegateListeners.AccessSignBankActionListener;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationEventsEntity;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationField;
import edu.bu.signstream.grepresentation.fields.gestureField.signTypeField.*;
import edu.bu.signstream.grepresentation.listener.WeakActionListener;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.GestureNRelatedView;
import edu.bu.signstream.grepresentation.view.LabelObject;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.grepresentation.view.mediaControl.MediaToolBar;
import edu.bu.signstream.grepresentation.view.mediaControl.MediaToolbarCommons;
import edu.bu.signstream.grepresentation.view.signbank.SignBankOccurrence;
import edu.bu.signstream.grepresentation.view.signbank.SignBankVariant;
import edu.bu.signstream.ui.ButtonPanel;
import edu.bu.signstream.ui.panels.signbank.SignBankDialog;

public class GestureInfoPanel extends JPanel implements ItemListener, ActionListener {

	private static final long serialVersionUID = 1L;

	private final JDialog parent;

	private SignBankDialog signBankDialog = null;

	private JTabbedPane tabbedPane;

	private GestureFieldWrapper wrapper = null;
	private GestureHandShapePanel hshPanel = null;
	
	private GestureTypePanel gstPanel = null;

	private final JLabel primaryEntryLb = new JLabel("Primary Entry");
	private final JTextField primaryEntryField = new JTextField();

	private final JLabel gestureLb = new JLabel("Label (Optional)");
	private final JTextField gestureLbField = new JTextField();
	private final JButton searchSignBank = new JButton("Search Sign Bank");
	private final JCheckBox incompleteCheckbox = new JCheckBox("Incomplete");
//	private final JCheckBox showUniqueNumberCheckbox = new JCheckBox("Show Unique Number");
	private final JCheckBox showAllUniqueNumbersCheckbox = new JCheckBox("Show All Unique Numbers");
//	private final JCheckBox defaultShowUniqueNumbersCheckbox = new JCheckBox("Default Show Unique Numbers");
	
	private final JLabel uniqueNumberLb = new JLabel("Gesture Number");
	private final JTextField uniqueNumberField = new JTextField(5);

	private final JButton addNewSign = new JButton("Add To Sign Bank");

	private final JLabel domHandLbl = new JLabel("Dominant Hand");
	private final JRadioButton domHandR = new JRadioButton("Right");
	private final JRadioButton domHandL = new JRadioButton("Left");

	private final JButton enter = new JButton("Enter");
	private final JButton cancel = new JButton("Cancel");
	private final JButton bypass = new JButton("Bypass Sign Bank Check");

	private final int ENTER_BYPASS = -1;
	private final int ENTER = 0;
	private final int CANCEL = 1;

	private final int SIGN_BANK = 8;
	private final int ADD_NEW = 9;

	public static final int TAB_HANDSHAPES = 0;
	public static final int TAB_LOCATION = 1;

	private GestureNRelatedView view = null;

	private GestureHandShapePreprocessor processor = null;
	private GestureHandShapeFormBean hshFormBean = null;

	private final LoadedProperties loadedProperties = new LoadedProperties();

	private AccessSignBankActionListener accessSignBankListener = null;

	private GestureEventsEntity currentGestureEntity;
	private boolean currentPartipantRightHanded;
	private SS3GlossWindowSegment currentGlossWindowSegment;

	private String dominantHand;

	public GestureInfoPanel(GestureFieldWrapper wrapper, GestureNRelatedView view, JDialog parent) {
		this.wrapper = wrapper;
		this.view = view;
		this.parent = parent;
		this.processor = new GestureHandShapePreprocessor(view.getFieldWrappersCollection());

		enter.setActionCommand("" + ENTER);
		cancel.setActionCommand("" + CANCEL);
		bypass.setActionCommand("" + ENTER_BYPASS);
		addGestureFieldDocumentListener();

		enter.addActionListener(new WeakActionListener(this, enter));
		cancel.addActionListener(new WeakActionListener(this, cancel));
		bypass.addActionListener(new WeakActionListener(this, bypass));

//		searchSignBank.addActionListener(this);
//		searchSignBank.setActionCommand("" + SIGN_BANK);

//		addNewSign.addActionListener(this);
//		addNewSign.setActionCommand("" + ADD_NEW);

		ButtonGroup domHandGrp = new ButtonGroup();
		domHandGrp.add(domHandR);
		domHandGrp.add(domHandL);

		domHandR.setEnabled(false);
		domHandL.setEnabled(false);

		update(wrapper, view);


		initUI();
	}

	private void addGestureFieldDocumentListener() {
		gestureLbField.getDocument().addDocumentListener(new DocumentListener() {
			@Override
			public void insertUpdate(DocumentEvent e) {
				changed();
			}
			@Override
			public void removeUpdate(DocumentEvent e) {
				changed();
			}
			@Override
			public void changedUpdate(DocumentEvent e) {
			}

			public void changed() {
//				if (variantField.getText().trim().isEmpty())
//					enter.setEnabled(false);
//				else
//					enter.setEnabled(true);
			}
		});
	}

	public void showTab(int tabNum) {
		if (tabbedPane != null) {
			tabbedPane.setSelectedIndex(tabNum);
		}
	}

	private void populateHandshapeFormBean(GestureEventsEntity entity) {
		// retrieve selected handshapes for right and left hands
		GestureHandShapeEntity hshEntity1 = entity.getDependentHandShapeEntity();
		GestureOrientationEntity oEntity1 = entity.getDependentOrientationEntity();
		// 1000, 2000
		SS3CodingScheme dbScheme = entity.getSignStreamSegmentPanel().getSS3Database().getSS3CodingScheme();

		ArrayList<HandShapeImage> selectedHandImagesRight = new ArrayList<HandShapeImage>();
		ArrayList<HandShapeImage> selectedHandImagesLeft = new ArrayList<HandShapeImage>();
		ArrayList<OrientationImage> selectedOrientationImagesRight = new ArrayList<OrientationImage>();
		ArrayList<OrientationImage> selectedOrientationImagesLeft = new ArrayList<OrientationImage>();

		if (hshEntity1 != null) {
			String fID = hshEntity1.getField().getFieldID();
			SS3Field field = dbScheme.getField(fID);
			ArrayList<GestureHandShapeEvent> hShapes = hshEntity1.getGestureHandShapeEvents();

			for (GestureHandShapeEvent event : hShapes) {
				SS3FieldValue value = field.getFieldValue(event.getID());
				HandShapeImage image = new HandShapeImage(value, dbScheme);
				if (currentPartipantRightHanded) {
					selectedHandImagesRight.add(image);
				} else {
					selectedHandImagesLeft.add(image);
				}
			}
		}
		
		if (oEntity1 != null) {
			String fID = oEntity1.getField().getFieldID();
			SS3Field field = dbScheme.getField(fID);
			ArrayList<GestureOrientationEvent> hShapes = oEntity1.getGestureOrientationEvents();

			for (GestureOrientationEvent event : hShapes) {
				SS3FieldValue value = field.getFieldValue(event.getID());
				OrientationImage image = new OrientationImage(value, dbScheme);
				if (currentPartipantRightHanded) {
					selectedOrientationImagesRight.add(image);
				} else {
					selectedOrientationImagesLeft.add(image);
				}
			}
		}

		GestureEventsEntity ndEntity = entity.getDependentGestureEntity();

		if (ndEntity != null && ndEntity.getDependentHandShapeEntity() != null) {
			GestureHandShapeEntity hshEntity2 = ndEntity.getDependentHandShapeEntity();
			String ndfID = hshEntity2.getField().getFieldID();

			SS3Field ndfield = dbScheme.getField(ndfID);
			ArrayList<GestureHandShapeEvent> ndHShapes = hshEntity2.getGestureHandShapeEvents();

			for (GestureHandShapeEvent event : ndHShapes) {
				SS3FieldValue value = ndfield.getFieldValue(event.getID());
				HandShapeImage image = new HandShapeImage(value, dbScheme);
				if (currentPartipantRightHanded) {
					selectedHandImagesLeft.add(image);
				} else {
					selectedHandImagesRight.add(image);
				}
			}
			
			GestureOrientationEntity oEntity2 = ndEntity.getDependentOrientationEntity();
			if (oEntity2 != null) {
				String ndofID = oEntity2.getField().getFieldID();

				SS3Field ndofield = dbScheme.getField(ndofID);
				ArrayList<GestureOrientationEvent> ndoShapes = oEntity2.getGestureOrientationEvents();

				for (GestureOrientationEvent event : ndoShapes) {
					SS3FieldValue value = ndofield.getFieldValue(event.getID());
					OrientationImage image = new OrientationImage(value, dbScheme);
					if (currentPartipantRightHanded) {
						selectedOrientationImagesLeft.add(image);
					} else {
						selectedOrientationImagesRight.add(image);
					}
				}
			}
		}

		if (wrapper.getGestureField().getFieldID().equals(Util.DOM_GESTURE_FIELD_ID)) {
			if (isDominantHandRight()) {
				hshFormBean.setSelectedDomHandShapeImages(selectedHandImagesRight);
				hshFormBean.setSelectedNdomHandShapeImages(selectedHandImagesLeft);
				hshFormBean.setSelectedDomOrientationImages(selectedOrientationImagesRight);
				hshFormBean.setSelectedNdomOrientationImages(selectedOrientationImagesLeft);
			} else {
				hshFormBean.setSelectedDomHandShapeImages(selectedHandImagesLeft);
				hshFormBean.setSelectedNdomHandShapeImages(selectedHandImagesRight);
				hshFormBean.setSelectedDomOrientationImages(selectedOrientationImagesLeft);
				hshFormBean.setSelectedNdomOrientationImages(selectedOrientationImagesRight);
			}
		} else {
			if (isDominantHandRight()) {
				hshFormBean.setSelectedDomHandShapeImages(selectedHandImagesLeft);
				hshFormBean.setSelectedNdomHandShapeImages(selectedHandImagesRight);
				hshFormBean.setSelectedDomOrientationImages(selectedOrientationImagesLeft);
				hshFormBean.setSelectedNdomOrientationImages(selectedOrientationImagesRight);
			} else {
				hshFormBean.setSelectedDomHandShapeImages(selectedHandImagesRight);
				hshFormBean.setSelectedNdomHandShapeImages(selectedHandImagesLeft);
				hshFormBean.setSelectedDomOrientationImages(selectedOrientationImagesRight);
				hshFormBean.setSelectedNdomOrientationImages(selectedOrientationImagesLeft);
			}
		}
	}

	protected void update(GestureFieldWrapper wrapper, GestureNRelatedView gestView) {

		this.wrapper = wrapper;
		this.view = gestView;

		loadedProperties.reset();

		EventsEntity ent = SS3Singleton.getMediaToolBar(null).selectedEntity();

		if (ent == null)
			return;

		currentGestureEntity = (GestureEventsEntity) ent;
		PresentationField parentField = currentGestureEntity.getField().getParentField();
		currentGlossWindowSegment = parentField.getSS3GlossWindowSegment();
		currentPartipantRightHanded = currentGlossWindowSegment.getParticipant() == null 
				|| currentGlossWindowSegment.getParticipant().isDominantHandRight();

		dominantHand = currentPartipantRightHanded ? "R" : "L";
		if (currentPartipantRightHanded) {
			domHandR.setSelected(true);
		} else {
			domHandL.setSelected(true);
		}

		hshFormBean = new GestureHandShapeFormBean();
		processor.setRightHandDominant(currentPartipantRightHanded);
		processor.populateFormBean(hshFormBean);
		hshFormBean.setGestFieldWrapper(wrapper);

		populateHandshapeFormBean(currentGestureEntity);

		GestureChainedEvent event = currentGestureEntity.getGestureChainedEvent();

		gestureLbField.setText(event.getText().trim());
		
		incompleteCheckbox.setSelected(currentGestureEntity.getIncompleteGesture());
		
//		showUniqueNumberCheckbox.setSelected(currentGestureEntity.getShowUniqueNumber());
		
		showAllUniqueNumbersCheckbox.setSelected(currentGlossWindowSegment.getShowAllGestureCounters());
		
//		defaultShowUniqueNumbersCheckbox.setSelected(currentGlossWindowSegment.getDefaultShowGestureCounters());

		uniqueNumberField.setText(currentGestureEntity.getUniqueNumber().trim());
		
		primaryEntryField.setText(null);

		String fieldID = currentGestureEntity.getField().getFieldID();

		GestureEntityProperties properties = currentGestureEntity.getGestureEntityProperties();

		ArrayList<HandShapeImage> rhList = new ArrayList<HandShapeImage>(hshFormBean.getSelectedDomHandShapeImages());
		ArrayList<HandShapeImage> lhList = new ArrayList<HandShapeImage>(hshFormBean.getSelectedNdomHandShapeImages());

		if((rhList.size() > 0 && lhList.size() == 0) || (rhList.size() == 0 && lhList.size() > 0)) {
			properties.setTwoHanded(false);
		}

		if (currentPartipantRightHanded) {
			properties.setDominamtHand("R");
		} else {
			properties.setDominamtHand("L");
		}

		if(hshPanel == null) {
			this.hshPanel = new GestureHandShapePanel(this);
		}

		if (gstPanel == null) {
			this.gstPanel = new GestureTypePanel(this);
		}
		
		if (fieldID.equalsIgnoreCase(Util.DOM_GESTURE_FIELD_ID)) {
			// if dominant hand right (right handed signer), check right hand;
			// otherwise check left
			if (currentPartipantRightHanded) {
				properties.setOnehandedSignHand("R");
			} else {
				properties.setOnehandedSignHand("L");
			}
		} else {
			if (currentPartipantRightHanded) {
				properties.setOnehandedSignHand("L");
			} else {
				properties.setOnehandedSignHand("R");
			}
		}

		if (currentGestureEntity.getStartTimeInfo().equals(currentGestureEntity.getEndTimeInfo())) {
			properties.setOneFrameGesture(true);
		} else {
			properties.setOneFrameGesture(false);
		}

		FieldWrappersCollection collection = view.getFieldWrappersCollection();
		GestureFieldWrapper ndWrp;

		if (properties.getSignType() == null) {

			boolean rhEmpty = rhList.isEmpty();
			boolean lhEmpty = lhList.isEmpty();

			if (rhEmpty && !lhEmpty) {
				properties.setTwoHanded(false);
				boolean rIdentical = isIdenticalStartEndHandshapes(lhList);

				if (rIdentical) {
					properties
							.setStartEndHandshape(GestureEntityProperties.SAME_START_END_HANDSHAPE);
				} else {
					properties
							.setStartEndHandshape(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
				}

			} else {
				if (!rhEmpty && lhEmpty) {
					properties.setTwoHanded(false);
					boolean lIdentical = isIdenticalStartEndHandshapes(rhList);

					if (lIdentical) {
						properties
								.setStartEndHandshape(GestureEntityProperties.SAME_START_END_HANDSHAPE);
					} else {
						properties
								.setStartEndHandshape(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
					}
				} else if (!rhEmpty && !lhEmpty) {
					properties.setTwoHanded(true);

					boolean isIdenticalDomNdom = isIdenticalHandshapes(rhList, lhList);

					if (isIdenticalDomNdom) {
						properties.setTwoHandedHandshapesClassification(GestureEntityProperties.SAME_HANDSHAPES_DOM_NDOM);
						boolean lIdentical = isIdenticalStartEndHandshapes(rhList);

						if (lIdentical) {
							properties.setStartEndHandshape(GestureEntityProperties.SAME_START_END_HANDSHAPE);
						} else {
							properties.setStartEndHandshape(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
						}
					} else {
						properties.setTwoHandedHandshapesClassification(GestureEntityProperties.DIFFERENT_HANDSHAPES_DOM_NDOM);

						if (isIdenticalStartEndHandshapes(lhList)) {
							properties
									.setStartEndHandshapeNdomHand(GestureEntityProperties.SAME_START_END_HANDSHAPE);
						} else {
							properties
									.setStartEndHandshapeNdomHand(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
						}

						if (isIdenticalStartEndHandshapes(rhList)) {
							properties
									.setStartEndHandshapeDomHand(GestureEntityProperties.SAME_START_END_HANDSHAPE);
						} else {
							properties
									.setStartEndHandshapeDomHand(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
						}
					}

					properties.setTwoHandedEnabled(true);

					String gest = currentGestureEntity.getText();

					String handednessPattern = "(!)?(neu:|([a-z_1-3][p:]))?((.)([12][h])(.))(alt.)?(.*)?";
					Pattern.compile(handednessPattern);
					Pattern handednessR = Pattern.compile(handednessPattern);
					Matcher handednessMatcher = handednessR.matcher(gest);

					// handedness
					if (handednessMatcher.find()) {

						String oneHandedPattern = "(!)?(neu:)?((1h)){1}(.*)?";
						Pattern oneHandedR = Pattern.compile(oneHandedPattern);
						Matcher oneHandedMatcher = oneHandedR.matcher(gest);

						if (oneHandedMatcher.find()) {
							properties.setTwoHanded(false);

						} else {
							properties.setTwoHanded(true);

							String twoHandedAltPattern = "(!)?(neu:)?((2h).alt)(.*)?";
							Pattern twoHandedAltR = Pattern
									.compile(twoHandedAltPattern);
							Matcher twoHandedAltMatcher = twoHandedAltR
									.matcher(gest);

							if (twoHandedAltMatcher.find()) {
								properties
										.setTwoHandedHandshapesClassification(GestureEntityProperties.ALTERNATING_SAME_HANDSHAPES_DOM_NDOM);
							}
						}
					}
				}
			}

			String gest = currentGestureEntity.getText();
			// name sign
			String nameSignPattern = "(!)?(neu:|([a-z_1-3][p:]))?([(1h)][(2h)][(2h)alt.])?(ns-){1}(.*)?";
			Pattern nameSignR = Pattern.compile(nameSignPattern);
			Matcher nameSignMatcher = nameSignR.matcher(gest);

			if (nameSignMatcher.find()) {
				hshPanel.setNameSign(true);
			} else {
				hshPanel.setNameSign(false);
			}

			String fingerspelledPattern = "(!)?(neu:|([a-z_1-3][p:]))?([(1h)][(2h)][(2h)alt.])?(fs-){1}(.*)?";
			Pattern fingerspelledR = Pattern.compile(fingerspelledPattern);
			Matcher fingerspelledMatcher = fingerspelledR.matcher(gest);

			if (fingerspelledMatcher.find()) {
				hshPanel.setFingerspelled(true);
			} else {
				// loan sign
				String loanSignPattern = "(!)?(neu:|([a-z_1-3][p:]))?([(1h)][(2h)][(2h)alt.])?(#){1}(.*)?";
				Pattern loanSignR = Pattern.compile(loanSignPattern);
				Matcher loanSignMatcher = loanSignR.matcher(gest);

				if (loanSignMatcher.find()) {
					hshPanel.setLoan(true);
				} else {
					String classifierPattern = "(!)?(neu:|([a-z_1-3][p:]))?([(1h)][(2h)][(2h)alt.])?(ns-)?((CL)|(DCL)|(LCL)|(SCL)|(BCL)|(BPCL)|(PCL)|(ICL)){1}([-_:].*)?$";
					Pattern classifierR = Pattern.compile(classifierPattern);
					Matcher classifierMatcher = classifierR.matcher(gest);

					if (classifierMatcher.find()) {
						hshPanel.setClassifier(true);
					} else {

						String gesturePattern = "(!)?(neu:|([a-z_1-3][p:]))?([(1h)][(2h)][(2h)alt.])?(ns-)?((\"){1}(.){1,}(\"){1})(.*)?";
						Pattern gestureR = Pattern.compile(gesturePattern);
						Matcher gestureMatcher = gestureR.matcher(gest);

						if (gestureMatcher.find()) {
							hshPanel.setGesture(true);
						} else {
							hshPanel.setLexical(true);

							if (fieldID.equalsIgnoreCase(Util.DOM_GESTURE_FIELD_ID)) {
								ndWrp = (GestureFieldWrapper) collection
										.getFieldWrapperWithFieldID(Util.NDOM_GESTURE_FIELD_ID);
							} else {
								ndWrp = (GestureFieldWrapper) collection
										.getFieldWrapperWithFieldID(Util.DOM_GESTURE_FIELD_ID);
							}
						}
					}
				}
			}
		} else {
			hshPanel.setFingerspelled(properties.isFingerspelled());
			hshPanel.setLoan(properties.isLoan());
			hshPanel.setNumber(properties.isNumber());
			hshPanel.setLexical(properties.isLexical());
			hshPanel.setClassifier(properties.isClassifier());
			hshPanel.setGesture(properties.isGesture());
			hshPanel.setNameSign(properties.isNameSign());

			if (fieldID.equalsIgnoreCase(Util.DOM_GESTURE_FIELD_ID)) {
				ndWrp = (GestureFieldWrapper) collection
						.getFieldWrapperWithFieldID(Util.NDOM_GESTURE_FIELD_ID);
			} else {
				ndWrp = (GestureFieldWrapper) collection
						.getFieldWrapperWithFieldID(Util.DOM_GESTURE_FIELD_ID);
			}

			NonManualField ndField = (NonManualField) ndWrp.getField();
			boolean isPossibleToAddEvent = ndField.isIntervalEmpty(currentGestureEntity.interval());

			if (!isPossibleToAddEvent) {
				String correspondingID = currentGestureEntity.getCorrespondingGestureEntityID();
				EventsEntity correspondingEntity = ndField
						.getEntity(correspondingID);
				if (correspondingEntity != null) {
					isPossibleToAddEvent = true;
				}
			}

			properties.setTwoHandedEnabled(isPossibleToAddEvent);

		}

		hshFormBean.setGestureEntityProperties(properties);

		if (this.hshPanel != null) {
			this.hshPanel.update();
		}
		if (this.gstPanel != null) {
			this.gstPanel.update();
		}

		checkSignTypeAndUpdateSignBankFunctionality();

		// populate LoadedProperties object 
		loadedProperties.setGestText(gestureLbField.getText().trim());
		loadedProperties.setFingerspelled(hshPanel.isFingerspelled());
		loadedProperties.setLoan(hshPanel.isLoan());
		loadedProperties.setNumber(hshPanel.isNumber());
		loadedProperties.setLexical(hshPanel.isLexical());
		loadedProperties.setClassifier(hshPanel.isClassifier());
		loadedProperties.setGesture(hshPanel.isGesture());
		loadedProperties.setNameSign(hshPanel.isNameSign());

		loadedProperties.setTwoHanded(properties.isTwoHanded());
		loadedProperties.setMarkedNumberOfHands(properties.isMarkedNumberOfHands());
		loadedProperties.setPassiveBaseArm(properties.isPassiveBaseArm());
		loadedProperties.setOneFrameGesture(properties.isOneFrameGesture());

		if(hshPanel != null){
			loadedProperties.setSameDifStartEndHandshapes(hshPanel.getSelectedSameDifStartEndHandshapes());
			loadedProperties.setSameDIfferentDomNdomHandshapes(hshPanel.getSelectedSameDifDomNdomHandshapes());
			loadedProperties.setSameDifStartEndHandshapesL(hshPanel.getSelectedSameDifStartEndHandshapesNdom());
			loadedProperties.setSameDifStartEndHandshapesR(hshPanel.getSelectedSameDifStartEndHandshapesDom());
		}

		loadedProperties.setRightHandSelectedHandshapes(hshFormBean.getSelectedDomHandShapeImages());
		loadedProperties.setLeftHandSelectedHandshapes(hshFormBean.getSelectedNdomHandShapeImages());
		
		loadedProperties.setRightHandSelectedOrientations(hshFormBean.getSelectedDomOrientationImages());
		loadedProperties.setLeftHandSelectedOrientations(hshFormBean.getSelectedNdomOrientationImages());
		
		loadedProperties.setGestureTypeEntity(currentGestureEntity.getDependentGestureTypeEntity());
		


		if (tabbedPane != null) {
			showTab(TAB_HANDSHAPES);
		}

		revalidate();
		parent.pack();
	}

	public GestureHandShapeFormBean getGestureHandShapeFormBean() {
		return hshFormBean;
	}

	private boolean isIdenticalHandshapes(ArrayList<HandShapeImage> rhList,
										  ArrayList<HandShapeImage> lhList) {
		if (rhList.size() == lhList.size()) {
			for (int i = 0; i < rhList.size(); i++) {
				HandShapeImage rImg = rhList.get(i);
				HandShapeImage lImg = lhList.get(i);
				String rId = rImg.getSS3FieldValue().getId();
				String lId = lImg.getSS3FieldValue().getId();

				if (!rId.equalsIgnoreCase(lId)) {
					return false;
				}
			}
			return true;
		} else {
			return false;
		}
	}

	private boolean isIdenticalStartEndHandshapes(ArrayList<HandShapeImage> list) {
		if (list.isEmpty()) {
			return true;
		}

		HandShapeImage fImg = list.get(0);
		HandShapeImage lImg = list.get(list.size() - 1);

		String rId = fImg.getSS3FieldValue().getId();
		String lId = lImg.getSS3FieldValue().getId();

		return rId.equalsIgnoreCase(lId);

	}

	private JPanel createGesturePanel() {
		JPanel panel = new JPanel(new GridBagLayout());

		GridBagConstraints c = new GridBagConstraints();
		Insets zeroInsets = new Insets(0,0,0,0);
		Insets insets = new Insets(0,80,0,0);
//		c.gridx = 0;
//		c.gridy = 0;
//		panel.add(primaryEntryLb, c);

//		c.gridx++;
//		panel.add(primaryEntryField, c);

		c.gridx = 0;
		c.gridy = 0;
		c.anchor = GridBagConstraints.WEST;
		panel.add(gestureLb, c);

		c.gridx++;
		c.weightx = 1;
		c.fill = GridBagConstraints.HORIZONTAL;
		c.insets = insets;
		c.gridwidth = 3;
		panel.add(gestureLbField, c);
		
		c.gridx = 0;
		c.gridy++;
		c.weightx = 0;
		c.fill = GridBagConstraints.NONE;
		c.insets = zeroInsets;
		c.gridwidth =1;
		panel.add(uniqueNumberLb, c);
		
		c.gridx++;
		c.weightx = 1;
		c.gridwidth = 1;
		c.insets = insets;
		panel.add(uniqueNumberField, c);
		
		c.gridx++;
//		c.weightx = 1;
		c.insets = zeroInsets;
		c.gridwidth = 2;
		panel.add(showAllUniqueNumbersCheckbox, c);
		
		c.gridx = 0;
		c.gridy++;
//		c.anchor = GridBagConstraints.CENTER;
//		panel.add(showUniqueNumberCheckbox, c);
//		
//		c.gridx++;
		
//		c.gridx++;
//		panel.add(defaultShowUniqueNumbersCheckbox, c);

		c.gridx += 2;
		c.weightx = 0;
		c.fill = GridBagConstraints.NONE;
		c.gridwidth = 1;
//		panel.add(searchSignBank, c);


		c.gridx = 0;
		c.gridy++;
		panel.add(domHandLbl, c);

		c.gridx++;
		c.insets = insets;
		panel.add(domHandR, c);

		c.gridx++;
		c.insets = new Insets(0, 0, 0, 15);
		c.anchor = GridBagConstraints.CENTER;
		panel.add(domHandL, c);

		c.gridx++;
		c.insets = zeroInsets;
		panel.add(incompleteCheckbox, c);

//		c.gridx++;
//		c.insets = new Insets(0, 0, 0, 0);
//		panel.add(addNewSign, c);

		panel.setBorder(new EmptyBorder(5, 5, 5, 5));
		return panel;
	}

	private JPanel createPosPanel() {
		JPanel panel = new JPanel();

		GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();

		panel.setLayout(gbl);

		gbc.anchor = GridBagConstraints.NORTHWEST;
		gbc.gridwidth = GridBagConstraints.REMAINDER;

		gbc.anchor = GridBagConstraints.NORTH;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0, 0, 10, 0);

		ButtonPanel buttonPanel = new ButtonPanel();
		buttonPanel.add(cancel);
		buttonPanel.add(enter);
//		buttonPanel.add(bypass);

		gbc.anchor = GridBagConstraints.SOUTH;
		gbc.insets = new Insets(15, 0, 0, 0);
		gbc.fill = GridBagConstraints.HORIZONTAL;
		panel.add(buttonPanel, gbc);

		return panel;
	}

	private JPanel createCenterPanel() {
		JPanel panel = new JPanel();

		tabbedPane = new JTabbedPane();
		tabbedPane.addTab("Hands", hshPanel);
		tabbedPane.addTab("Gesture Type", gstPanel);

		tabbedPane.addChangeListener(new ChangeListener() {
			@Override
			public void stateChanged(ChangeEvent e) {
//				int newTabIndex = ((JTabbedPane)e.getSource()).getSelectedIndex();
//				boolean enable = newTabIndex == 0;
//				addNewSign.setEnabled(enable);
//				enter.setEnabled(enable);
			}
		});

		panel.setLayout(new BorderLayout());

		panel.add(tabbedPane, BorderLayout.CENTER);

		return panel;
	}

	private void initUI() {
		JPanel gestPanel = createGesturePanel();
		JPanel posPanel = createPosPanel();
		JPanel cPanel = createCenterPanel();

		setLayout(new BorderLayout(0, 10));
		add(gestPanel, BorderLayout.NORTH);

		Dimension size = new Dimension(600, 500);
		cPanel.setMinimumSize(size);
		cPanel.setPreferredSize(size);
		add(cPanel, BorderLayout.CENTER);

		add(posPanel, BorderLayout.SOUTH);

//		GridBagConstraints gbc = new GridBagConstraints();
//		setLayout(new GridBagLayout());
//
//		gbc.anchor = GridBagConstraints.NORTHWEST;
//		gbc.gridwidth = GridBagConstraints.REMAINDER;
//		gbc.fill = GridBagConstraints.HORIZONTAL;
//		gbc.insets = new Insets(0, 0, 10, 0);
//		add(glsPanel, gbc);
//
//		gbc.anchor = GridBagConstraints.NORTH;
//		gbc.fill = GridBagConstraints.HORIZONTAL;
//		gbc.insets = new Insets(0, 0, 10, 0);
//		add(new JSeparator(), gbc);
//
//		gbc.anchor = GridBagConstraints.NORTHWEST;
//		gbc.gridwidth = GridBagConstraints.REMAINDER;
//		add(cPanel, gbc);
//
//		gbc.anchor = GridBagConstraints.NORTH;
//		gbc.fill = GridBagConstraints.HORIZONTAL;
//		gbc.insets = new Insets(0, 0, 10, 0);
//		add(posPanel, gbc);
	}

	@Override
	public void itemStateChanged(ItemEvent event) {
		removeAll();
		initUI();
		revalidate();
		parent.pack();
	}

	public boolean isChanged() {

		String gestText = gestureLbField.getText().trim();
		if (!gestText.equalsIgnoreCase(loadedProperties.getGestText())) {
			return true;
		}

		if(hshPanel.isTwoHandedSelected() != loadedProperties.isTwoHanded()) {
			return true;
		}

		DomNdomHandshapesType sameDifHandshapes = hshPanel.getSelectedSameDifDomNdomHandshapes();
		StartEndHandshapesType sameDifStartEndHandshapes = hshPanel.getSelectedSameDifStartEndHandshapes();
		StartEndHandshapesType sameDifStartEndHandshapesL = hshPanel.getSelectedSameDifStartEndHandshapesNdom();
		StartEndHandshapesType sameDifStartEndHandshapesR = hshPanel.getSelectedSameDifStartEndHandshapesDom();

		DomNdomHandshapesType loadedSameDifHandshapes = loadedProperties.getSameDIfferentDomNdomHandshapes();
		StartEndHandshapesType loadedSameDifStartEndHandshapes = loadedProperties.getSameDifStartEndHandshapes();
		StartEndHandshapesType loadedSameDifStartEndHandshapesR = loadedProperties.getSameDifStartEndHandshapesR();
		StartEndHandshapesType loadedSameDifStartEndHandshapesL = loadedProperties.getSameDifStartEndHandshapesL();

		
		if(sameDifHandshapes != loadedSameDifHandshapes) {
			return true;
		}

		if(sameDifStartEndHandshapes != loadedSameDifStartEndHandshapes) {
			return true;
		}

		if(sameDifStartEndHandshapesL != loadedSameDifStartEndHandshapesL) {
			return true;
		}

		if(sameDifStartEndHandshapesR != loadedSameDifStartEndHandshapesR) {
			return true;
		}

		ArrayList<HandShapeImage> selLeftHandShapes = hshPanel.getSelectedNdomHandshapesPane().getHandshapes();
		ArrayList<HandShapeImage> selRightHandShapes = hshPanel.getSelectedDomHandshapesPane().getHandshapes();

		ArrayList<HandShapeImage> selLeftHandShapes1 = loadedProperties.getLeftHandSelectedHandshapes();
		ArrayList<HandShapeImage> selRightHandShapes1 = loadedProperties.getRightHandSelectedHandshapes();
		
		ArrayList<OrientationImage> selLeftOrientations = hshPanel.getSelectedNdomHandshapesPane().getOrientations();
		ArrayList<OrientationImage> selRightOrientations = hshPanel.getSelectedDomHandshapesPane().getOrientations();
		
		ArrayList<OrientationImage> selLeftOrientations1 = loadedProperties.getLeftHandSelectedOrientations();
		ArrayList<OrientationImage> selRightOrientations1 = loadedProperties.getRightHandSelectedOrientations();
		

		if(selLeftHandShapes.isEmpty() != selLeftHandShapes1.isEmpty()) {
			return true;
		}

		if(selRightHandShapes.isEmpty() != selRightHandShapes1.isEmpty()) {
			return true;
		}

		if(selLeftOrientations.isEmpty() != selLeftOrientations1.isEmpty()) {
			return true;
		}

		if(selRightOrientations.isEmpty() != selRightOrientations1.isEmpty()) {
			return true;
		}

		int rHsSize1 = selRightHandShapes1.size();
		int rHsSize = selRightHandShapes.size();

		if(rHsSize1 != rHsSize) {
			if(rHsSize1 == 2 && rHsSize == 1) {
				HandShapeImage rHandShape11 = selRightHandShapes1.get(0);
				HandShapeImage rHandShape12 = selRightHandShapes1.get(1);
				HandShapeImage rHandShape = selRightHandShapes.get(0);
				String rHandShape11ID = rHandShape11.getSS3FieldValue().getId();
				String rHandShape12ID = rHandShape12.getSS3FieldValue().getId();
				if(!rHandShape11ID.equalsIgnoreCase(rHandShape12ID)) {
					return true;
				}
				String rHandShapeID = rHandShape.getSS3FieldValue().getId();
				if(!rHandShape11ID.equalsIgnoreCase(rHandShapeID)) {
					return true;
				}
			} else {
				return true;
			}
		}

		int i = 0 ;
		for(HandShapeImage rHandShape : selRightHandShapes) {
			HandShapeImage rHandShape1 = selRightHandShapes1.get(i);
			String rhShapeID = rHandShape.getSS3FieldValue().getId();
			String rhShapeID1 = rHandShape1.getSS3FieldValue().getId();
			if(!rhShapeID.equalsIgnoreCase(rhShapeID1)) {
				return true;
			}
			i++;
		}

		int lHsSize1 = selLeftHandShapes1.size();
		int lHsSize = selLeftHandShapes.size();

		if(lHsSize1 != lHsSize) {
			if(lHsSize1 == 2 && lHsSize == 1) {
				HandShapeImage lHandShape11 = selLeftHandShapes1.get(0);
				HandShapeImage lHandShape12 = selLeftHandShapes1.get(1);
				HandShapeImage lHandShape = selLeftHandShapes.get(0);
				String lHandShape11ID = lHandShape11.getSS3FieldValue().getId();
				String lHandShape12ID = lHandShape12.getSS3FieldValue().getId();
				if(!lHandShape11ID.equalsIgnoreCase(lHandShape12ID)) {
					return true;
				}
				String lHandShapeID = lHandShape.getSS3FieldValue().getId();
				if(!lHandShape11ID.equalsIgnoreCase(lHandShapeID)) {
					return true;
				}
			} else {
				return true;
			}
		}

		int j = 0 ;
		for(HandShapeImage lHandShape : selLeftHandShapes) {
			HandShapeImage lHandShape1 = selLeftHandShapes1.get(j);
			String lhShapeID = lHandShape.getSS3FieldValue().getId();
			String lhShapeID1 = lHandShape1.getSS3FieldValue().getId();
			if(!lhShapeID.equalsIgnoreCase(lhShapeID1)) {
				return true;
			}
			j++;
		}
		
		int rOSize1 = selRightOrientations1.size();
		int rOSize = selRightOrientations.size();

		if(rOSize1 != rOSize) {
			if(rOSize1 == 2 && rOSize == 1) {
				OrientationImage rOrientation11 = selRightOrientations1.get(0);
				OrientationImage rOrientation12 = selRightOrientations1.get(1);
				OrientationImage rOrientation = selRightOrientations.get(0);
				String rOrientation11ID = rOrientation11.getSS3FieldValue().getId();
				String rOrientation12ID = rOrientation12.getSS3FieldValue().getId();
				if(!rOrientation11ID.equalsIgnoreCase(rOrientation12ID)) {
					return true;
				}
				String rOrientationID = rOrientation.getSS3FieldValue().getId();
				if(!rOrientation11ID.equalsIgnoreCase(rOrientationID)) {
					return true;
				}
			} else {
				return true;
			}
		}

		i = 0 ;
		for(OrientationImage rOrientation : selRightOrientations) {
			OrientationImage rOrientation1 = selRightOrientations1.get(i);
			String rhOrientationID = rOrientation.getSS3FieldValue().getId();
			String rhOrientationID1 = rOrientation1.getSS3FieldValue().getId();
			if(!rhOrientationID.equalsIgnoreCase(rhOrientationID1)) {
				return true;
			}
			i++;
		}

		int lOSize1 = selLeftOrientations1.size();
		int lOSize = selLeftOrientations.size();

		if(lOSize1 != lOSize) {
			if(lHsSize1 == 2 && lHsSize == 1) {
				OrientationImage lOrientation11 = selLeftOrientations1.get(0);
				OrientationImage lOrientation12 = selLeftOrientations1.get(1);
				OrientationImage lOrientation = selLeftOrientations.get(0);
				String lOrientation11ID = lOrientation11.getSS3FieldValue().getId();
				String lOrientation12ID = lOrientation12.getSS3FieldValue().getId();
				if(!lOrientation11ID.equalsIgnoreCase(lOrientation12ID)) {
					return true;
				}
				String lOrientationID = lOrientation.getSS3FieldValue().getId();
				if(!lOrientation11ID.equalsIgnoreCase(lOrientationID)) {
					return true;
				}
			} else {
				return true;
			}
		}

		j = 0 ;
		for(OrientationImage lOrientation : selLeftOrientations) {
			OrientationImage lOrientation1 = selLeftOrientations1.get(j);
			String lhOrienationID = lOrientation.getSS3FieldValue().getId();
			String lhOrientationID1 = lOrientation1.getSS3FieldValue().getId();
			if(!lhOrienationID.equalsIgnoreCase(lhOrientationID1)) {
				return true;
			}
			j++;
		}
		
		// GREG TODO: the below won't work as is - need a way to compare pre/post gesture types
		GestureTypeEntity oldGestureTypeEntity = loadedProperties.getGestureTypeEntity();
		GestureTypeEntity currentGestureTypeEntity = currentGestureEntity.getDependentGestureTypeEntity();
		
		if (oldGestureTypeEntity != null) {
			if ( ! oldGestureTypeEntity.equals(currentGestureTypeEntity)) {
				return false;
			}
		}

		return false;
	}

	public boolean saveChanges() {
		boolean success = updateChanges();
		return success;
	}

	public boolean saveChanges(SignBankVariant variant) {
		MediaToolBar mediaToolBar = SS3Singleton.getMediaToolBar(null);
		GestureEventsEntity sEntity = (GestureEventsEntity) mediaToolBar.selectedEntity();

		if (sEntity == null) {
			sEntity = wrapper.getGestureField()
					.getGestureEventsEntityCollection()
					.getSelectedEntity();
		}

		GestureEntityProperties properties = sEntity.getGestureEntityProperties();

		properties.setVerifiedFromSignBank(true);

		// compare against the defaultOccurrence - from which we get the source resource
		SignBankOccurrence defaultOccurrence = variant.getDefaultOccurrence();
		String sourceResource = defaultOccurrence.getSIgnBankResourceFileName();
		properties.setSourceResource(sourceResource);

		String mainGestureID = ""; // variant.getParentMainGesture().getMainGestureID();
		String variantID = variant.getVariantID();
		String occurrenceID = defaultOccurrence.getOccurrenceID();
		properties.setMainGestureID(mainGestureID);
		properties.setVariantID(variantID);
		properties.setOccurrenceID(occurrenceID);

		ArrayList<HandShapeImage> domImages, nondomImages;
		int domImagesSize, nondomImagesSize;

		if (isDominantHandRight()) {
			domImages = hshPanel.getSelectedDomHandshapesPane().getHandshapes();
			nondomImages = hshPanel.getSelectedNdomHandshapesPane().getHandshapes();
		} else {
			domImages = hshPanel.getSelectedNdomHandshapesPane().getHandshapes();
			nondomImages = hshPanel.getSelectedDomHandshapesPane().getHandshapes();
		}
		domImagesSize = domImages.size();
		nondomImagesSize = nondomImages.size();

		String domStartHS = null;
		String nondomStartHS = null;
		String domEndHS = null;
		String nondomEndHS = null;

		if (domImagesSize > 0) {
			domStartHS = domImages.get(0).getSS3FieldValue().getLabel();
			domEndHS = domImages.get(domImagesSize - 1).getSS3FieldValue().getLabel();
		}

		if (nondomImagesSize > 0) {
			nondomStartHS = nondomImages.get(0).getSS3FieldValue().getLabel();
			nondomEndHS = nondomImages.get(nondomImagesSize - 1).getSS3FieldValue().getLabel();
		}

		String occDomStartHS = defaultOccurrence.getDomStartHS();
		String occNondomStartHS = defaultOccurrence.getNondomStartHS();
		String occDomEndHS = defaultOccurrence.getDomEndHS();
		String occNondomEndHS = defaultOccurrence.getNondomEndHS();

		String occLeftRightHS = defaultOccurrence.getLeftRightHS();
		String occStartEndHS = defaultOccurrence.getStartEndHS();
		String occStartEndLeftHS = defaultOccurrence.getStartEndLeftHS();
		String occStartEndRightHS = defaultOccurrence.getStartEndRightHS();

		boolean occTwoHanded = defaultOccurrence.isTwoHanded();
		boolean occMarkedHands = defaultOccurrence.isMarkedHands();
		boolean occPassiveBaseArm = defaultOccurrence.isPassiveBaseArm();

		String occSignType = defaultOccurrence.getSignType();

		boolean differingFromOccurrence = false;

		if (occDomStartHS != null && domStartHS != null && !occDomStartHS.equals(domStartHS))
			differingFromOccurrence = true;
		if (occNondomStartHS != null && nondomStartHS != null && !occNondomStartHS.equals(nondomStartHS))
			differingFromOccurrence = true;
		if (occDomEndHS != null && domEndHS != null && !occDomEndHS.equals(domEndHS))
			differingFromOccurrence = true;
		if (occNondomEndHS != null && nondomEndHS != null && !occNondomEndHS.equals(nondomEndHS))
			differingFromOccurrence = true;
		
		DomNdomHandshapesType domNdomHS = hshPanel.getSelectedSameDifDomNdomHandshapes();
		StartEndHandshapesType startEndHS = hshPanel.getSelectedSameDifStartEndHandshapes();
		StartEndHandshapesType startEndLeftHS = hshPanel.getSelectedSameDifStartEndHandshapesNdom();
		StartEndHandshapesType startEndRightHS = hshPanel.getSelectedSameDifStartEndHandshapesDom();
		
		boolean twoHanded = hshPanel.isTwoHandedSelected();
		boolean markedHands = hshPanel.isMarkedNumberOfHands();
		boolean passiveBaseArm = hshPanel.isPassiveBaseArm();

		String signType = null;
		if (hshPanel.isLexical())
			signType = "LEXICAL";
		if (hshPanel.isFingerspelled())
			signType = "FINGERSPELLED";
		if (hshPanel.isLoan())
			signType = "LOAN";
		if (hshPanel.isNumber())
			signType = "NUMBER";
		if (hshPanel.isClassifier())
			signType = "CLASSIFER";
		if (hshPanel.isGesture())
			signType = "GESTURE";

		if (occLeftRightHS != null) {
			if (occLeftRightHS.equals("SAME") && domNdomHS != DomNdomHandshapesType.SAME) {
				differingFromOccurrence = true;

				if (occStartEndHS != null) {
					if (occStartEndHS.equals("SAME") && startEndHS != StartEndHandshapesType.SAME)
						differingFromOccurrence = true;
					else if (occStartEndHS.equals("DIFFERENT") && startEndHS != StartEndHandshapesType.DIFFERENT)
						differingFromOccurrence = true;
				}
			} else if (occLeftRightHS.equals("DIFFERENT") && domNdomHS != DomNdomHandshapesType.DIFFERENT) {
				differingFromOccurrence = true;

				if (occStartEndLeftHS != null) {
					if (occStartEndLeftHS.equals("SAME") && startEndLeftHS != StartEndHandshapesType.SAME)
						differingFromOccurrence = true;
					else if (occStartEndLeftHS.equals("DIFFERENT") && startEndLeftHS != StartEndHandshapesType.DIFFERENT)
						differingFromOccurrence = true;
				}

				if (occStartEndRightHS != null) {
					if (occStartEndRightHS.equals("SAME") && startEndRightHS != StartEndHandshapesType.SAME)
						differingFromOccurrence = true;
					else if (occStartEndRightHS.equals("DIFFERENT") && startEndRightHS != StartEndHandshapesType.DIFFERENT)
						differingFromOccurrence = true;
				}
			}
		}

		if (occTwoHanded != twoHanded)
			differingFromOccurrence = true;

		if (occMarkedHands != markedHands)
			differingFromOccurrence = true;

		if (occPassiveBaseArm != passiveBaseArm)
			differingFromOccurrence = true;

		if ( !occSignType.equals(signType))
			differingFromOccurrence = true;

		properties.setDifferingFromOccurrence(differingFromOccurrence);

		// we need to set the same sign bank properties on the dependent (other hand) gloss entity
		// because on "file open" both hands (both SS3Track objects) will be need to be parsed separately
		// (there could be one handed signs on the nondominant hand - an unlikely but possible use case)
		GestureEventsEntity dependentEntity = sEntity.getDependentGestureEntity();
		if (dependentEntity != null) {
			GestureEntityProperties dependentProperties = dependentEntity.getGestureEntityProperties();
			dependentProperties.setVerifiedFromSignBank(true);
			dependentProperties.setSourceResource(sourceResource);
			dependentProperties.setDifferingFromOccurrence(differingFromOccurrence);
			dependentProperties.setMainGestureID(mainGestureID);
			dependentProperties.setVariantID(variantID);
			dependentProperties.setOccurrenceID(occurrenceID);
		}

		updateChanges();
		
		return true;
	}

	protected boolean updateChanges() {

		MediaToolBar mediaToolBar = SS3Singleton.getMediaToolBar(null);

		if (currentGestureEntity == null) {
			currentGestureEntity = wrapper.getGestureField()
					.getGestureEventsEntityCollection()
					.getSelectedEntity();
			boolean rightHanded = true;
			var parentEntities = currentGestureEntity.getParentEntities();
			for (PresentationEventsEntity parentEntity: parentEntities) {
				SS3GlossWindowItem windowItem = parentEntity.getSS3GlossWindowItem();
				SS3TemporalPartition partition = currentGestureEntity.getSignStreamSegmentPanel().getSS3Database()
						.getSS3GlossWindow().getTemporalPartitionByLabel(windowItem.getPartitionLabel());
				SS3GlossWindowSegment segment = partition.getTemporalPartitionSegmentByLabel(windowItem.getSegmentLabel());
				if (segment.getParticipant() != null && ! segment.getParticipant().isDominantHandRight()) {
					rightHanded = false;
				}
			}
			currentPartipantRightHanded = rightHanded;
		}
		
		// (re-)setting unique number, if applicable
		String potentialUniqueNumberStr = uniqueNumberField.getText();
		if (potentialUniqueNumberStr == null || potentialUniqueNumberStr.isBlank()) {
			SS3Singleton.getErrorMessages().showErrorMessage(
					ErrorMessages.GESTURE_UNIQUE_NUMBER_NOT_NULL_POSITIVE);
			return false;
		}
		
		int potentialUniqueNumber = 0;
		try {
			potentialUniqueNumber = Integer.parseInt(potentialUniqueNumberStr);
		} catch (NumberFormatException ex) {
			SS3Singleton.getErrorMessages().showErrorMessage(
					ErrorMessages.GESTURE_UNIQUE_NUMBER_NOT_NULL_POSITIVE);
			return false;
		}
		
		if (potentialUniqueNumber < 1) {
			SS3Singleton.getErrorMessages().showErrorMessage(
					ErrorMessages.GESTURE_UNIQUE_NUMBER_NOT_NULL_POSITIVE);			
			return false;
		}
		
		boolean success = currentGlossWindowSegment.setGestureUniqueNumber(currentGestureEntity, potentialUniqueNumber);
		if (!success) {
			SS3Singleton.getErrorMessages().showErrorMessage(
					ErrorMessages.GESTURE_UNIQUE_NUMBER_COLLISION);
			return false;
		}
		
		

		GestureEventsEntity depGestEntity = currentGestureEntity.getDependentGestureEntity();
		GestureEvent selectedTextEvent = (GestureEvent) currentGestureEntity.getTextValue();
		GestureClassifications gestClassification = selectedTextEvent.getGestureClassifications();

		GestureEntityProperties properties = currentGestureEntity.getGestureEntityProperties();

		if(hshPanel.isFingerspelled()) {
			gestClassification.setSignClassifications(GestureClassifications.SIGN_FINGERSPELLED);
		} else if(hshPanel.isLoan()) {
			gestClassification.setSignClassifications(GestureClassifications.SIGN_LOAN);
		} else if(hshPanel.isNumber()) {
			gestClassification.setSignClassifications(GestureClassifications.SIGN_NUMBERS);
		} else if(hshPanel.isLexical()) {
			gestClassification.setSignClassifications(GestureClassifications.SIGN_LEXICAL);
		} else if(hshPanel.isClassifier()) {
			gestClassification.setSignClassifications(GestureClassifications.SIGN_CLASSIFIER);
		} else if(hshPanel.isGesture()) {
			gestClassification.setSignClassifications(GestureClassifications.SIGN_GESTURE);
		}

		gestClassification.setNameSign(hshPanel.isNameSign());
		gestClassification.setOneFrameGesture(hshPanel.isOneFrameGloss());
		gestClassification.setPassiveBaseArm(hshPanel.isPassiveBaseArm());
		gestClassification.setMarkedNamberOfHands(hshPanel.isMarkedNumberOfHands());

		properties.setOneFrameGesture(hshPanel.isOneFrameGloss());

		currentGestureEntity.setIncompleteGesture(incompleteCheckbox.isSelected());
//		currentGestureEntity.setShowUniqueNumber(showUniqueNumberCheckbox.isSelected());
		
		currentGlossWindowSegment.setShowAllGestureCounters(showAllUniqueNumbersCheckbox.isSelected());
		currentGlossWindowSegment.showAllGestureCounters();
//		currentGlossWindowSegment.setDefaultShowGestureCounters(defaultShowUniqueNumbersCheckbox.isSelected());

		String fieldID = null;

		Field field = SS3Singleton.getMediaToolBar(null).selectedField();
		if(field != null) {
			fieldID = field.getFieldID();
		}

		if(fieldID == null) {
			EventsEntity ent = SS3Singleton.getMediaToolBar(null).selectedEntity();

			if (ent == null)
				return false;

			GestureEventsEntity entity = (GestureEventsEntity) ent;
			fieldID = entity.getField().getFieldID();
		}

		LabelObject gestLabelObj = view.getSegment().getRootLabelObject().getGestureLabelObject();

		String newID = fieldID.equalsIgnoreCase(Util.DOM_GESTURE_FIELD_ID) ? Util.NDOM_GESTURE_FIELD_ID : Util.DOM_GESTURE_FIELD_ID;

		GestureFieldWrapper depGestWrapper = (GestureFieldWrapper) gestLabelObj.getChildWithFieldID(newID).getWrapper();

		String domGestureTypeFieldID = Util.DOM_GESTURE_TYPE_FIELD_ID;
		GestureTypeFieldWrapper domGestureTypeWrapper
			= (GestureTypeFieldWrapper) gestLabelObj.getChildWithFieldID(domGestureTypeFieldID).getWrapper();
		if (domGestureTypeWrapper == null)
			domGestureTypeWrapper = (GestureTypeFieldWrapper) gestLabelObj.getChildWithFieldID(domGestureTypeFieldID).getWrapper();

		String ndomGesureTypeFieldID = Util.NDOM_GESTURE_TYPE_FIELD_ID;
		GestureTypeFieldWrapper ndomGestureTypeWrapper
			= (GestureTypeFieldWrapper) gestLabelObj.getChildWithFieldID(ndomGesureTypeFieldID).getWrapper();
		if (ndomGestureTypeWrapper == null)
			ndomGestureTypeWrapper = (GestureTypeFieldWrapper) gestLabelObj.getChildWithFieldID(ndomGesureTypeFieldID).getWrapper();

		boolean isTwoHanded = hshPanel.isTwoHandedSelected();
		if (isTwoHanded) {
			if(depGestEntity != null) {
				String text = currentGestureEntity.getText();
				depGestEntity.getTextValue().setText(text);
				depGestEntity.getGestureEntityProperties().setTwoHanded(true);
				depGestEntity.setIncompleteGesture(currentGestureEntity.getIncompleteGesture());
				depGestEntity.setShowUniqueNumber(currentGestureEntity.getShowUniqueNumber());
				depGestEntity.setUniqueNumber(currentGestureEntity.getUniqueNumber());
			} else {
				GestureField gestField = (GestureField) depGestWrapper.getField();

				ArrayList<GestureEventsEntity> entities = gestField.getEntitiesInInterval(currentGestureEntity.interval(), Bound.EXCLUSIVE);

				if (entities.isEmpty()) {
					GestureChainedEventsCollection chainedEventsCollection = new GestureChainedEventsCollection();

					GestureEvent ndTextEvent = new GestureEvent(
							currentGestureEntity.getSignStreamSegmentPanel());
					ndTextEvent.setStartTimeInfo(selectedTextEvent.getStartTimeInfo());
					ndTextEvent.setEndTimeInfo(selectedTextEvent.getEndTimeInfo());
					ndTextEvent.setText(selectedTextEvent.getText());


					chainedEventsCollection.setTextValueEvent(ndTextEvent);
					depGestEntity = new GestureEventsEntity(
							chainedEventsCollection,
							currentGestureEntity.getSignStreamSegmentPanel(), gestField);
					depGestEntity.updateParentEntity();
					depGestEntity.setCorrespondingGestureEntityID(currentGestureEntity.getID());
					currentGestureEntity.setCorrespondingGestureEntityID(depGestEntity.getID());
					currentGestureEntity.setDependentGestureEntity(depGestEntity);
					depGestEntity.setDependentGestureEntity(currentGestureEntity);
					depGestEntity.getGestureEntityProperties().setTwoHanded(true);
					depGestEntity.setIncompleteGesture(currentGestureEntity.getIncompleteGesture());
					depGestEntity.setShowUniqueNumber(currentGestureEntity.getShowUniqueNumber());
					depGestEntity.setUniqueNumber(currentGestureEntity.getUniqueNumber());

					currentGestureEntity.setLockedDomNdomAlignments(true);
					depGestEntity.setLockedDomNdomAlignments(true);
					depGestWrapper.getGestureField().addGestureEventsEntity(depGestEntity);

//					Location_XYZEntity depLocEntity = currentGestureEntity.getDependentLocationEntity();
//					depGlsEntity.setDependentLocationEntity(depLocEntity);
//
//					if (depLocEntity != null) {
//						Location_XYZFieldWrapper domLocWrapper = (Location_XYZFieldWrapper) collection.getFieldWrapperWithFieldID(Util.DOM_LOCATION_XYZ_FIELD_ID);
//						Location_XYZFieldWrapper ndomLocWrapper = (Location_XYZFieldWrapper) collection.getFieldWrapperWithFieldID(Util.NDOM_LOCATION_XYZ_FIELD_ID);
//						if (wrapper.getGestureField().getFieldID().equals(Util.NDOM_GESTURE_FIELD_ID)) {
//							ndomLocWrapper.getField().deleteEntity(depLocEntity);
//							domLocWrapper.getField().addEventsEntity(depLocEntity);
//						}
//						depLocEntity.setRefGestureEntity(depGlsEntity);
//					}

//					GestureTypeEntity depSignTypeEnt = currentGestureEntity.getDependentSignTypeEntity();
//					depGlsEntity.setDependentSignTypeEntity(depSignTypeEnt);
//
//					if (depSignTypeEnt != null) {
//						SignType_XYZFieldWrapper domSignTypeWrapper = (SignType_XYZFieldWrapper) collection.getFieldWrapperWithFieldID(Util.DOM_GESTURE_TYPE_FIELD_ID);
//						SignType_XYZFieldWrapper ndomSignTypeWrapper = (SignType_XYZFieldWrapper) collection.getFieldWrapperWithFieldID(Util.NDOM_GESTURE_TYPE_FIELD_ID);
//						if (wrapper.getGestureField().getFieldID().equals(Util.NDOM_GESTURE_FIELD_ID)) {
//							ndomSignTypeWrapper.getField().deleteEntity(depSignTypeEnt);
//							domSignTypeWrapper.getField().addEventsEntity(depSignTypeEnt);
//						}
//						depSignTypeEnt.setRefGestureEntity(depGlsEntity);
//					}
				} else {
					SS3Singleton.getErrorMessages().showErrorMessage(
							ErrorMessages.CHAINS_CANNOT_OVERLAP);
					return false;
				}
			}
			
		} else {
			currentGestureEntity.setLockedDomNdomAlignments(false);
			
			// delete second gloss and related
			if (depGestEntity != null) {
				depGestWrapper.getGestureField().deleteEntity(depGestEntity);

				GestureChainedEventsEntity depHandEntity = depGestEntity.getDependentHandEntity();
				GestureHandShapeEntity depHandShapeEntity = depGestEntity.getDependentHandShapeEntity();
				GestureOrientationEntity depOrientationEntity = depGestEntity.getDependentOrientationEntity();
				
				ApexChainedApexEventsEntity depApexEntity = depGestEntity.getDependentApexEntity();

				GestureDomNdomHandFieldWrapper depHandWrapper;
				GestureOrientationFieldWrapper depOrnWrapper;
				
				ApexFieldWrapper depApexWrapper;

				if(depGestWrapper.getGestureField().getFieldID().equalsIgnoreCase(Util.DOM_GESTURE_FIELD_ID)) {
					depHandWrapper = (GestureDomNdomHandFieldWrapper) gestLabelObj.getChildWithFieldID(Util.DOM_GESTURE_HAND_FIELD_ID).getWrapper();
					depOrnWrapper = (GestureOrientationFieldWrapper) gestLabelObj.getChildWithFieldID(Util.DOM_GESTURE_ORIENTATION_FIELD_ID).getWrapper();
					depApexWrapper = (ApexFieldWrapper)  gestLabelObj.getChildWithFieldID(Util.DOM_GESTURE_APEX_FIELD_ID).getWrapper();
				} else {
					depHandWrapper = (GestureDomNdomHandFieldWrapper) gestLabelObj.getChildWithFieldID(Util.NDOM_GESTURE_HAND_FIELD_ID).getWrapper();
					depOrnWrapper = (GestureOrientationFieldWrapper) gestLabelObj.getChildWithFieldID(Util.NDOM_GESTURE_ORIENTATION_FIELD_ID).getWrapper();
					depApexWrapper = (ApexFieldWrapper)  gestLabelObj.getChildWithFieldID(Util.NDOM_GESTURE_APEX_FIELD_ID).getWrapper();
				}

				if(depHandEntity != null) {
					GestureDomNdomHandField rl = (GestureDomNdomHandField)depHandWrapper.getField();
					rl.deleteEntity(depHandEntity);
				}

				if(depHandShapeEntity != null) {
					depHandShapeEntity.getField().deleteEntity(depHandShapeEntity);
				}
				
				if (depOrientationEntity != null) {
					depOrnWrapper.getField().deleteEntity(depOrientationEntity);
				}
				
				if (depApexEntity != null) {
					depApexWrapper.getField().deleteEntity(depApexEntity);
				}

				depGestEntity = null;
			}
		}

		getGestureTypePanel().setSelectedGestureTypes();
		
		// begin block: this block (up until below) was above, but the check for going to 2-handed should occur first
		if(hshPanel.isTwoHandedSelected()) {
			gestClassification.setNumberOfHands(2);
			properties.setTwoHanded(true);
		} else {
			gestClassification.setNumberOfHands(1);
			properties.setTwoHanded(false);
		}
		
		DomNdomHandshapesType handshapeClassification = hshPanel.getSelectedSameDifDomNdomHandshapes();
		boolean sameHandshapes = handshapeClassification == DomNdomHandshapesType.SAME;

		gestClassification.setSameHandshapes(sameHandshapes);

		if(sameHandshapes) {
			StartEndHandshapesType sameDiffStartEndHandshapes = hshPanel.getSelectedSameDifStartEndHandshapes();
			gestClassification.setDomHandShapesSameDIfferent(sameDiffStartEndHandshapes);
			gestClassification.setNondomHandShapesSameDIfferent(sameDiffStartEndHandshapes);
		} else {
			StartEndHandshapesType sameDifStartEndHandshapesL = hshPanel.getSelectedSameDifStartEndHandshapesNdom();
			StartEndHandshapesType sameDifStartEndHandshapesR = hshPanel.getSelectedSameDifStartEndHandshapesDom();
			
			if(isDominantHandRight()) {
				gestClassification.setDomHandShapesSameDIfferent(sameDifStartEndHandshapesR);
				gestClassification.setNondomHandShapesSameDIfferent(sameDifStartEndHandshapesL);
			} else {
				gestClassification.setDomHandShapesSameDIfferent(sameDifStartEndHandshapesL);
				gestClassification.setNondomHandShapesSameDIfferent(sameDifStartEndHandshapesR);
			}
		}
		// end block

		GestureEntityProperties properties2 = null;

		if (depGestEntity != null)
			properties2 = depGestEntity.getGestureEntityProperties();

		if (hshPanel.isFingerspelled()) {
			properties.setFingerspelled();
			if (properties2 != null)
				properties2.setFingerspelled();
		} else if (hshPanel.isLoan()) {
			properties.setLoan();
			if (properties2 != null)
				properties2.setLoan();
		} else if (hshPanel.isNumber()) {
			properties.setNumber();
			if (properties2 != null)
				properties2.setNumber();
		} else if (hshPanel.isLexical()) {
			properties.setLexical();
			if (properties2 != null)
				properties2.setLexical();
		} else if (hshPanel.isClassifier()) {
			properties.setClassifier();
			if (properties2 != null)
				properties2.setClassifier();
		} else if (hshPanel.isGesture()) {
			properties.setGesture();
			if (properties2 != null)
				properties2.setGesture();
		}

		properties.setNameSign(hshPanel.isNameSign());
		properties.setDominamtHand(dominantHand);
		properties.setMarkedNumberOfHands(hshPanel.isMarkedNumberOfHands());
		properties.setPassiveBaseArm(hshPanel.isPassiveBaseArm());

		if (properties2 != null) {
			properties2.setNameSign(hshPanel.isNameSign());
			properties2.setDominamtHand(dominantHand);
			properties2
					.setMarkedNumberOfHands(hshPanel.isMarkedNumberOfHands());
			properties2.setPassiveBaseArm(hshPanel.isPassiveBaseArm());
		}

		String text = gestureLbField.getText().trim();

		currentGestureEntity.getGestureChainedEvent().setText(text);

		if (depGestEntity != null) {
			depGestEntity.getGestureChainedEvent().setText(text);
		}

		GestureHandShapeBean hspBean = hshPanel.getHandShapeBean();

		addOrUpdateHandShapes(hspBean, currentGestureEntity, gestLabelObj);

		if (depGestEntity != null) {
			Event event = currentGestureEntity.getValueOrTextValueEvent();
			GestureChainedEvent onset = currentGestureEntity.getPreparation();
			GestureChainedEvent initialHold = currentGestureEntity.getPrestrokeHold();
			GestureChainedEvent offset = currentGestureEntity.getRetraction();
			GestureChainedEvent finalHold = currentGestureEntity.getPoststrokeHold();
			GestureChainedEvent relaxed = currentGestureEntity.getRelaxed();

			Event ndEvent = depGestEntity.getValueOrTextValueEvent();
			GestureChainedEvent ndOnset = depGestEntity.getPreparation();
			GestureChainedEvent ndInitialHold = depGestEntity.getPrestrokeHold();
			GestureChainedEvent ndOffset = depGestEntity.getRetraction();
			GestureChainedEvent ndFinalHold = depGestEntity.getPoststrokeHold();
			GestureChainedEvent ndRelaxed = depGestEntity.getRelaxed();

			if (currentGestureEntity.isLockedDomNdomAlignments() && depGestEntity.isLockedDomNdomAlignments()) {
			    ndEvent.setStartTimeInfo(event.getStartTimeInfo());
			    ndEvent.setEndTimeInfo(event.getEndTimeInfo());

				SignStreamSegmentPanel panel = wrapper.getField()
						.getSignStreamSegmentPanel();

				if (initialHold != null) {
					if (ndInitialHold != null) {
					    ndInitialHold.setStartTimeInfo(initialHold.getStartTimeInfo());
					    ndInitialHold.setEndTimeInfo(initialHold.getEndTimeInfo());
					} else {
						ndInitialHold = new GestureChainedEvent(panel);
						ndInitialHold.setStartTimeInfo(initialHold.getStartTimeInfo());
						ndInitialHold.setEndTimeInfo(initialHold.getEndTimeInfo());
						depGestEntity.setPrestrokeHoldEvent(ndInitialHold);
					}
				} else {
					depGestEntity.setPrestrokeHoldEvent(null);
				}

				if (onset != null) {
					if (ndOnset != null) {
					    ndOnset.setStartTimeInfo(onset.getStartTimeInfo());
					    ndOnset.setEndTimeInfo(onset.getEndTimeInfo());
					} else {
						ndOnset = new GestureChainedEvent(panel);
						ndOnset.setStartTimeInfo(onset.getStartTimeInfo());
						ndOnset.setEndTimeInfo(onset.getEndTimeInfo());
						depGestEntity.setPreparationEvent(ndOnset);
					}
				} else {
					depGestEntity.setPreparationEvent(null);
				}

				if (finalHold != null) {
					if (ndFinalHold != null) {
					    ndFinalHold.setStartTimeInfo(finalHold.getStartTimeInfo());
					    ndFinalHold.setEndTimeInfo(finalHold.getEndTimeInfo());
					} else {
						ndFinalHold = new GestureChainedEvent(panel);
						ndFinalHold.setStartTimeInfo(finalHold.getStartTimeInfo());
						ndFinalHold.setEndTimeInfo(finalHold.getEndTimeInfo());
						depGestEntity.setPoststrokeHoldEvent(ndFinalHold);
					}
				} else {
					depGestEntity.setPoststrokeHoldEvent(null);
				}

				if (offset != null) {
					if (ndOffset != null) {
					    ndOffset.setStartTimeInfo(offset.getStartTimeInfo());
					    ndOffset.setEndTimeInfo(offset.getEndTimeInfo());
					} else {
						ndOffset = new GestureChainedEvent(panel);
						ndOffset.setStartTimeInfo(offset.getStartTimeInfo());
						ndOffset.setEndTimeInfo(offset.getEndTimeInfo());
						depGestEntity.setRetractionEvent(ndOffset);
					}
				} else {
					depGestEntity.setRetractionEvent(null);
				}

				if (relaxed != null) {
					if (ndRelaxed != null) {
						ndRelaxed.setStartTimeInfo(relaxed.getStartTimeInfo());
						ndRelaxed.setEndTimeInfo(relaxed.getEndTimeInfo());
					} else {
						ndRelaxed = new GestureChainedEvent(panel);
						ndRelaxed.setStartTimeInfo(relaxed.getStartTimeInfo());
						ndRelaxed.setEndTimeInfo(relaxed.getEndTimeInfo());
						depGestEntity.setRelaxedEvent(ndRelaxed);
					}
				} else {
					depGestEntity.setRelaxedEvent(null);
				}
			}
		}

		properties.clearHandshapeInformation();

		if(hshPanel.isTwoHandedSelected()) {
			properties2.clearHandshapeInformation();
			if(handshapeClassification == DomNdomHandshapesType.SAME) {
				properties.setTwoHandedHandshapesClassification(GestureEntityProperties.SAME_HANDSHAPES_DOM_NDOM);
				properties2.setTwoHandedHandshapesClassification(GestureEntityProperties.SAME_HANDSHAPES_DOM_NDOM);
				StartEndHandshapesType sameDiffHandshapes = hshPanel.getSelectedSameDifStartEndHandshapes();
				if(sameDiffHandshapes == StartEndHandshapesType.SAME) {
					properties.setStartEndHandshape(GestureEntityProperties.SAME_START_END_HANDSHAPE);
					properties2.setStartEndHandshape(GestureEntityProperties.SAME_START_END_HANDSHAPE);
				} else {
					properties.setStartEndHandshape(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
					properties2.setStartEndHandshape(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
				}
			} else if(handshapeClassification == DomNdomHandshapesType.ALTERNATING) {
				properties.setTwoHandedHandshapesClassification(GestureEntityProperties.ALTERNATING_SAME_HANDSHAPES_DOM_NDOM);
				properties2.setTwoHandedHandshapesClassification(GestureEntityProperties.ALTERNATING_SAME_HANDSHAPES_DOM_NDOM);
				StartEndHandshapesType sameDiffHandshapes = hshPanel.getSelectedSameDifStartEndHandshapes();
				if(sameDiffHandshapes == StartEndHandshapesType.SAME) {
					properties.setStartEndHandshape(GestureEntityProperties.SAME_START_END_HANDSHAPE);
					properties2.setStartEndHandshape(GestureEntityProperties.SAME_START_END_HANDSHAPE);
				} else {
					properties.setStartEndHandshape(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
					properties2.setStartEndHandshape(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
				}
			} else {
				properties.setTwoHandedHandshapesClassification(GestureEntityProperties.DIFFERENT_HANDSHAPES_DOM_NDOM);
				properties2.setTwoHandedHandshapesClassification(GestureEntityProperties.DIFFERENT_HANDSHAPES_DOM_NDOM);
				
				StartEndHandshapesType selectedStartEndHandshapeR = hshPanel.getSelectedSameDifStartEndHandshapesDom();
				StartEndHandshapesType selectedStartEndHandshapeL = hshPanel.getSelectedSameDifStartEndHandshapesNdom();
				
				if(selectedStartEndHandshapeR == StartEndHandshapesType.SAME) {
					properties.setStartEndHandshapeDomHand(GestureEntityProperties.SAME_START_END_HANDSHAPE);
					properties2.setStartEndHandshapeDomHand(GestureEntityProperties.SAME_START_END_HANDSHAPE);
				} else {
					properties.setStartEndHandshapeDomHand(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
					properties2.setStartEndHandshapeDomHand(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
				}
				
				if(selectedStartEndHandshapeL == StartEndHandshapesType.SAME) {
					properties.setStartEndHandshapeNdomHand(GestureEntityProperties.SAME_START_END_HANDSHAPE);
					properties2.setStartEndHandshapeNdomHand(GestureEntityProperties.SAME_START_END_HANDSHAPE);
				} else {
					properties.setStartEndHandshapeNdomHand(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
					properties2.setStartEndHandshapeNdomHand(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
				}
			}
		} else {
			StartEndHandshapesType sameDiffHandshapes = hshPanel.getSelectedSameDifStartEndHandshapes();
			if(sameDiffHandshapes == StartEndHandshapesType.SAME) {
				properties.setStartEndHandshape(GestureEntityProperties.SAME_START_END_HANDSHAPE);
			} else {
				properties.setStartEndHandshape(GestureEntityProperties.DIFFERENT_START_END_HANDSHAPE);
			}
		}

		if(!properties.isTwoHanded()) {
			currentGestureEntity.setDependentGestureEntity(null);
			currentGestureEntity.setCorrespondingGestureEntityID(null);
		}

		// GD 2021-03-06: do not update gesture hand/shape entities to the final/initial holds
//		if (depGlsEntity != null && depGlsEntity.isLockedGesturePhonAlignments()) { //check if locked to hand shape
//			Event initialHold = depGlsEntity.getInitialHold();
//			Event finalHold = depGlsEntity.getFinalHold();
//            
//			if(initialHold != null) {
//				TimeInfo initialStartMovieTimeInfo = initialHold.getStartTimeInfo();
//				depGlsEntity.getDependentHandEntity().setStartTimeInfo(initialStartMovieTimeInfo);
//				depGlsEntity.getDependentHandShapeEntity().getFirstHandShapeEvent_XYZ().setStartTimeInfo(initialStartMovieTimeInfo);
//				depGlsEntity.getDependentHandShapeEntity().getFirstHandShapeEvent_XYZ().setEndTimeInfo(initialStartMovieTimeInfo);
//			}
//			if(finalHold != null) {
//				TimeInfo finalEndMovieTimeInfo = finalHold.getEndTimeInfo();
//				depGlsEntity.getDependentHandEntity().setEndTimeInfo(finalEndMovieTimeInfo);
//				depGlsEntity.getDependentHandShapeEntity().getLastHandShapeEvent_XYZ().setStartTimeInfo(finalEndMovieTimeInfo);
//				depGlsEntity.getDependentHandShapeEntity().getLastHandShapeEvent_XYZ().setEndTimeInfo(finalEndMovieTimeInfo);
//			}
//		}

		hshPanel.getSelectedDomHandshapesPane().removeAll();
		hshPanel.getSelectedNdomHandshapesPane().removeAll();

		//properties.setLocationInfo(locationPanel.getCurrentLocationInfo().cloneInfo());
//		addOrUpdateLocations(currentGestureEntity, collection);
//		addOrUpdateSignTypes(currentGestureEntity, collection);

		wrapper.getSignStreamSegmentPanel().repaint();
		wrapper.getSignStreamSegmentPanel().getUtteranceView().updateUtteranceLists();
		wrapper.getSignStreamSegmentPanel().getUtteranceView().updateUtteranceIndex();

		// set start/end times to themselves to make sure handshapes won't get misaligned for badly saved glosses
		MediaToolbarCommons.setSelectedEventStartTime(mediaToolBar.selectedEvent().getStartTimeInfo());
		MediaToolbarCommons.setSelectedEventEndTime(mediaToolBar.selectedEvent().getEndTimeInfo());
		
		return true;
 	}

	@Deprecated // in favor of getGestureTypePanel().setSelectedGestureTypes()
 	private void addOrUpdateSignTypes(GestureEventsEntity glossEntity, LabelObject gestLabelObj) {
//		GestureTypeEntity dependentSignTypeEntity = glossEntity.getDependentSignTypeEntity();
//		TimeInfo startTimeInfo = glossEntity.getStartTimeInfo();
//		TimeInfo endTimeInfo = glossEntity.getEndTimeInfo();
//
//		GestureEventsEntity depGlsEntity = glossEntity.getDependentGestureEntity();
//
//		SignType_XYZFieldWrapper signTypeFieldWrapper;
//		String signTypeFieldID;
//		if (!isCurrentGestureDominant() && depGlsEntity == null) {
//			signTypeFieldID = Util.NDOM_GESTURE_TYPE_FIELD_ID;
//		} else {
//			signTypeFieldID = Util.DOM_GESTURE_TYPE_FIELD_ID;
//		}
//        signTypeFieldWrapper = (SignType_XYZFieldWrapper) collection.getFieldWrapperWithFieldID(signTypeFieldID);
//        if (signTypeFieldWrapper == null) {
//            signTypeFieldWrapper = (SignType_XYZFieldWrapper) view.getSegment().getRootLabelObject()
//                    .getGestureNRelatedLabelObject().getChildWithFieldID(signTypeFieldID).getWrapper();
//        }
//
//		if (dependentSignTypeEntity != null) {
//			dependentSignTypeEntity.getEvent().setSignType_XYZ(currentSignType);
//			dependentSignTypeEntity.getEvent().setNameSign(glossEntity.getGestureEntityProperties().isNameSign());
//			dependentSignTypeEntity.setStartTimeInfo(startTimeInfo);
//			dependentSignTypeEntity.setEndTimeInfo(endTimeInfo);
//			if (depGlsEntity != null) {
//				depGlsEntity.setDependentSignTypeEntity(dependentSignTypeEntity);
//			}
//		} else {
//			SignType_XYZEvent event = new SignType_XYZEvent(
//					signTypeFieldWrapper.getSignStreamSegmentPanel(),
//					startTimeInfo,
//					endTimeInfo
//			);
//			event.setSignType_XYZ(currentSignType);
//			event.setNameSign(glossEntity.getGestureEntityProperties().isNameSign());
//			dependentSignTypeEntity = new GestureTypeEntity(event, signTypeFieldWrapper.getSignStreamSegmentPanel(), signTypeFieldWrapper.getField());
//			dependentSignTypeEntity.setID(Util.getLongUniqueNumber());
//			signTypeFieldWrapper.addEventsEntity(dependentSignTypeEntity);
//
//			glossEntity.setDependentSignTypeEntity(dependentSignTypeEntity);
//			if (depGlsEntity != null) {
//				depGlsEntity.setDependentSignTypeEntity(dependentSignTypeEntity);
//			}
//
//			if (isCurrentGestureDominant() || (!isCurrentGestureDominant() && depGlsEntity == null)) {
//				dependentSignTypeEntity.setRefGestureEntity(glossEntity);
//			} else {
//				dependentSignTypeEntity.setRefGestureEntity(depGlsEntity);
//			}
//		}
	}

	private void addOrUpdateLocations(GestureEventsEntity glossEntity, LabelObject gestLabelObj) {
		SignStreamSegmentPanel segmentPanel = glossEntity.getSignStreamSegmentPanel();
		GestureLocationEntity depLocEntity = glossEntity.getDependentLocationEntity();
		LocationInfo newInfo = new LocationInfo(); //locationPanel.getCurrentLocationInfo();

		GestureEventsEntity depGestEntity = glossEntity.getDependentGestureEntity();

		GestureLocationFieldWrapper lfWrapper;
		String locFieldID;
		if (!isCurrentGestureDominant() && depGestEntity == null) { // one-handed non-dominant gloss
			locFieldID = Util.NDOM_GESTURE_LOCATION_FIELD_ID;
		} else {
			locFieldID = Util.DOM_GESTURE_LOCATION_FIELD_ID;
		}
		lfWrapper = (GestureLocationFieldWrapper) gestLabelObj.getChildWithFieldID(locFieldID).getWrapper();
		if (lfWrapper == null) {
		    lfWrapper = (GestureLocationFieldWrapper) view.getSegment().getRootLabelObject()
                    .getGestureLabelObject().getChildWithFieldID(locFieldID).getWrapper();
        }


		if (newInfo.isEmpty()) {
		    if (depLocEntity != null) {
                lfWrapper.getField().deleteEntity(depLocEntity);
                glossEntity.setDependentLocationEntityID(null);
                glossEntity.setDependentLocationEntity(null);
		    }
		    return;
		}

		double startTime = glossEntity.getStartTimeInfo().doubleValue();
        double endTime = glossEntity.getEndTimeInfo().doubleValue();

        ArrayList<GestureLocationEvent> eventsList = new ArrayList<GestureLocationEvent>();

        // populates the list of LocationEvents that will get passed to the LocationEntity.
        // sets the start/end times of each LocationEvent relative to what order they appear in on-screen
        ArrayList<LocationType> locationTypes = SS3Singleton.getLocationConfig().getLocationTypes();
        for (int i = 0; i < locationTypes.size(); i++) {
            GestureLocationType type = new GestureLocationType(locationTypes.get(i));
            double time;
            if (i == 0) {
                time = startTime;
            } else if (i == locationTypes.size() - 1) {
                time = endTime;
            } else {
                time = startTime + (i * (endTime - startTime) / (newInfo.size() - 1));
            }
            Time startTimeInfo = SS3Singleton.getVideoTimeRange().time(Math.round(time), TimeUnit.TIMESTAMP);
//            TimeInfo startTimeInfo = new TimeInfo(time, glossEntity.getStartTimeInfo().unit());
            GestureLocationEvent event = new GestureLocationEvent(segmentPanel, type, newInfo.getLocation(new LocationType(type)));
            event.setStartTimeInfo(startTimeInfo);
            
            eventsList.add(event);
        }

        if (depLocEntity != null) {
            depLocEntity.reset();
            depLocEntity.setEvents(eventsList);
            if (depGestEntity != null) {
                depGestEntity.setDependentLocationEntity(depLocEntity);
            }
        } else {
            GestureLocationEventsCollection newLocEventsColl = new GestureLocationEventsCollection();
            for (GestureLocationEvent locationEvent : eventsList) {
                newLocEventsColl.addEvent(locationEvent);
            }

            GestureLocationEntity newLocEnt = new GestureLocationEntity(Util.getLongUniqueNumber(), newLocEventsColl, segmentPanel, lfWrapper.getField());
            newLocEnt.setStartTimeInfo(newLocEventsColl.getFirstEvent().getStartTimeInfo());
            newLocEnt.setEndTimeInfo(newLocEventsColl.getLastEvent().getEndTimeInfo());
            lfWrapper.addEventsEntity(newLocEnt);

            glossEntity.setDependentLocationEntity(newLocEnt);
            if (depGestEntity != null) {
                depGestEntity.setDependentLocationEntity(newLocEnt);
            }

            if (!isCurrentGestureDominant() && depGestEntity == null) {
                newLocEnt.setRefGestureEntity(glossEntity);
            } else {
                newLocEnt.setRefGestureEntity(depGestEntity);
            }
        }
	}

	private void addOrUpdateHandShapes(GestureHandShapeBean bean, GestureEventsEntity entity, LabelObject gestLabelObj) {

		GestureEventsEntity depGestEntity = entity.getDependentGestureEntity();
		String fieldID = entity.getField().getFieldID();

		ArrayList<HandShapeImage> domHndShapeImgs = new ArrayList<HandShapeImage>(bean.getSelectedDomHandShapeImages());
		ArrayList<HandShapeImage> ndomHndShapeImgs = new ArrayList<HandShapeImage>(bean.getSelectedNdomHandShapeImages());
		ArrayList<OrientationImage> domOrientationImgs = new ArrayList<OrientationImage>(bean.getSelectedDomOrientationImages());
		ArrayList<OrientationImage> ndomOrientationImgs = new ArrayList<OrientationImage>(bean.getSelectedNdomOrientationImages());

		GestureChainedEventsEntity dhEntity = null, ndhEntity = null;
		GestureHandShapeEntity dHshEntity, ndHshEntity;
		GestureOrientationEntity  dOEntity, ndOEntity;

		SignStreamSegmentPanel segmentPanel = entity.getSignStreamSegmentPanel();

		GestureChainedEventsEntity handEntity = entity.getDependentHandEntity();
		GestureHandShapeEntity handShapeEntity = entity.getDependentHandShapeEntity();
		GestureOrientationEntity orientationEntity = entity.getDependentOrientationEntity();
		
		GestureChainedEventsEntity depHandEntity = null;
		GestureHandShapeEntity depHandShapeEntity = null;
		GestureOrientationEntity depOrientationEntity = null;

		if(depGestEntity != null) {
			depHandEntity = depGestEntity.getDependentHandEntity();
			depHandShapeEntity = depGestEntity.getDependentHandShapeEntity();
			depOrientationEntity = depGestEntity.getDependentOrientationEntity();
		}

		LabelObject gestObj = view.getSegment().getRootLabelObject().getGestureLabelObject();
		
		String domGestureHandFieldID = Util.DOM_GESTURE_HAND_FIELD_ID;
		GestureDomNdomHandFieldWrapper domHandWrapper
			= (GestureDomNdomHandFieldWrapper) gestLabelObj.getChildWithFieldID(domGestureHandFieldID).getWrapper();
		if (domHandWrapper == null)
			domHandWrapper = (GestureDomNdomHandFieldWrapper) gestObj.getChildWithFieldID(domGestureHandFieldID).getWrapper();

		String domGestureHandshapeFieldID = Util.DOM_GESTURE_HANDSHAPE_FIELD_ID;
		GestureHandShapeFieldWrapper domHandShapeWrapper
			= (GestureHandShapeFieldWrapper) gestLabelObj.getChildWithFieldID(domGestureHandshapeFieldID).getWrapper();
		if (domHandShapeWrapper == null)
			domHandShapeWrapper = (GestureHandShapeFieldWrapper) gestObj.getChildWithFieldID(domGestureHandshapeFieldID).getWrapper();

		String domGestureOrientationFieldID = Util.DOM_GESTURE_ORIENTATION_FIELD_ID;
		GestureOrientationFieldWrapper domOrientationWrapper
			= (GestureOrientationFieldWrapper) gestLabelObj.getChildWithFieldID(domGestureOrientationFieldID).getWrapper();
		if (domOrientationWrapper == null)
			domOrientationWrapper = (GestureOrientationFieldWrapper) gestObj.getChildWithFieldID(domGestureOrientationFieldID).getWrapper();

		String ndomGestureHandFieldID = Util.NDOM_GESTURE_HAND_FIELD_ID;
		GestureDomNdomHandFieldWrapper ndomHandWrapper
			= (GestureDomNdomHandFieldWrapper) gestLabelObj.getChildWithFieldID(ndomGestureHandFieldID).getWrapper();
		if (ndomHandWrapper == null)
			ndomHandWrapper = (GestureDomNdomHandFieldWrapper) gestObj.getChildWithFieldID(ndomGestureHandFieldID).getWrapper();

		String ndomGestureHandshapeFieldID = Util.NDOM_GESTURE_HANDSHAPE_FIELD_ID;
		GestureHandShapeFieldWrapper ndomHandShapeWrapper
			= (GestureHandShapeFieldWrapper) gestLabelObj.getChildWithFieldID(ndomGestureHandshapeFieldID).getWrapper();
		if (ndomHandShapeWrapper == null)
			ndomHandShapeWrapper = (GestureHandShapeFieldWrapper) gestObj.getChildWithFieldID(ndomGestureHandshapeFieldID).getWrapper();

		String ndomGestureOrientationFieldID = Util.NDOM_GESTURE_ORIENTATION_FIELD_ID;
		GestureOrientationFieldWrapper ndomOrientationWrapper
			= (GestureOrientationFieldWrapper) gestLabelObj.getChildWithFieldID(ndomGestureOrientationFieldID).getWrapper();
		if (ndomOrientationWrapper == null)
			ndomOrientationWrapper = (GestureOrientationFieldWrapper) gestObj.getChildWithFieldID(ndomGestureOrientationFieldID).getWrapper();


		if(!domHndShapeImgs.isEmpty() || !domOrientationImgs.isEmpty()) {
			// add/update handshapes on right hand
			if (fieldID.equals(Util.DOM_GESTURE_FIELD_ID)) {
				if(handEntity != null) {
					handEntity.getTextValue().setText(entity.getText());
					//					dhEntity = handEntity;
					//				} else {
					//					// add entity to Right Hand field
					//					dhEntity = addHandEntity(domHandWrapper, entity, segmentPanel);
					//					entity.setDependentHandEntity(dhEntity);
					//					dhEntity.setLockedGesturePhonAlignments(true);
				}

				if (!domHndShapeImgs.isEmpty()) {
					if(handShapeEntity != null) {
						Time startTimeInfo = handShapeEntity.getStartTimeInfo();
						Time endTimeInfo = handShapeEntity.getEndTimeInfo();
						
						if (entity.isLockedGesturePhonAlignments()) {
							GestureChainedEvent value = entity.getTextValue();
							startTimeInfo = value.getStartTimeInfo();
							endTimeInfo = value.getEndTimeInfo();
						}

						SS3Entity ent = GestureHandShapeEntity.createSS3Entity(domHndShapeImgs, startTimeInfo, endTimeInfo);
						handShapeEntity.resetEntity(ent);
					} else {
						// add entity to Right Hand field
						dhEntity = addHandEntity(domHandWrapper, entity, segmentPanel);

						dHshEntity = GestureHandShapeEntity.createGestureHandShapeEntity(bean, domHndShapeImgs, dhEntity,
								domHandShapeWrapper.getGestureHandShapeField());

						domHandShapeWrapper.getGestureHandShapeField().addGestureHandShapeEntity(dHshEntity);
						entity.setDependentHandEntity(dhEntity);
						entity.setDependentHandShapeEntity(dHshEntity);

						dHshEntity.setRefGestureEntity(entity);	
						entity.setLockedGesturePhonAlignments(true);
						dhEntity.setLockedGesturePhonAlignments(true);
						dHshEntity.setLockedGesturePhonAlignments(true);
					}
				}

				if (!domOrientationImgs.isEmpty()) {
					if (orientationEntity != null) {
						Time startTimeInfo = orientationEntity.getStartTimeInfo();
						Time endTimeInfo = orientationEntity.getEndTimeInfo();
						
						if (entity.isLockedGesturePhonAlignments()) {
							GestureChainedEvent value = entity.getTextValue();
							startTimeInfo = value.getStartTimeInfo();
							endTimeInfo = value.getEndTimeInfo();
						}

						SS3Entity ent = GestureOrientationEntity.createSS3EntityOrientation(domOrientationImgs, startTimeInfo, endTimeInfo);
						orientationEntity.resetEntity(ent);
					} else {
						dhEntity = entity.getDependentHandEntity();
						/*
						 * if (dhEntity == null)
						 * ???? not sure how it would be, if handshapes and orientations must be selected together
						 */
						dOEntity = GestureOrientationEntity.createGestureOrientationEntity(bean, domOrientationImgs, dhEntity,
								domOrientationWrapper.getGestureOrientationField());

						domOrientationWrapper.getGestureOrientationField().addGestureOrientationEntity(dOEntity);
						entity.setDependentOrientationEntity(dOEntity);		

						dOEntity.setRefGestureEntity(entity);
						entity.setLockedGesturePhonAlignments(true);
						dOEntity.setLockedGesturePhonAlignments(true);
					}
				}
			} else if (fieldID.equals(Util.NDOM_GESTURE_FIELD_ID)) {
				if(depHandEntity != null) {
					depGestEntity.getTextValue().setText(entity.getText());
					//					dhEntity = ndHandEntity;
					//				} else {
					//					// add entity to Right Hand field
					//					dhEntity = addHandEntity(domHandWrapper, depGlsEntity, segmentPanel);
					//					depGlsEntity.setDependentHandEntity(dhEntity);
					//					dhEntity.setLockedGesturePhonAlignments(true);
				}

				if (!domHndShapeImgs.isEmpty()) {
					if(depHandShapeEntity != null) {
						Time startTimeInfo = depHandShapeEntity.getStartTimeInfo();
						Time endTimeInfo = depHandShapeEntity.getEndTimeInfo();

						if (depGestEntity.isLockedGesturePhonAlignments()) {

							GestureChainedEvent value = depGestEntity.getTextValue();
							startTimeInfo = value.getStartTimeInfo();
							endTimeInfo = value.getEndTimeInfo();
						}

						SS3Entity ent = GestureHandShapeEntity.createSS3Entity(domHndShapeImgs, startTimeInfo, endTimeInfo);
						depHandShapeEntity.resetEntity(ent);
					} else {
						// add entity to Right Hand field
						dhEntity = addHandEntity(domHandWrapper, depGestEntity, segmentPanel);

						dHshEntity = GestureHandShapeEntity.createGestureHandShapeEntity(bean, domHndShapeImgs, dhEntity,
								domHandShapeWrapper.getGestureHandShapeField());

						domHandShapeWrapper.getGestureHandShapeField().addGestureHandShapeEntity(dHshEntity);
						depGestEntity.setDependentHandEntity(dhEntity);
						depGestEntity.setDependentHandShapeEntity(dHshEntity);

						dHshEntity.setRefGestureEntity(depGestEntity);						
						depGestEntity.setLockedGesturePhonAlignments(true);
						dhEntity.setLockedGesturePhonAlignments(true);
						dHshEntity.setLockedGesturePhonAlignments(true);
					}
				}

				if (!domOrientationImgs.isEmpty()) {
					if(depOrientationEntity != null) {
						Time startTimeInfo = depOrientationEntity.getStartTimeInfo();
						Time endTimeInfo = depOrientationEntity.getEndTimeInfo();

						if (depGestEntity.isLockedGesturePhonAlignments()) {

							GestureChainedEvent value = depGestEntity.getTextValue();
							startTimeInfo = value.getStartTimeInfo();
							endTimeInfo = value.getEndTimeInfo();
						}

						SS3Entity ent = GestureOrientationEntity.createSS3EntityOrientation(domOrientationImgs, startTimeInfo, endTimeInfo);
						depOrientationEntity.resetEntity(ent);
					} else {
						dhEntity = depGestEntity.getDependentHandEntity();
						/*
						 * if (dhEntity == null)
						 * ???? not sure how it would be, if handshapes and orientations must be selected together
						 */

						dOEntity = GestureOrientationEntity.createGestureOrientationEntity(bean, domOrientationImgs, dhEntity,
								domOrientationWrapper.getGestureOrientationField());

						domOrientationWrapper.getGestureOrientationField().addGestureOrientationEntity(dOEntity);
						depGestEntity.setDependentOrientationEntity(dOEntity);

						dOEntity.setRefGestureEntity(depGestEntity);
						depGestEntity.setLockedGesturePhonAlignments(true);
						dOEntity.setLockedGesturePhonAlignments(true);
					}
				}				
			}
		} else {
			// delete handshapes and orientations
			if(fieldID.equals(Util.DOM_GESTURE_FIELD_ID)) {
				if(handEntity != null) {
					domHandWrapper.getField().deleteEntity(handEntity);
				}

				if(handShapeEntity != null) {
					domHandShapeWrapper.getGestureHandShapeField().deleteEntity(handShapeEntity);
				}

				if (orientationEntity != null) {
					domOrientationWrapper.getGestureOrientationField().deleteEntity(orientationEntity);
				}

				entity.setDependentHandEntity(null);
				entity.setDependentHandShapeEntity(null);
				entity.setDependentOrientationEntity(null);
			} else if(fieldID.equals(Util.NDOM_GESTURE_FIELD_ID)) {
				if(depHandEntity != null) {
					domHandWrapper.getField().deleteEntity(depHandEntity);
				}
				if(depHandShapeEntity != null) {
					domHandShapeWrapper.getGestureHandShapeField().deleteEntity(depHandShapeEntity);
				}
				if (depOrientationEntity != null) {
					domOrientationWrapper.getGestureOrientationField().deleteEntity(depOrientationEntity);
				}

				if(depGestEntity != null) {
					depGestEntity.setDependentHandEntity(null);
					depGestEntity.setDependentHandShapeEntity(null);
					depGestEntity.setDependentOrientationEntity(null);
				}
			}
		}

		if(!ndomHndShapeImgs.isEmpty() || !ndomOrientationImgs.isEmpty()) {
			// add/update handshapes on right hand
			if(fieldID.equals(Util.NDOM_GESTURE_FIELD_ID)) {
				if(handEntity != null) {
					handEntity.getTextValue().setText(entity.getText());
					//					ndhEntity = handEntity;
					//				} else {
					//					// add entity to Right Hand field
					//					ndhEntity = addHandEntity(ndomHandWrapper, entity, segmentPanel);
					//					entity.setDependentHandEntity(ndhEntity);
					//					ndhEntity.setLockedGesturePhonAlignments(true);
				}

				if (!ndomHndShapeImgs.isEmpty()) {
					if(handShapeEntity != null) {
						Time startTimeInfo = handShapeEntity.getStartTimeInfo();
						Time endTimeInfo = handShapeEntity.getEndTimeInfo();

						if (entity.isLockedGesturePhonAlignments()) {
							GestureChainedEvent value = entity.getTextValue();
							startTimeInfo = value.getStartTimeInfo();
							endTimeInfo = value.getEndTimeInfo();
						}

						SS3Entity ent = GestureHandShapeEntity.createSS3Entity(ndomHndShapeImgs, startTimeInfo, endTimeInfo);
						handShapeEntity.resetEntity(ent);
					} else {
						// add entity to Right Hand field
						ndhEntity = addHandEntity(ndomHandWrapper, entity, segmentPanel);

						ndHshEntity = GestureHandShapeEntity.createGestureHandShapeEntity(bean, ndomHndShapeImgs, ndhEntity,
								ndomHandShapeWrapper.getGestureHandShapeField());

						ndomHandShapeWrapper.getGestureHandShapeField().addGestureHandShapeEntity(ndHshEntity);	
						entity.setDependentHandEntity(ndhEntity);					
						entity.setDependentHandShapeEntity(ndHshEntity);

						ndHshEntity.setRefGestureEntity(entity);
						entity.setLockedGesturePhonAlignments(true);		
						ndhEntity.setLockedGesturePhonAlignments(true);				
						ndHshEntity.setLockedGesturePhonAlignments(true);
					}
				}

				if (!ndomOrientationImgs.isEmpty()) {
					if (orientationEntity != null) {
						Time startTimeInfo = orientationEntity.getStartTimeInfo();
						Time endTimeInfo = orientationEntity.getEndTimeInfo();

						if (entity.isLockedGesturePhonAlignments()) {
							GestureChainedEvent value = entity.getTextValue();
							startTimeInfo = value.getStartTimeInfo();
							endTimeInfo = value.getEndTimeInfo();
						}

						SS3Entity ent = GestureOrientationEntity.createSS3EntityOrientation(ndomOrientationImgs, startTimeInfo, endTimeInfo);
						orientationEntity.resetEntity(ent);
					} else {
						ndhEntity = entity.getDependentHandEntity();
						/*
						 * if null ....?
						 */
						ndOEntity = GestureOrientationEntity.createGestureOrientationEntity(bean, ndomOrientationImgs, ndhEntity,
								ndomOrientationWrapper.getGestureOrientationField());

						ndomOrientationWrapper.getGestureOrientationField().addGestureOrientationEntity(ndOEntity);
						entity.setDependentHandEntity(ndhEntity);
						entity.setDependentOrientationEntity(ndOEntity);		

						ndOEntity.setRefGestureEntity(entity);
						entity.setLockedGesturePhonAlignments(true);
						ndhEntity.setLockedGesturePhonAlignments(true);
						ndOEntity.setLockedGesturePhonAlignments(true);
					}
				}
			} else if(fieldID.equals(Util.DOM_GESTURE_FIELD_ID)) {
				// assert ndEntity != null;
				if(depHandEntity != null) {
					depHandEntity.getTextValue().setText(entity.getText());
					//					ndhEntity = ndHandEntity;
					//				} else {
					//					// add entity to Right Hand field
					//					ndhEntity = addHandEntity(ndomHandWrapper, depGlsEntity, segmentPanel);
					//					if (depGlsEntity != null) {
					//						depGlsEntity.setDependentHandEntity(ndhEntity);
					//					}
					//					ndhEntity.setLockedGesturePhonAlignments(true);
				}

				if (!ndomHndShapeImgs.isEmpty()) {
					if(depHandShapeEntity != null) {
						Time startTimeInfo = depHandShapeEntity.getStartTimeInfo();
						Time endTimeInfo = depHandShapeEntity.getEndTimeInfo();

						if (depGestEntity.isLockedGesturePhonAlignments()) {
							GestureChainedEvent value = depGestEntity.getTextValue();
							startTimeInfo = value.getStartTimeInfo();
							endTimeInfo = value.getEndTimeInfo();
						}

						SS3Entity ent = GestureHandShapeEntity.createSS3Entity(ndomHndShapeImgs, startTimeInfo, endTimeInfo);
						depHandShapeEntity.resetEntity(ent);
					} else {
						// add entity to Right Hand field
						ndhEntity = addHandEntity(ndomHandWrapper, depGestEntity, segmentPanel);

						ndHshEntity = GestureHandShapeEntity.createGestureHandShapeEntity(bean, ndomHndShapeImgs, ndhEntity,
								ndomHandShapeWrapper.getGestureHandShapeField());

						ndomHandShapeWrapper.getGestureHandShapeField().addGestureHandShapeEntity(ndHshEntity);
						if(depGestEntity != null) {						
							depGestEntity.setDependentHandShapeEntity(ndHshEntity);
							ndHshEntity.setRefGestureEntity(depGestEntity);
							depGestEntity.setDependentHandEntity(ndhEntity);
							depGestEntity.setLockedGesturePhonAlignments(true);
						}
						ndhEntity.setLockedGesturePhonAlignments(true);
						ndHshEntity.setLockedGesturePhonAlignments(true);
					}
				}

				if (!ndomOrientationImgs.isEmpty()) {
					if(depOrientationEntity != null) {
						Time startTimeInfo = depOrientationEntity.getStartTimeInfo();
						Time endTimeInfo = depOrientationEntity.getEndTimeInfo();

						if (depGestEntity.isLockedGesturePhonAlignments()) {
							GestureChainedEvent value = depGestEntity.getTextValue();
							startTimeInfo = value.getStartTimeInfo();
							endTimeInfo = value.getEndTimeInfo();
						}

						SS3Entity ent = GestureOrientationEntity.createSS3EntityOrientation(ndomOrientationImgs, startTimeInfo, endTimeInfo);
						depOrientationEntity.resetEntity(ent);
					} else {
						ndhEntity = depGestEntity.getDependentHandEntity();
						/*
						 * if null....?
						 */
						depOrientationEntity = GestureOrientationEntity.createGestureOrientationEntity(bean, ndomOrientationImgs, ndhEntity,
								ndomOrientationWrapper.getGestureOrientationField());

						ndomOrientationWrapper.getGestureOrientationField().addGestureOrientationEntity(depOrientationEntity);
						if(depGestEntity != null) {						
							depGestEntity.setDependentHandEntity(ndhEntity);
							depGestEntity.setDependentOrientationEntity(depOrientationEntity);
							depOrientationEntity.setRefGestureEntity(depGestEntity);
							depGestEntity.setLockedGesturePhonAlignments(true);
						}
						ndhEntity.setLockedGesturePhonAlignments(true);
						depOrientationEntity.setLockedGesturePhonAlignments(true);
					}
				}
			}
		} else {
			// delete handshapes and orientations
			if(fieldID.equals(Util.NDOM_GESTURE_FIELD_ID)) {
				if(handEntity != null) {
					ndomHandWrapper.getField().deleteEntity(handEntity);
				}

				if(handShapeEntity != null) {
					ndomHandShapeWrapper.getGestureHandShapeField().deleteEntity(handShapeEntity);
				}

				if (orientationEntity != null) {
					ndomOrientationWrapper.getGestureOrientationField().deleteEntity(orientationEntity);
				}

				entity.setDependentHandEntity(null);
				entity.setDependentHandShapeEntity(null);
				entity.setDependentOrientationEntity(null);
			} else if(fieldID.equals(Util.DOM_GESTURE_FIELD_ID)) {
				if(depHandEntity != null) {
					ndomHandWrapper.getField().deleteEntity(depHandEntity);
				}
				if(depHandShapeEntity != null) {
					ndomHandShapeWrapper.getGestureHandShapeField().deleteEntity(depHandShapeEntity);
				}
				if(depOrientationEntity != null) {
					ndomOrientationWrapper.getGestureOrientationField().deleteEntity(depOrientationEntity);
				}

				if(depGestEntity != null) {
					depGestEntity.setDependentHandEntity(null);
					depGestEntity.setDependentHandShapeEntity(null);
					depGestEntity.setDependentOrientationEntity(null);
				}
			}
		}
		
		if (entity != null) {
			if (entity.getDependentHandEntity() != null) {
				entity.getDependentHandEntity().setIncompleteGesture(entity.getIncompleteGesture());
				entity.getDependentHandEntity().setShowUniqueNumber(entity.getShowUniqueNumber());
				entity.getDependentHandEntity().setUniqueNumber(entity.getUniqueNumber());
			}
		}
		
		if (depGestEntity != null) {
			if (depGestEntity.getDependentHandEntity() != null) {
				depGestEntity.getDependentHandEntity().setIncompleteGesture(depGestEntity.getIncompleteGesture());
				depGestEntity.getDependentHandEntity().setShowUniqueNumber(entity.getShowUniqueNumber());
				depGestEntity.getDependentHandEntity().setUniqueNumber(entity.getUniqueNumber());
			}
		}
	}

	private GestureChainedEventsEntity addHandEntity(GestureDomNdomHandFieldWrapper wrp,
											  GestureEventsEntity gestEntity, SignStreamSegmentPanel panel) {

		GestureChainedEvent value = gestEntity.getTextValue();
//		GestureChainedEvent initHold = glsEntity.getInitialHold();
//		GestureChainedEvent finalHold = glsEntity.getFinalHold();

		Time startTimeInfo; // = null;
		Time endTimeInfo; // = null;

		gestEntity.setLockedGesturePhonAlignments(true);

//		if (initHold != null) {
//			startTimeInfo = initHold.getStartTimeInfo();
//		} else {
			startTimeInfo = value.getStartTimeInfo();
//		}

//		if (finalHold != null) {
//			endTimeInfo = finalHold.getEndTimeInfo();
//		} else {
			endTimeInfo = value.getEndTimeInfo();
//		}

		GestureChainedEventsCollection collection = new GestureChainedEventsCollection();

		GestureEvent gEvent = new GestureEvent(panel);
		gEvent.setStartTimeInfo(startTimeInfo);
		gEvent.setEndTimeInfo(endTimeInfo);
		gEvent.setText(value.getText());
		collection.setTextValueEvent(gEvent);

		GestureChainedEventsEntity handEntity = new GestureChainedEventsEntity(collection,
																 panel, wrp.getField());

		handEntity.setID(Util.getUniqueNumber());
		handEntity.setField(wrp.getField());
		handEntity.updateParentEntity();

		wrp.addEventsEntity(handEntity);
		handEntity.setRefEntityId(gestEntity.getID());

		handEntity.setLockedGesturePhonAlignments(true);
		return handEntity;
	}

	/**
	 * To be called by the sign bank panel exclusively.
	 * Set the main gloss text and variant text to the labels passed in.
	 * @param mainGestureLabel The main gloss label from the sign bank panel results list
	 * @param variantLabel The variant label from the sign bank panel results list
	 */
	public void populateMainGestureAndVariantLabels(String mainGestureLabel, String variantLabel) {
		if (mainGestureLabel == null || variantLabel == null)
			return;

		primaryEntryField.setText(mainGestureLabel.trim());
		gestureLbField.setText(variantLabel.trim());
	}

	@Override
	public void actionPerformed(ActionEvent ae) {
		String str = ae.getActionCommand();

		switch (Integer.parseInt(str)) {
			case ENTER_BYPASS:
				boolean success = saveChanges();
				if (!success)
					return;
				
				view.update();
				view.getSignStreamSegmentPanel().getUtteranceView().getNonmanualFieldsView().getCSFieldDialog()
                        .getCSFieldPanel().showAllFieldsCurrentUtterance();
				SS3Singleton.getSignStreamApplication().repaint();
				parent.setVisible(false);
				System.gc();
				break;
			case ENTER:

//				SignBankCollection collection = null;
//				String mainGestureStr = "", trimmedVariantStr = "", originalVariantStr = "";
//
//				// first, before closing out, check that the user didn't edit the labels of main gloss & variant - to ensure that those labels are in the SB
//				if (hshPanel.isLexical() || hshPanel.isNumber()) {
//					collection = SS3Singleton.getSignStreamApplication().getSignBankCollection();
//
//					mainGestureStr = primaryEntryField.getText().trim();
//					originalVariantStr = variantField.getText().trim();
//					trimmedVariantStr = Util.trimAsterisksAndPlusSigns(originalVariantStr);
//					// check first if this sign DOES NOT exist in collection already - we will disallow if so
//					SignBankVariant matchingVariant = collection.contains(trimmedVariantStr);
//					SignBankVariant matchingOriginalVariant = collection.contains(originalVariantStr);
//					if (matchingVariant == null && matchingOriginalVariant == null) {
//						String warningDialogText =
//								"Sign was not found in the sign bank.\nPlease either search for an existing sign, or add a new one.";
//						String warningTitleText = "Sign Not Found";
//						int optionType = JOptionPane.YES_NO_OPTION;
//						int messageType = JOptionPane.ERROR_MESSAGE;
//						String options[] = {"OK"};
//
//						try {
//							JOptionPane.showOptionDialog(this,
//														 warningDialogText,
//														 warningTitleText,
//														 optionType,
//														 messageType,
//														 null,
//														 options,
//														 options[0]);
//						} catch (HeadlessException he) {
//							System.out.println("");
//						}
//
//						return;
//					} else if (matchingOriginalVariant == null) {
//						//addToSignBank(mainGestureStr, untrimmedVariantStr);
//
//						// reset this variant in the case we just added to sign bank
//						// (inside addToSignBank() the sign bank itself got re-parsed into `collection`)
//						//matchingUntrimmedVariant = collection.contains(mainGestureStr, untrimmedVariantStr);
//						saveChanges();
//					} else {
//						saveChanges(matchingOriginalVariant);
//					}
//
//
//				} else {
//					saveChanges();
//				}
				
				if (hshPanel.isTwoHanded()) {
					ArrayList<HandShapeImage> rhImages = hshPanel.getSelectedDomHandshapesPane().getHandshapes();
					ArrayList<HandShapeImage> lhImages = hshPanel.getSelectedNdomHandshapesPane().getHandshapes();
					ArrayList<OrientationImage> rOImages =hshPanel.getSelectedDomHandshapesPane().getOrientations();
					ArrayList<OrientationImage> lOImages = hshPanel.getSelectedNdomHandshapesPane().getOrientations();
					
					boolean handSizeNotMatch = rhImages.size() != lhImages.size();
					boolean ornSizeNotMatch = rOImages.size() != lOImages.size();
					
					if ( (handSizeNotMatch && (rhImages.size() == 0 || lhImages.size() == 0) )
							|| (ornSizeNotMatch && (rOImages.size() == 0 || lOImages.size() == 0) )  ) {
						// user must select any number of handshape and orientation images for two-handed, unless empty
						SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.GESTURE_EMPTY_HANDSHAPES_ORIENTATIONS);
						break;
					}
				}

				success = saveChanges();
				if (!success)
					return;
				
				view.update();
				view.getSignStreamSegmentPanel().getUtteranceView().getNonmanualFieldsView().getCSFieldDialog()
                        .getCSFieldPanel().showAllFieldsCurrentUtterance();
				SS3Singleton.getSignStreamApplication().repaint();
				parent.setVisible(false);
				System.gc();
				break;
			case CANCEL:
				gstPanel.update();
				parent.setVisible(false);
				break;
		}

		checkSignTypeAndUpdateSignBankFunctionality();
	}

	public void checkSignTypeAndUpdateSignBankFunctionality() {
		if (hshPanel.isLexical() || hshPanel.isNumber() || hshPanel.isLoan())
			enableSignBankFunctionality(true);
		else if (hshPanel.isFingerspelled() || hshPanel.isGesture() || hshPanel.isClassifier())
			enableSignBankFunctionality(false);
	}

	public void enableSignBankFunctionality(boolean enabled) {
		primaryEntryField.setEnabled(enabled);
		addNewSign.setEnabled(enabled);
	}

	public boolean isOneHandedSelected() {
		return hshPanel.isOneHandedSelected();
	}

	public boolean isTwoHandedSelected() {
		return hshPanel.isTwoHandedSelected();
	}

	public boolean isDominantHandRight() {
		return Util.RIGHT_HAND.equals(dominantHand);
	}

	public boolean isCurrentGestureDominant() {
		return wrapper.getGestureField().getFieldID().equals(Util.DOM_GESTURE_FIELD_ID);
	}

	public String getDominantHand() {
		return dominantHand;
	}

	public JDialog getParentDialog() {
		return parent;
	}

	public JButton getEnterButton() {
		return enter;
	}

	public GestureEventsEntity getCurrentGestureEntity() {
		return currentGestureEntity;
	}
	
	public SS3GlossWindowSegment getCurrentSS3GlossWindowSegment() {
		return currentGlossWindowSegment;
	}

	public GestureTypePanel getGestureTypePanel() {
		return gstPanel;
	}
	
	public GestureNRelatedView getGestureNRelatedView() {
		return this.view;
	}
}

class LoadedProperties {

	private String gestText = "";

	private boolean fingerspelled = false;
	private boolean loan = false;
	private boolean number = false;
	private boolean lexical = false;
	private boolean classifier = false;
	private boolean gesture = false;
	private boolean nameSign = false;
	private boolean twoHanded = false;
	private boolean oneFrameGesture = false;
	private boolean markedNumberOfHands = false;
	private boolean passiveBaseArm = false;

//	private int sameDifHandshapes = 0;
	private DomNdomHandshapesType sameDIfferentDomNdomHandshapes = DomNdomHandshapesType.SAME;
	private StartEndHandshapesType sameDifStartEndHandshapesL = StartEndHandshapesType.SAME;
	private StartEndHandshapesType sameDifStartEndHandshapesR = StartEndHandshapesType.SAME;
	private StartEndHandshapesType sameDifStartEndHandshapes = StartEndHandshapesType.SAME;
	
	private ArrayList<HandShapeImage> rightHandSelectedHandshapes = new ArrayList<HandShapeImage>();
	private ArrayList<HandShapeImage> leftHandSelectedHandshapes = new ArrayList<HandShapeImage>();
	
	private ArrayList<OrientationImage> rightHandSelectedOrientations = new ArrayList<OrientationImage>();
	private ArrayList<OrientationImage> leftHandSelectedOrientations = new ArrayList<OrientationImage>();
	
	private GestureTypeEntity gestureTypeEntity = null;
	
//	public int getSameDifHandshapes() {
//		return sameDifHandshapes;
//	}
//	public void setSameDifHandshapes(int sameDifHandshapes) {
//		this.sameDifHandshapes = sameDifHandshapes;
//	}
	public DomNdomHandshapesType getSameDIfferentDomNdomHandshapes() {
		return sameDIfferentDomNdomHandshapes;
	}
	public void setSameDIfferentDomNdomHandshapes(
			DomNdomHandshapesType sameDIfferentDomNdomHandshapes) {
		this.sameDIfferentDomNdomHandshapes = sameDIfferentDomNdomHandshapes;
	}

	public void setSameDifStartEndHandshapes(
			StartEndHandshapesType sameDifStartEndHandshapes) {
		this.sameDifStartEndHandshapes = sameDifStartEndHandshapes;
	}
	
	public StartEndHandshapesType getSameDifStartEndHandshapes() {
		return sameDifStartEndHandshapes;
	}
	
	public StartEndHandshapesType getSameDifStartEndHandshapesL() {
		return sameDifStartEndHandshapesL;
	}
	public void setSameDifStartEndHandshapesL(StartEndHandshapesType sameDifStartEndHandshapesL) {
		this.sameDifStartEndHandshapesL = sameDifStartEndHandshapesL;
	}
	public StartEndHandshapesType getSameDifStartEndHandshapesR() {
		return sameDifStartEndHandshapesR;
	}
	public void setSameDifStartEndHandshapesR(StartEndHandshapesType sameDifStartEndHandshapesR) {
		this.sameDifStartEndHandshapesR = sameDifStartEndHandshapesR;
	}
	public boolean isFingerspelled() {
		return fingerspelled;
	}
	public void setFingerspelled(boolean fingerspelled) {
		this.fingerspelled = fingerspelled;
	}
	public boolean isLoan() {
		return loan;
	}
	public void setLoan(boolean loan) {
		this.loan = loan;
	}
	public boolean isNumber() {
		return number;
	}
	public void setNumber(boolean number) {
		this.number = number;
	}
	public boolean isLexical() {
		return lexical;
	}
	public void setLexical(boolean lexical) {
		this.lexical = lexical;
	}
	public boolean isClassifier() {
		return classifier;
	}
	public void setClassifier(boolean classifier) {
		this.classifier = classifier;
	}
	public boolean isGesture() {
		return gesture;
	}
	public void setGesture(boolean gesture) {
		this.gesture = gesture;
	}
	public boolean isNameSign() {
		return nameSign;
	}
	public void setNameSign(boolean nameSign) {
		this.nameSign = nameSign;
	}
	public boolean isTwoHanded() {
		return twoHanded;
	}
	public void setTwoHanded(boolean twoHanded) {
		this.twoHanded = twoHanded;
	}
	public boolean isOneFrameGesture() {
		return oneFrameGesture;
	}
	public void setOneFrameGesture(boolean oneFrameGesture) {
		this.oneFrameGesture = oneFrameGesture;
	}
	public boolean isMarkedNumberOfHands() {
		return markedNumberOfHands;
	}
	public void setMarkedNumberOfHands(boolean markedNumberOfHands) {
		this.markedNumberOfHands = markedNumberOfHands;
	}
	public boolean isPassiveBaseArm() {
		return passiveBaseArm;
	}
	public void setPassiveBaseArm(boolean passiveBaseArm) {
		this.passiveBaseArm = passiveBaseArm;
	}
	public ArrayList<HandShapeImage> getRightHandSelectedHandshapes() {
		return rightHandSelectedHandshapes;
	}
	public void setRightHandSelectedHandshapes(
			ArrayList<HandShapeImage> rightHandSelectedHandshapes) {
		this.rightHandSelectedHandshapes.clear();
		this.rightHandSelectedHandshapes.addAll(rightHandSelectedHandshapes);
	}
	public ArrayList<HandShapeImage> getLeftHandSelectedHandshapes() {
		return leftHandSelectedHandshapes;
	}
	public void setLeftHandSelectedHandshapes(
			ArrayList<HandShapeImage> leftHandSelectedHandshapes) {
		this.leftHandSelectedHandshapes.clear();
		this.leftHandSelectedHandshapes.addAll(leftHandSelectedHandshapes);
	}
	public ArrayList<OrientationImage> getRightHandSelectedOrientations() {
		return rightHandSelectedOrientations;
	}
	public void setRightHandSelectedOrientations(
			ArrayList<OrientationImage> rightHandSelectedOrientations) {
		this.rightHandSelectedOrientations.clear();
		this.rightHandSelectedOrientations.addAll(rightHandSelectedOrientations);
	}
	public ArrayList<OrientationImage> getLeftHandSelectedOrientations() {
		return leftHandSelectedOrientations;
	}
	public void setLeftHandSelectedOrientations(
			ArrayList<OrientationImage> leftHandSelectedOrientations) {
		this.leftHandSelectedOrientations.clear();
		this.leftHandSelectedOrientations.addAll(leftHandSelectedOrientations);
	}
	public String getGestText() {
		return gestText;
	}
	public void setGestText(String gloss) {
		this.gestText = gloss;
	}
	public GestureTypeEntity getGestureTypeEntity() {
		return gestureTypeEntity;
	}
	public void setGestureTypeEntity(GestureTypeEntity gestureTypeEntity) {
		this.gestureTypeEntity = gestureTypeEntity;
	}
	public void reset() {
		this.gestText = "";
		this.fingerspelled = false;
		this.loan = false;
		this.number = false;
		this.lexical = false;
		this.classifier = false;
		this.gesture = false;
		this.nameSign = false;
		this.twoHanded = false;
		this.oneFrameGesture = false;
		this.markedNumberOfHands = false;
		this.passiveBaseArm = false;
//		this.sameDifHandshapes = 0;
		this.sameDIfferentDomNdomHandshapes = DomNdomHandshapesType.SAME;
		this.sameDifStartEndHandshapesL = StartEndHandshapesType.SAME;
		this.sameDifStartEndHandshapesR = StartEndHandshapesType.SAME;

		rightHandSelectedHandshapes.clear();
		leftHandSelectedHandshapes.clear();
		
		rightHandSelectedOrientations.clear();
		leftHandSelectedOrientations.clear();
	}
}
