package edu.bu.signstream.grepresentation.fields.gestureField.dialog.handShapes;

import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ArrayList;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;

import edu.bu.signstream.common.util.ErrorMessages;
import edu.bu.signstream.common.util.Util;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.grepresentation.fields.gestureField.dialog.GestureHandShapeBean;
import edu.bu.signstream.grepresentation.fields.gestureField.dialog.GestureHandShapePanel;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.HandShapeBean;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.HandShapePanel;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.handshapeTypes.StartEndHandshapesType;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.HandShapeImage;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.ui.ButtonPanel;

public class GestureDblHandshapePalette extends JPanel implements ActionListener {
	private GestureHandShapesPaletteFormBean rhFormBean = null;
	private GestureHandShapesPaletteFormBean lhFormBean = null;
	private GestureHandShapeBean bean = null;
	private GestureGeneralHandshapePalette rPalette = null;
	private GestureGeneralHandshapePalette lPalette = null;
	private JDialog dialog = null;
    private SS3CodingScheme scheme;
    private GestureHandShapePanel hsPanel;

//	//private JComboBox templatesCb = new JComboBox();
//   private JPanel languagePanel = null;

	private JButton enter = new JButton("Enter");
	private JButton cancel = new JButton("Cancel");

	private final int ENTER = 0;
	private final int CANCEL = 1;

	public GestureDblHandshapePalette(
		GestureHandShapesPaletteFormBean rhFormBean,
		GestureHandShapesPaletteFormBean lhFormBean,
		GestureHandShapeBean bean, SS3CodingScheme scheme, 
		JDialog dialog, GestureHandShapePanel hsPanel) {

		this.rhFormBean = rhFormBean;
		this.lhFormBean = lhFormBean;
		this.bean = bean;
		this.dialog = dialog;
		this.scheme = scheme;
		this.hsPanel = hsPanel;
		initUI(scheme);

		lPalette.setPalette(0);
		rPalette.setPalette(0);

		enter.setActionCommand("" + ENTER);
		cancel.setActionCommand("" + CANCEL);
		enter.addActionListener(this);
		cancel.addActionListener(this);

		enter.setSelected(true);
	}
   
   private JPanel createLanguageSelectionPanel() {
      
//      if(languagePanel != null)
//         return languagePanel;
      
//		String[] lstr = new String[1];
//		lstr[0] = "American Sign Language";
//		JComboBox l = new JComboBox(lstr);		

		String[] tstr1 = new String[5];
		tstr1[0] = "Basic Gestures";
		tstr1[1] = "ASL - All";
		tstr1[2] = "ASL - Letters";
		tstr1[3] = "ASL - Numbers";
		tstr1[4] = "ASL - Unmarked";
		final JComboBox t1 = new JComboBox(tstr1);
		
		t1.setSelectedIndex(rhFormBean.getPaletteID());
		//rPalette.setPalett(1);	
		
		t1.addItemListener(new ItemListener() {
			@Override
			public void itemStateChanged(ItemEvent itemEvent) {
//				invalidate();
				int selectedIndex = t1.getSelectedIndex();
				rPalette.setPalette(selectedIndex);
//				revalidate();
			}
		});

		String[] tstr2 = new String[5];
		tstr2[0] = "Basic Gestures";
		tstr2[1] = "ASL - All";
		tstr2[2] = "ASL - Letters";
		tstr2[3] = "ASL - Numbers";
		tstr2[4] = "ASL - Unmarked";
		final JComboBox t2 = new JComboBox(tstr2);
		
		t2.setSelectedIndex(lhFormBean.getPaletteID());
		
		t2.addItemListener(new ItemListener() {
		      @Override
		      public void itemStateChanged(ItemEvent itemEvent) {
//		    	  invalidate();
		    	  int selectedIndex = t2.getSelectedIndex();
		    	  lPalette.setPalette(selectedIndex);
//		    	  revalidate();
		      }
		});

		String[] ostr1 = new String[1];
		ostr1[0] = "Orientations";
		final JComboBox o1 = new JComboBox(ostr1);
		
		o1.setSelectedIndex(0);
		//rPalette.setPalett(1);	
		
		o1.addItemListener(new ItemListener() {
			@Override
			public void itemStateChanged(ItemEvent itemEvent) {
//				invalidate();
				int selectedIndex = o1.getSelectedIndex();
				rPalette.setOrientationPalette(selectedIndex);
//				revalidate();
			}
		});

		String[] ostr2 = new String[1];
		ostr2[0] = "Orientations";
		final JComboBox o2 = new JComboBox(ostr2);
		
		o2.setSelectedIndex(0);
		
		o2.addItemListener(new ItemListener() {
		      @Override
		      public void itemStateChanged(ItemEvent itemEvent) {
//		    	  invalidate();
		    	  int selectedIndex = o2.getSelectedIndex();
		    	  lPalette.setOrientationPalette(selectedIndex);
//		    	  revalidate();
		      }
		});

      ButtonPanel bp = new ButtonPanel();
//      bp.add(new JLabel("Palettes: "));
//      bp.add(l);
      bp.add(new JLabel(" Right Hand: "));
      bp.add(t1);
      bp.add(new JLabel(" Left Hand: "));
      bp.add(t2);
      
      ButtonPanel bp2 = new ButtonPanel();
      bp2.add(new JLabel(" Right Orientations: " ));
      bp2.add(o1);
      bp2.add(new JLabel(" Left Orientations: " ));
      bp2.add(o2);
      
      JPanel p = null;
      p = new JPanel(new BorderLayout());
      p.add(bp, BorderLayout.NORTH);
      p.add(bp2, BorderLayout.SOUTH);

      return p;
   }

	private void initUI(SS3CodingScheme scheme) {
		GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();
		setLayout(gbl);
      
      JPanel languagePanel = createLanguageSelectionPanel();
            gbc.insets = new Insets(0, 0, 0, 0);		// GD 2021-03-08: changed this from Insets(15, 0, 0, 0)
            gbc.anchor = GridBagConstraints.CENTER;
            gbc.gridheight = 1;
            gbc.gridwidth = GridBagConstraints.REMAINDER;
            add(languagePanel, gbc);       
      
       boolean rhSelected = rhFormBean.isRightHandSelected();

	  int all = 0;
      if(!rhSelected)
		all = 3;
       
       rPalette =
			new GestureGeneralHandshapePalette(
				rhFormBean.getValues(),
				rhFormBean.getSelectedHshImages(),
				rhFormBean.getSelectedOrientationImages(), scheme, all, hsPanel);

		rPalette.setBorder(new TitledBorder(rhFormBean.getTitle()));
		rPalette.setPalette(rhFormBean.getPaletteID());
//		rPalette.setMinimumSize(rPalette.getPreferredSize());

		int unm = 3;
		if(!rhSelected)
			unm = 0;
		
		//
		//System.err.println("rhSelected = " + rhSelected + ", all = " + all + ", unm = " + unm);
		//
		
		lPalette =
			new GestureGeneralHandshapePalette(
				lhFormBean.getValues(),
				lhFormBean.getSelectedHshImages(),
				lhFormBean.getSelectedOrientationImages(), scheme, unm, hsPanel);

		lPalette.setBorder(new TitledBorder(lhFormBean.getTitle()));
		lPalette.setPalette(lhFormBean.getPaletteID());
//		lPalette.setMinimumSize(lPalette.getPreferredSize());
		
		gbc.anchor = GridBagConstraints.WEST;
		gbc.gridwidth = 1;
		add(rPalette, gbc);

		//gbc.anchor = GridBagConstraints.NORTHWEST;
		add(Box.createHorizontalStrut(10));
		gbc.gridwidth = GridBagConstraints.REMAINDER;
		add(lPalette, gbc);

		ButtonPanel buttonPanel = new ButtonPanel();
		buttonPanel.add(cancel);
		buttonPanel.add(enter);

		gbc.anchor = GridBagConstraints.SOUTH;
		gbc.insets = new Insets(15, 0, 0, 0);
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.gridwidth = 7;
		add(buttonPanel, gbc);
	}

	@Override
	public void actionPerformed(ActionEvent ae) {
		String str = ae.getActionCommand();

		switch (Integer.parseInt(str)) {
			case ENTER :
				bean.setUpdated(true);

	            ArrayList<HandShapeImage> rhImages = new ArrayList<HandShapeImage>(getRightHandSelectedHandshapes());
	            ArrayList<HandShapeImage> lhImages =  new ArrayList<HandShapeImage>(getLeftHandSelectedHandshapes());
	            ArrayList<OrientationImage> rOImages = new ArrayList<OrientationImage>(getRightHandSelectedOrientations());
	            ArrayList<OrientationImage> lOImages =  new ArrayList<OrientationImage>(getLeftHandSelectedOrientations());
	            
				// first check if this is a one-frame gloss, and if it is then disallow anything more than one handshape in either hand
				if (hsPanel.isOneFrameGloss()) {
					if (rhImages.size() > 1 || lhImages.size() > 1) {
						SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.SELECT_GESTURE_HANDSHAPES_EXACTLY_ONE);
						break;
					}
				} else if ( (hsPanel.getSelectedSameDifStartEndHandshapesDom() == StartEndHandshapesType.DIFFERENT && rhImages.size() == 1)
							|| (hsPanel.getSelectedSameDifStartEndHandshapesNdom() == StartEndHandshapesType.DIFFERENT && lhImages.size() == 1) ) {
					// conversely, if this is not a one-frame gloss and you have dif start/end selected,
					// then disallow a selection of just one handshape in either hand
					SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.SELECT_GESTURE_HANDSHAPES_MULTIPLE);
					break;
				} else if ( (rhImages.size() != rOImages.size()) || (lhImages.size() != lOImages.size()) ) {
					// user must select the same number of handshape and orientation images
					SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.GESTURE_SELECT_HANDSHAPES_ORIENTATIONS);
					break;
				}
				
	            // if user only selected none-image for one of above lists - disallow
	            boolean onlyNoneImage = false;
	            onlyNoneImage = onlyNoneImage || 
            		(rhImages.size() > 0 && rhImages.stream().allMatch(
            				img -> img.getSS3FieldValue().getIid().equalsIgnoreCase(Util.DNI_HANDSHAPE_IMAGE_ID))) || 
            		(lhImages.size() > 0 && lhImages.stream().allMatch(
            				img -> img.getSS3FieldValue().getIid().equalsIgnoreCase(Util.DNI_HANDSHAPE_IMAGE_ID))) || 
            		(rOImages.size() > 0 && rOImages.stream().allMatch(
            				img -> img.getSS3FieldValue().getIid().equalsIgnoreCase(Util.DNI_ORIENTATION_IMAGE_ID))) || 
            		(lOImages.size() > 0 && lOImages.stream().allMatch(
            				img -> img.getSS3FieldValue().getIid().equalsIgnoreCase(Util.DNI_ORIENTATION_IMAGE_ID)));
	            
	            if (onlyNoneImage) {
					SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.GESTURE_CANNOT_SELECT_ONLY_NONE);
	            	break;
	            }

				if (hsPanel.getAssociatedFieldsPanel().isDominantHandRight()) {
					hsPanel.updateSelectedHandshapesPanels(rhImages, lhImages, rOImages, lOImages);
				} else {
					hsPanel.updateSelectedHandshapesPanels(lhImages, rhImages, lOImages, rOImages);
				}

				dialog.dispose();
				break;
			case CANCEL:
				dialog.dispose();
				break;
		}
	}

	public ArrayList<HandShapeImage> getRightHandSelectedHandshapes() {
		return rPalette.getSelectedHandshapes();
	}

	public ArrayList<HandShapeImage> getLeftHandSelectedHandshapes() {
		return lPalette.getSelectedHandshapes();
	}
	
	public ArrayList<OrientationImage> getRightHandSelectedOrientations() {
		return rPalette.getSelectedOrientations();
	}

	public ArrayList<OrientationImage> getLeftHandSelectedOrientations() {
		return lPalette.getSelectedOrientations();
	}
}