package edu.bu.signstream.grepresentation.fields.gestureField.dialog.handShapes;

import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JViewport;
import javax.swing.ScrollPaneConstants;

import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3FieldValue;
import edu.bu.signstream.grepresentation.fields.gestureField.dialog.GestureHandShapePanel;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.HandShapePanel;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.LettersHandshapesPalette;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.NumbersHandshapesPallete;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.PaletteUtil;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.SortedHandshapesPalette;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.UnmarkedHandshapesPalette;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.HandShapeImage;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.SelectedHandshapesPanel;
import edu.bu.signstream.ui.ButtonPanel;

public class GestureGeneralHandshapePalette extends JPanel implements ActionListener {

	private static final long serialVersionUID = 1L;
	
	private SS3CodingScheme scheme;
	private HashMap<String, SS3FieldValue> hm = new HashMap<String, SS3FieldValue>();
	private SelectedGestureHandshapesPanel panel = null;
	private OrientationPalette orientationPanel = null;
	
	private JPanel client = null;
	protected JScrollPane sp = null;

	private JButton clean = new JButton("Clear");
	
	private JPanel iconPanel = new JPanel();
	
	private ArrayList<SS3FieldValue> values = new ArrayList<SS3FieldValue>();
	private ArrayList<HandShapeImage> selectedHshImages = new ArrayList<HandShapeImage>();
	private ArrayList<OrientationImage> selectedOrientationImages = new ArrayList<OrientationImage>();
	
	private PaletteUtil paletteUtil = null;
	
	private final static String GESTURE_PANEL_INDEX = "0";
	private final static String ALL_PANEL_INDEX = "1";
	private final static String LETTERS_PANEL_INDEX = "2";
	private final static String NUMBERS_PANEL_INDEX = "3";
	private final static String UNMARKED_PANEL_INDEX = "4";
	
	private GestureHandshapesPalette gesturePanel = null;
	private SortedHandshapesPalette allPanel = null;
	private LettersHandshapesPalette lettersPanel = null;
	private NumbersHandshapesPallete numbersPanel = null;
	UnmarkedHandshapesPalette unmarkedPanel = null;
	

	public GestureGeneralHandshapePalette(ArrayList<SS3FieldValue> values, ArrayList<HandShapeImage> selectedHshImages, ArrayList<OrientationImage> selectedOrientationImages, SS3CodingScheme scheme, int selectedIndex, GestureHandShapePanel hsPanel) {
		this.scheme = scheme;
		this.values = values;
		this.selectedHshImages.addAll(selectedHshImages);
		this.selectedOrientationImages.addAll(selectedOrientationImages);
		
		if (values == null) {
			panel = new SelectedGestureHandshapesPanel(scheme);
		} else {
			panel = new SelectedGestureHandshapesPanel(selectedHshImages, selectedOrientationImages, scheme, hsPanel);
		}

		this.paletteUtil = new PaletteUtil(scheme, panel);
        
        iconPanel = new JPanel();
//        iconPanel.setLayout(new CardLayout());
//        
//        gesturePanel = new GestureHandshapesPalette_XYZ(values, panel, scheme);
//        iconPanel.add(gesturePanel, GESTURE_PANEL_INDEX);
//        
//        allPanel = new SortedHandshapesPalette(values, paletteUtil);
//        iconPanel.add(allPanel, ALL_PANEL_INDEX);
//        
//        lettersPanel = new LettersHandshapesPalette(values, paletteUtil,  selectedHshImages);
//        iconPanel.add(lettersPanel, LETTERS_PANEL_INDEX);
//        
//        numbersPanel = new NumbersHandshapesPallet(values, panel, scheme);
//        iconPanel.add(numbersPanel, NUMBERS_PANEL_INDEX);
//        
//        unmarkedPanel = new UnmarkedHandshapesPellet(values, panel, scheme);
//        iconPanel.add(unmarkedPanel, UNMARKED_PANEL_INDEX);

		orientationPanel = new OrientationPalette(values, panel, scheme);    	   

		initUI();
		setPalette(selectedIndex);
		setOrientationPalette(0);
		setMinimumSize(getPreferredSize());
//		setMaximumSize(new Dimension(100, 200));
	}

	public void setPalette(int selectedIndex) {
//        invalidate();
//        revalidate();
		
//		CardLayout cl = (CardLayout)(iconPanel.getLayout());
//		cl.show(iconPanel, String.valueOf(selectedIndex));
//		
//		// GREG TODO: not sure this is really needed
//		if (selectedIndex == 2)
//        	panel.setLettersHandshapesPallet(lettersPanel);
        
       if (selectedIndex == 0) {
    	   // gestures
    	   iconPanel = new GestureHandshapesPalette(values, panel, scheme);
       } else if(selectedIndex == 1) {
        	//all
        	iconPanel = new SortedHandshapesPalette(values, paletteUtil);
        } else if(selectedIndex == 2) {
        	//letters
        	iconPanel = new LettersHandshapesPalette(values, paletteUtil,  selectedHshImages);
        	panel.setLettersHandshapesPallet((LettersHandshapesPalette)iconPanel);
        } else if(selectedIndex == 3) {
        	//numbers
        	iconPanel = new NumbersHandshapesPallete(values, panel, scheme);
        } else {
        	//unmarked
        	iconPanel = new UnmarkedHandshapesPalette(values, panel, scheme); 
        }
        
        removeAll();
        
        initUI();
        invalidate();
        revalidate();
	}
	
	 // hardcode index zero, only one for now
	public void setOrientationPalette(int selectedIndex) {

		if (selectedIndex == 0) {
//			orientationPanel = new OrientationPalette(values, panel, scheme);    	   
		}

        removeAll();
        
        initUI();
        invalidate();
        revalidate();
	}
	
	private void initUI() {	
		Dimension d = new Dimension(getPreferredSize().width, 100);
		panel.setPreferredSize(d);
		
		sp = new JScrollPane(panel, ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED,
				ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
//		sp.add(iconPanel);
//		sp.add(orientationPanel);
		sp.getViewport().setScrollMode(JViewport.SIMPLE_SCROLL_MODE);
		
//		Dimension spd = new Dimension(getPreferredSize().width - 50, 100);
		//Dimension spd = new Dimension(getPreferredSize().width - 150, 60);
//		sp.setMaximumSize(spd);
//		sp.setPreferredSize(spd);
//		sp.setMinimumSize(spd);

		JPanel p = new JPanel();
		p.setLayout(new BorderLayout());
//		p.add(iconPanel, BorderLayout.NORTH);
//		p.add(orientationPanel, BorderLayout.CENTER);
//		p.add(client, BorderLayout.SOUTH);
		
//		JPanel iconsPanel = new JPanel();
//		iconsPanel.setLayout(new BorderLayout());
//		iconPanel.setMinimumSize(dim);
		
//		iconsPanel.add(iconPanel, BorderLayout.NORTH);
//		iconsPanel.add(orientationPanel, BorderLayout.CENTER);
		
		JScrollPane jsp = new JScrollPane(iconPanel, ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED,
				ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
		Dimension dim = new Dimension(450, 300);
		jsp.setMaximumSize(dim);
		jsp.setPreferredSize(dim);

		client = new JPanel();
		client.setLayout(new BorderLayout(10, 10));
		client.add(sp, BorderLayout.SOUTH);
		
		p.add(jsp, BorderLayout.NORTH);
		p.add(orientationPanel, BorderLayout.CENTER);
		p.add(client, BorderLayout.SOUTH);

		ButtonPanel bp = new ButtonPanel();
		bp.add(clean);		
		clean.addActionListener(this);

		setLayout(new BorderLayout());

		add(p, BorderLayout.CENTER);
		add(bp, BorderLayout.SOUTH);
	}

	public void setSelectedHshImages(ArrayList<HandShapeImage> selectedHshImages) {
        // panel = new SelectedHandshapesPanel(selectedHshImages);
		this.selectedHshImages.clear();
		this.selectedHshImages.addAll(selectedHshImages);
        panel.update(this.selectedHshImages);
    }
	
	public void setSelectedOrientationImages(ArrayList<OrientationImage> selectedOrientationImages) {
        // panel = new SelectedHandshapesPanel(selectedHshImages);
		this.selectedOrientationImages.clear();
		this.selectedOrientationImages.addAll(selectedOrientationImages);
        panel.updateOrientations(this.selectedOrientationImages);
    }

	@Override
	public void actionPerformed(ActionEvent ae) {
		panel.removeAll();		
		if(iconPanel instanceof LettersHandshapesPalette) {
			LettersHandshapesPalette p = (LettersHandshapesPalette)iconPanel;
			p.clearEnteredIcons();
		}
	}

	public ArrayList<HandShapeImage> getSelectedHandshapes() {
		setSelectedHshImages(panel.getHandshapes());	// sets selectedHshImages
		return selectedHshImages;
	}
	
	public ArrayList<OrientationImage> getSelectedOrientations() {
		setSelectedOrientationImages(new ArrayList<OrientationImage>(panel.getOrientations()));
		return selectedOrientationImages;
	}

	public SelectedGestureHandshapesPanel getSelectedHandshapesPanel() {
		return panel;
	}
}
