package edu.bu.signstream.grepresentation.fields.gestureField.locationField;

import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.locations.LocationType;

// This class is used to represent the types that
// are defined in defCodingScheme.xml
public class GestureLocationType {
    private String name;
    private int id;
    private int order;
    
    public GestureLocationType(LocationType type) {
    	this.name = type.getName();
    	this.id = type.getId();
    	this.order = type.getOrder();
    }

    public GestureLocationType(String name, int id, int order) {
        this.name = name;
        this.id = id;
        this.order = order;
    }

    public String getName() {
        return name;
    }

    public int getId() {
        return id;
    }

    public int getOrder() {
        return order;
    }

    @Override
    public boolean equals(Object obj) {
        return (obj instanceof GestureLocationType) && ((GestureLocationType) obj).getId() == id;
    }

    @Override
    public int hashCode() {
        return id;
    }
}
