package edu.bu.signstream.grepresentation.fields.gestureField.mouseDelegateListeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import edu.bu.signstream.common.util.ErrorMessages;
import edu.bu.signstream.time.Time;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureChainedEventsEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureEventsEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.handshapes.GestureHandShapeEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.locationField.GestureLocationEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.orientationField.GestureOrientationEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.signTypeField.GestureTypeEntity;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.grepresentation.view.mediaControl.MediaToolBar;

public class AddGesturePoststrokeHoldActionListener implements ActionListener {

   private GestureChainedEventsEntity selectedEntity = null;

	public void setSelectedEntity(GestureChainedEventsEntity entity) {
		this.selectedEntity = entity;
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
//		MediaToolBar mediaToolBar = SS3Singleton.getMediaToolBar(null);
//		Event utterance = selectedEntity.getParentEntity().getEvent();

		SignStreamSegmentPanel segmentPanel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();

//		Time maxOffsetStartTimeInfo = segmentPanel.getMultipleMovieController()
//				.getFollowingFrameTimeInfo(
//						selectedEntity.getEndTimeInfo());
		
//		int frameDuration =  (int)segmentPanel.getMultipleMovieController().getPacketDuration();

//		if (selectedEntity.getOffset() == null && maxOffsetStartTimeInfo.greaterThan(utterance.getEndTimeInfo())) {	
//			SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.EVENT_EXTEND_BEYOND_UTTERANCE);
//			return;
//
//		}
		if(selectedEntity.getRetraction() == null) {
			GestureChainedEventsEntity nextEntity = selectedEntity.getNextEntity();
			if(nextEntity != null) {
				Time nextEntiyStartTimeInfo = nextEntity.getStartTimeInfo();
				Time maxOffsetTimeInfo = segmentPanel.getMultipleMovieController().getPrecedingFrameTimeInfo(nextEntiyStartTimeInfo);
				if(selectedEntity.getEndTimeInfo().greaterThan(maxOffsetTimeInfo)) {
					SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.CHAINS_CANNOT_OVERLAP);
					return;
				}
			}
		}
		
		String warning = selectedEntity.addPoststrokeHoldEvent();
		if (warning != null) {
			SS3Singleton.getErrorMessages().showErrorMessage(warning);
			return;
		}
		Event selectedEvent = selectedEntity.getPoststrokeHold();
		selectedEntity.getValueOrTextValueEvent().unselect();
		MediaToolBar mToolBar = SS3Singleton.getMediaToolBar();
		mToolBar.select(selectedEvent, selectedEntity);

		var currentTime = selectedEvent.getEndTimeInfo();
		SS3Singleton.getMediaPlayer().seek(currentTime);

		if (selectedEntity instanceof GestureEventsEntity) {
			GestureEventsEntity gestSelectedEntity = (GestureEventsEntity) selectedEntity;
			boolean isLockedGlossAlignments = gestSelectedEntity.isLockedGesturePhonAlignments();
			boolean isLockedDomNdomAlignments = gestSelectedEntity.isLockedDomNdomAlignments();
		
			Time timeInfo = gestSelectedEntity.getValueOrTextValueEvent().getEndTimeInfo();

			if(isLockedGlossAlignments) {
				GestureChainedEventsEntity handEntity  = gestSelectedEntity.getDependentHandEntity();
				GestureHandShapeEntity handShapeEntity = gestSelectedEntity.getDependentHandShapeEntity();
				GestureOrientationEntity orientationEntity = gestSelectedEntity.getDependentOrientationEntity();
			
				if(handEntity != null) {
					GestureChainedEventsEntity nextHndEntity = handEntity.getNextEntity();

					if (nextHndEntity == null) {
						handEntity.getValueOrTextValueEvent().setEndTimeInfo(timeInfo);
					} else if (nextHndEntity.getEndTimeInfo().lessThan(timeInfo)) {
						SS3Singleton.getErrorMessages().showErrorMessage(
							ErrorMessages.CHAINS_CANNOT_OVERLAP);
						return;
					} else {
						handEntity.getTextValue().setEndTimeInfo(timeInfo);
					}
				
					if(handShapeEntity != null) {
						Event valueOrTextEvent = selectedEntity.getValueOrTextValueEvent();
						if (handShapeEntity.getEvents().size() != 1) {
							handShapeEntity.getFirstGestureHandShapeEvent().setStartTimeInfo(valueOrTextEvent.getStartTimeInfo());
							handShapeEntity.getFirstGestureHandShapeEvent().setEndTimeInfo(valueOrTextEvent.getStartTimeInfo());

							handShapeEntity.getLastGestureHandShapeEvent().setStartTimeInfo(valueOrTextEvent.getEndTimeInfo());
							handShapeEntity.getLastGestureHandShapeEvent().setEndTimeInfo(valueOrTextEvent.getEndTimeInfo());
						} else {
							handShapeEntity.getFirstGestureHandShapeEvent().setStartTimeInfo(valueOrTextEvent.getStartTimeInfo());
							handShapeEntity.getFirstGestureHandShapeEvent().setEndTimeInfo(valueOrTextEvent.getEndTimeInfo());
						}
					}
					
					if(orientationEntity != null) {
						Event valueOrTextEvent = selectedEntity.getValueOrTextValueEvent();
						if (orientationEntity.getEvents().size() != 1) {
							orientationEntity.getFirstGestureOrientationEvent().setStartTimeInfo(valueOrTextEvent.getStartTimeInfo());
							orientationEntity.getFirstGestureOrientationEvent().setEndTimeInfo(valueOrTextEvent.getStartTimeInfo());

							orientationEntity.getLastGestureOrientationEvent().setStartTimeInfo(valueOrTextEvent.getEndTimeInfo());
							orientationEntity.getLastGestureOrientationEvent().setEndTimeInfo(valueOrTextEvent.getEndTimeInfo());
						} else {
							orientationEntity.getFirstGestureOrientationEvent().setStartTimeInfo(valueOrTextEvent.getStartTimeInfo());
							orientationEntity.getFirstGestureOrientationEvent().setEndTimeInfo(valueOrTextEvent.getEndTimeInfo());
						}
					}
				}
			}
		
			if(isLockedDomNdomAlignments) {
				GestureEventsEntity depGestEntity = gestSelectedEntity.getDependentGestureEntity();
				if(depGestEntity != null && depGestEntity.getPoststrokeHold() == null) {
					GestureEventsEntity nextDepGestEntity = depGestEntity.getNextEntity();

					if (depGestEntity.getRetraction() == null && nextDepGestEntity != null) {
						Time minHoldMovieTimeInfo = segmentPanel.getMultipleMovieController().getPrecedingFrameTimeInfo(
								nextDepGestEntity.getStartTimeInfo());
						Time selectedEntityStartMovieTimeInfo = depGestEntity.getEndTimeInfo();

						if (selectedEntityStartMovieTimeInfo.greaterThan(minHoldMovieTimeInfo)) {
							SS3Singleton.getErrorMessages().showErrorMessage(
								ErrorMessages.CHAINS_CANNOT_OVERLAP);
							return;
						}
					}
				
					String depWarning = depGestEntity.addPoststrokeHoldEvent();
					if (depWarning != null) {
						SS3Singleton.getErrorMessages().showErrorMessage(depWarning);
						return;
					}
					if(depGestEntity.isLockedGesturePhonAlignments()) {
						GestureChainedEventsEntity depHandEntity = depGestEntity.getDependentHandEntity();
						GestureHandShapeEntity depHandShapeEntity = depGestEntity.getDependentHandShapeEntity();
						GestureOrientationEntity depOrientationEntity = depGestEntity.getDependentOrientationEntity();

						if(depHandEntity != null) {
							GestureChainedEventsEntity nextHndEntity = depHandEntity.getNextEntity();

							if (nextHndEntity == null) {
								depHandEntity.getTextValue().setEndTimeInfo(timeInfo);
							} else if (nextHndEntity.getStartTimeInfo().lessThan(timeInfo)) {
								SS3Singleton.getErrorMessages().showErrorMessage(
									ErrorMessages.CHAINS_CANNOT_OVERLAP);
								return;
							} else {
								depHandEntity.getTextValue().setEndTimeInfo(timeInfo);
							}
						
							if(depHandShapeEntity != null) {
								Event valueOrTextEvent = depGestEntity.getValueOrTextValueEvent();
								if (depHandShapeEntity.getEvents().size() != 1) {
									depHandShapeEntity.getFirstGestureHandShapeEvent().setStartTimeInfo(valueOrTextEvent.getStartTimeInfo());
									depHandShapeEntity.getFirstGestureHandShapeEvent().setEndTimeInfo(valueOrTextEvent.getStartTimeInfo());

									depHandShapeEntity.getLastGestureHandShapeEvent().setStartTimeInfo(valueOrTextEvent.getEndTimeInfo());
									depHandShapeEntity.getLastGestureHandShapeEvent().setEndTimeInfo(valueOrTextEvent.getEndTimeInfo());
								} else {
									depHandShapeEntity.getFirstGestureHandShapeEvent().setStartTimeInfo(valueOrTextEvent.getStartTimeInfo());
									depHandShapeEntity.getFirstGestureHandShapeEvent().setEndTimeInfo(valueOrTextEvent.getEndTimeInfo());
								}
							}
						
							if(depOrientationEntity != null) {
								Event valueOrTextEvent = depGestEntity.getValueOrTextValueEvent();
								if (depOrientationEntity.getEvents().size() != 1) {
									depOrientationEntity.getFirstGestureOrientationEvent().setStartTimeInfo(valueOrTextEvent.getStartTimeInfo());
									depOrientationEntity.getFirstGestureOrientationEvent().setEndTimeInfo(valueOrTextEvent.getStartTimeInfo());

									depOrientationEntity.getLastGestureOrientationEvent().setStartTimeInfo(valueOrTextEvent.getEndTimeInfo());
									depOrientationEntity.getLastGestureOrientationEvent().setEndTimeInfo(valueOrTextEvent.getEndTimeInfo());
								} else {
									depOrientationEntity.getFirstGestureOrientationEvent().setStartTimeInfo(valueOrTextEvent.getStartTimeInfo());
									depOrientationEntity.getFirstGestureOrientationEvent().setEndTimeInfo(valueOrTextEvent.getEndTimeInfo());
								}
							}
						}
					}
				}
			}

			GestureLocationEntity depLocEntity = gestSelectedEntity.getDependentLocationEntity();
			if (depLocEntity != null) {
				depLocEntity.updateTimes();
			}
			
			GestureTypeEntity depSignTypeEnt = gestSelectedEntity.getDependentGestureTypeEntity();
			if (depSignTypeEnt != null) {
				depSignTypeEnt.updateTimes();
			}
		}
		
		SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
		
		segmentPanel.repaint();
	}
}
