package edu.bu.signstream.grepresentation.fields.gestureField.orientationField;

import edu.bu.signstream.common.files.SSResources;
import edu.bu.signstream.ui.SS3SignStreamApplication;

import java.io.*;
import java.awt.*;
import java.awt.image.BufferedImage;

import javax.swing.*;
import java.util.*;
import java.util.logging.Level;
import javax.imageio.*;

public class GestureOrientationsImageManager {
	private HashMap<String, BufferedImage> loadedImageFiles = new HashMap<String, BufferedImage>();

	private String path = SSResources.resourcesPath + "/images/orientations/";
	
	// Empty image to use when an image isn't found
	// 40x29 is the most common size among the handshape image files
	private BufferedImage emptyImage = new BufferedImage(40, 29, BufferedImage.TYPE_3BYTE_BGR);

	public BufferedImage getImage(String fileName) {
		if (loadedImageFiles.containsKey(fileName)) {
			return loadedImageFiles.get(fileName);
		}
		
		File file = new File(path + fileName);
		BufferedImage image = emptyImage;
		try {
			image = ImageIO.read(file);
			loadedImageFiles.put(fileName, image);
		} catch (Exception ex) {
			ex.printStackTrace();
			SS3SignStreamApplication.logger.log(Level.SEVERE, "Exception", ex);
		}
		return image;
	}

	public Icon getImageIcon(String fileName) {
		Icon icon = new ImageIcon(getImage(fileName));
		return icon;
	}

    public Image getScaledImageInstance(String fileName, GestureOrientationEntity entity) {

        Image image = getImage(fileName);
        return image.getScaledInstance(image
                .getWidth(entity), 23, Image.SCALE_AREA_AVERAGING);
    }
}
