package edu.bu.signstream.grepresentation.fields.glossField;

import javax.swing.JTextField;

import edu.bu.signstream.common.util.vo.TrackValue;
import edu.bu.signstream.common.util.vo.ss3.db.SS3Item;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEvent;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class GlossChainedEvent extends ChainedEvent {
   private boolean updatable = false;

   private int prevEventEndCoord = -1;
   private int nextEventStartCoord = -1;

   private JTextField tf = new JTextField();

   private GlossChainedEvent dependentEvent = null;
   
   private boolean startTimeFinilized = true;
   private boolean endTimeFinilized = false;

   private GlossClassifications classifications = new GlossClassifications(); 
   
   public GlossChainedEvent(
      TrackValue value,
      SignStreamSegmentPanel segmentPanel) {
      super(value, segmentPanel);
   }

   public GlossChainedEvent(
      SS3Item item,
      SignStreamSegmentPanel segmentPanel) {
      super(item, segmentPanel);
   }

   public GlossChainedEvent(SignStreamSegmentPanel segmentPanel) {
      super(segmentPanel);
   }
   
	public GlossClassifications getGlossClassifications() {
	   return classifications;
   }

   public void setClassifications(GlossClassifications classifications) {
	   this.classifications = classifications;	   
   }
   
   public void setStartTimeFinilized(boolean isFinilized) {
	   this.startTimeFinilized = isFinilized;
   }
   
   public void setEndTimeFinalized(boolean isFinilized) {
	  this.endTimeFinilized = isFinilized; 
   }
   
   public boolean isStartTimeFinilized() {
	   return startTimeFinilized;
   }
   
   public boolean isEndTimeFiilized() {
	   return endTimeFinilized;
   }

   public int getPreviousEventEndCoord() {
      return prevEventEndCoord;
   }

   public void setPreviousEventEndCoord(int prevEventEndCoord) {
      this.prevEventEndCoord = prevEventEndCoord;
   }

   public void setNextEventStartCoord(int nextEventStartCoord) {
      this.nextEventStartCoord = nextEventStartCoord;
   }

   public int getNextEventStartCoord() {
      return nextEventStartCoord;
   }

   public void setDependentEvent(GlossChainedEvent dependentEvent) {
      this.dependentEvent = dependentEvent;
   }

   public GlossChainedEvent getDependentEvent() {
      return dependentEvent;
   }

   public void removeDependentEvent() {
      this.dependentEvent = null;
   }

   @Override
public void setText(String text) {
      this.text = text;
      
      tf.setText(text);

      if (dependentEvent != null)
         dependentEvent.setText(text);
   }

   public JTextField getTextField() {
      return tf;
   }

   @Override
    public boolean unselect() {
      super.unselect();

      if (updatable)
         this.text = tf.getText();

      this.updatable = false;
      return true;
   }

   public boolean isUpdatable() {
      return updatable;
   }

   public void setUpdatable(boolean updatable) {
      this.updatable = updatable;
   }

   @Override
public void reset() {
      super.reset();
      updatable = false;
   }

   public GlossChainedEvent cloneGlossChainedEvent() {
      return new GlossChainedEvent(getSS3Item(), segmentPanel);
   }
}
