package edu.bu.signstream.grepresentation.fields.glossField;

import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.handshapeTypes.StartEndHandshapesType;

public class GlossClassifications {

	public static final int SIGN_FINGERSPELLED = 0;
	public static final int SIGN_LOAN = 1;
	public static final int SIGN_LEXICAL = 2;
	public static final int SIGN_CLASSIFIER = 3;
	public static final int SIGN_GESTURE = 4;
	public static final int SIGN_NUMBERS = 5;

	public static final int SAME_START_END_HANDSHAPES = 0;
	public static final int DIFF_START_END_HANDSHAPES = 1;
	public static final int NOT_ENTERED_HANDSHAPES = 2;

	private int signClassifier = GlossClassifications.SIGN_LEXICAL;
	private boolean isNameSign = false;
	private boolean isOneFrameGloss = false;
	private boolean isPassiveBaseArm = false;
	private int numberOfHands = 1;
	private boolean sameHandshapes = true;
	private StartEndHandshapesType domHandShapesSameDIfferent = StartEndHandshapesType.SAME;
	private StartEndHandshapesType nondomHandShapesSameDIfferent = StartEndHandshapesType.SAME;
	private boolean markedNamberOfHands;
	private boolean isRightHandDominant = true;
	
	private boolean defaultClassificationValues = true;

	public boolean isDefaultClassificationValues() {
		return defaultClassificationValues;
	}
	
	public int getSignClassification() {
		return signClassifier;
	}

	public void setSignClassifications(int signClassifier) {
		this.signClassifier = signClassifier;
		this.defaultClassificationValues = false;
	}
	
	public boolean isSignClassificationFingerspelled() {
		return signClassifier == GlossClassifications.SIGN_FINGERSPELLED;
	}
	
	public boolean isSignClassificationLoan() {
		return signClassifier == GlossClassifications.SIGN_LOAN;
	}
	
	public boolean isSignClassificationLexical() {
		return signClassifier == GlossClassifications.SIGN_LEXICAL;
	}
	
	public boolean isSignClassificationClassifier() {
		return signClassifier == GlossClassifications.SIGN_CLASSIFIER;
	}
	
	public boolean isSignClassificationGesture() {
		return signClassifier == GlossClassifications.SIGN_GESTURE;
	}
	
	public boolean isSignClassificationNumber() {
		return signClassifier == GlossClassifications.SIGN_NUMBERS;
	}

	public boolean isNameSign() {
		return isNameSign;
	}

	public void setNameSign(boolean isNameSign) {
		this.isNameSign = isNameSign;
		this.defaultClassificationValues = false;
	}
	
	public boolean isOneFrameGloss() {
		return isOneFrameGloss;
	}
	
	public void setOneFrameGloss(boolean isOneFrameGloss) {
		this.isOneFrameGloss = isOneFrameGloss;
	}

	public boolean isPassiveBaseArm() {
		return isPassiveBaseArm;
	}

	public void setPassiveBaseArm(boolean isPassiveBaseArm) {
		this.isPassiveBaseArm = isPassiveBaseArm;
		this.defaultClassificationValues = false;
	}

	public int getNumberOfHands() {
		return numberOfHands;
	}
	
	public boolean isOneHanded() {
		return numberOfHands == 1;
	}

	public void setNumberOfHands(int numberOfHands) {
		this.numberOfHands = numberOfHands;
		this.defaultClassificationValues = false;
	}

	public boolean isSameHandshapes() {
		return sameHandshapes;
	}

	public void setSameHandshapes(boolean sameHandshapes) {
		this.sameHandshapes = sameHandshapes;
		this.defaultClassificationValues = false;
	}

	public StartEndHandshapesType getDomHandShapesSameDIfferent() {
		return domHandShapesSameDIfferent;
	}

	public void setDomHandShapesSameDIfferent(StartEndHandshapesType domHandShapesSameDIfferent) {
		this.domHandShapesSameDIfferent = domHandShapesSameDIfferent;
		this.defaultClassificationValues = false;
	}

	public StartEndHandshapesType getNondomHandShapesSameDIfferent() {
		return nondomHandShapesSameDIfferent;
	}

	public void setNondomHandShapesSameDIfferent(
			StartEndHandshapesType nondomHandShapesSameDIfferent) {
		this.nondomHandShapesSameDIfferent = nondomHandShapesSameDIfferent;
		this.defaultClassificationValues = false;
	}

	public boolean isMarkedNamberOfHands() {
		return markedNamberOfHands;
	}

	public void setMarkedNamberOfHands(boolean markedNamberOfHands) {
		this.markedNamberOfHands = markedNamberOfHands;
		this.defaultClassificationValues = false;
	}
}
