package edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields;
	
	import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Image;
import java.awt.Insets;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.HashMap;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import edu.bu.signstream.common.util.UIPalette;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3FieldValue;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.HandShapeImage;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.HandShapePalletClient;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;

	public class NumbersHandshapesPallete extends PalettePanel {

		private static final long serialVersionUID = 1L;

		private HandShapePalletClient hsClient;
		
		private SS3CodingScheme defaultCodingScheme;

		private HashMap<String, SS3FieldValue> hm = new HashMap<String, SS3FieldValue>();

		public NumbersHandshapesPallete(ArrayList<SS3FieldValue> handshapes,
				HandShapePalletClient hsClient, SS3CodingScheme defaultCodingScheme) {
			this.hsClient = hsClient;
			this.defaultCodingScheme = defaultCodingScheme;

			for (int i = 0; i < handshapes.size(); i++) {
				Object obj = handshapes.get(i);
				SS3FieldValue value = (SS3FieldValue) obj;
				hm.put(value.getId(), value);
			}

			populate();
			initUI();
		}

		private JPanel handshapesPanel = new JPanel();
		GridBagConstraints c = new GridBagConstraints();
//		JScrollPane scrollPane = new JScrollPane(handshapesPanel);

		private void initUI() {
			setLayout(new GridBagLayout());

			handshapesPanel.setLayout(new GridBagLayout());

//			JPanel controlsPanel = new JPanel();
//			GridBagLayout gridbag1 = new GridBagLayout();
//			GridBagConstraints c1 = new GridBagConstraints();
//			controlsPanel.setLayout(gridbag1);

//			c1.insets = new Insets(1, 1, 1, 1);

			populateHahdshapesPanel();

			Dimension d = handshapesPanel.getPreferredSize();
//			Dimension dd = controlsPanel.getPreferredSize();
//			Dimension ddd = new Dimension((int) d.getWidth() + 10, (int) dd
//					.getHeight());

//			controlsPanel.setPreferredSize(ddd);

			//scrollPane.setPreferredSize(new Dimension(ddd.width + 10, 500));
			
//			scrollPane.setPreferredSize(new Dimension(450, 385));
//			scrollPane.getViewport().setScrollMode(javax.swing.JViewport.SIMPLE_SCROLL_MODE);
			
			c.gridwidth = 1;
			c.gridy = 1;
			c.gridx = 1;
//			add(controlsPanel, c);
//
//			c.gridwidth = 1;
//			c.gridy = 3;
//			c.gridx = 1;
			add(handshapesPanel, c);
		}

		private void populateHahdshapesPanel() {
			handshapesPanel.removeAll();
			handshapesPanel.setBackground(UIPalette.getBackground());

			c.insets = new Insets(0, 0, 0, 0);

			int longestHandshapeeList = sortedHandshapesCollectionLeft.size();
			if (longestHandshapeeList < sortedHandshapesCollectionCenter.size()) {
				longestHandshapeeList = sortedHandshapesCollectionRight.size();
			}

			if (longestHandshapeeList < sortedHandshapesCollectionRight.size()) {
				longestHandshapeeList = sortedHandshapesCollectionRight.size();
			}

			int height = 10;
			int y = 1;
			for (int i = 0; i < longestHandshapeeList; i++) {

				c.gridwidth = 1;
				c.gridy = y;
				c.gridx = 1;
				c.anchor = GridBagConstraints.NORTHEAST;

				if (sortedHandshapesCollectionLeft.size() > i) {
					final FieldValueWrapper wrapperLeft = sortedHandshapesCollectionLeft
							.get(i);
					final SS3FieldValue valueLeft = wrapperLeft.getSS3FieldValue();

					JLabel l1 = getHandhsapeVisualRepresentation(valueLeft);
					l1.setBackground(wrapperLeft.getBackground());
					height = l1.getPreferredSize().height;
					l1.setPreferredSize(new Dimension(120, height));
					l1.setMinimumSize(new Dimension(120, height));
					l1.setMaximumSize(new Dimension(120, height));

					handshapesPanel.add(new JLabel(" "), c);

					c.gridx = 2;
					c.weightx = 1;
					c.anchor = GridBagConstraints.NORTHWEST;
					handshapesPanel.add(l1, c);
				}

				c.gridx = 3;

				if (sortedHandshapesCollectionCenter.size() > i) {
					final FieldValueWrapper wrapperCenter = sortedHandshapesCollectionCenter
							.get(i);
					final SS3FieldValue valueCenter = wrapperCenter
							.getSS3FieldValue();

					c.anchor = GridBagConstraints.NORTHEAST;

					JLabel l2 = getHandhsapeVisualRepresentation(valueCenter);
					l2.setBackground(wrapperCenter.getBackground());
					height = l2.getPreferredSize().height;
					l2.setPreferredSize(new Dimension(120, height));

					handshapesPanel.add(new JLabel(" "), c);

					c.gridx = 4;
					c.weightx = 1;
					c.anchor = GridBagConstraints.NORTHWEST;
					handshapesPanel.add(l2, c);
				}

				c.gridx = 5;

				if (sortedHandshapesCollectionRight.size() > i) {
					final FieldValueWrapper wrapperRight = sortedHandshapesCollectionRight
							.get(i);
					final SS3FieldValue valueRight = wrapperRight
							.getSS3FieldValue();

					c.anchor = GridBagConstraints.NORTHEAST;

					JLabel l3 = getHandhsapeVisualRepresentation(valueRight);
					l3.setBackground(wrapperRight.getBackground());
					height = l3.getPreferredSize().height;
					l3.setPreferredSize(new Dimension(120, height));

					JLabel l = new JLabel(" ");
					handshapesPanel.add(l, c);

					c.gridx = 6;
					c.weightx = 1;
					c.anchor = GridBagConstraints.NORTHWEST;
					handshapesPanel.add(l3, c);
				}
				y++;
			}

			int j = 21 - y;
			for(int k = 0; k < j; k++) {
				c.gridwidth = 1;
				c.gridy = GridBagConstraints.RELATIVE;  
				c.gridy = y;			
				c.gridx = 2;
				handshapesPanel.add(createPlainLabel(height), c);
				y++;
			}
		}

		ArrayList<FieldValueWrapper> sortedHandshapesCollectionLeft = new ArrayList<FieldValueWrapper>();
		ArrayList<FieldValueWrapper> sortedHandshapesCollectionCenter = new ArrayList<FieldValueWrapper>();
		ArrayList<FieldValueWrapper> sortedHandshapesCollectionRight = new ArrayList<FieldValueWrapper>();

		private void populate() {
			Color color2 = new Color(255, 255, 255);
			Color color1 = new Color(123, 166, 172);

			sortedHandshapesCollectionLeft.add(createFieldValueWrapper("1", "HSH_001",
					"1", false, false, color1));
			sortedHandshapesCollectionLeft.add(createFieldValueWrapper("77", "HSH_077",
					"V/2", false, false, color2));
			sortedHandshapesCollectionLeft.add(createFieldValueWrapper("2", "HSH_002",
					"3", false, false, color1));
			sortedHandshapesCollectionLeft.add(createFieldValueWrapper("3", "HSH_003",
					"4", false, false, color2));

			sortedHandshapesCollectionCenter.add(createFieldValueWrapper("4", "HSH_004",
					"5", false, false, color1));
			sortedHandshapesCollectionCenter.add(createFieldValueWrapper("8", "HSH_008",
					"6", false, false, color2));
			sortedHandshapesCollectionCenter.add(createFieldValueWrapper("9", "HSH_009",
					"7", false, false, color1));
			sortedHandshapesCollectionCenter.add(createFieldValueWrapper("10", "HSH_010",
					"8", false, false, color2));

			sortedHandshapesCollectionRight.add(createFieldValueWrapper("44", "HSH_044",
					"F/9", false, false, color1));
			sortedHandshapesCollectionRight.add(createFieldValueWrapper("12", "HSH_012",
					"10", false, false, color2));
			sortedHandshapesCollectionRight.add(createFieldValueWrapper("13", "HSH_013",
					"25", false, false, color1));
		}

		private JLabel getHandhsapeVisualRepresentation(final SS3FieldValue value) {
			HandShapeImage handshapeImage = new HandShapeImage(value, defaultCodingScheme);

			Image image = handshapeImage.getImage();

			JLabel label = new JLabel();
			Font lblFont = new Font(label.getFont().getName(), Font.PLAIN, 10);
			label.setFont(lblFont);
			label.setBorder(BorderFactory.createLineBorder(UIPalette
					.getBackground()));
			label.setBackground(UIPalette.getBackground());
			label.setOpaque(true);
			SameWidhtIcon icon = new SameWidhtIcon(image);
			label.setIcon(icon);
			label.setText(value.getLabelOrName());

			label.addMouseListener(new MouseAdapter() {
				@Override
				public void mousePressed(MouseEvent e) {
					value.getId();
					hsClient.setItem(value);
					SS3Singleton.getApplicationStateController()
							.setLoadedCollectionUpdated(true);
				}
			});

			return label;
		}
	}

