package edu.bu.signstream.grepresentation.fields.glossField.dialog.handShapes;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JViewport;
import javax.swing.ScrollPaneConstants;

import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3FieldValue;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.HandShapePanel;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.LettersHandshapesPalette;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.NumbersHandshapesPallete;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.PaletteUtil;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.SortedHandshapesPalette;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.UnmarkedHandshapesPalette;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.HandShapeImage;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.SelectedHandshapesPanel;
import edu.bu.signstream.ui.ButtonPanel;

public class GeneralHandshapePalette extends JPanel implements ActionListener {

	private static final long serialVersionUID = 1L;
	
	private SS3CodingScheme scheme;
	private HashMap<String, SS3FieldValue> hm = new HashMap<String, SS3FieldValue>();
	private SelectedHandshapesPanel panel = null;
	private JPanel client = null;
	protected JScrollPane sp = null;

	private JButton clean = new JButton("Clear");
	
	private JPanel iconPanel = new JPanel();
	
	private ArrayList<SS3FieldValue> values = new ArrayList<SS3FieldValue>();
	private ArrayList<HandShapeImage> selectedHshImages = new ArrayList<HandShapeImage>();
	
	private PaletteUtil paletteUtil = null;

	public GeneralHandshapePalette(ArrayList<SS3FieldValue> values, ArrayList<HandShapeImage> selectedHshImages, SS3CodingScheme scheme, int selectedIndex, HandShapePanel hsPanel) {
		this.scheme = scheme;
		this.values = values;
		this.selectedHshImages.addAll(selectedHshImages);
		if (values == null) {
			panel = new SelectedHandshapesPanel(scheme);
		} else {
			panel = new SelectedHandshapesPanel(selectedHshImages, scheme, hsPanel);
		}
		
		this.paletteUtil = new PaletteUtil(scheme, panel);
        
        iconPanel = new JPanel();
        
//		initUI();		
		setPalette(selectedIndex);
		setMinimumSize(getPreferredSize());
	}

	public void setPalette(int selectedIndex) {
		
		paletteUtil.setLetter(false);
		
        if(selectedIndex == 0) {
        	//all
        	iconPanel = new SortedHandshapesPalette(values, paletteUtil);
        } else if(selectedIndex == 1) {
        	//letters
        	iconPanel = new LettersHandshapesPalette(values, paletteUtil, getSelectedHandshapes());
        	panel.setLettersHandshapesPallet((LettersHandshapesPalette)iconPanel);
        	paletteUtil.setLetter(true);
        } else if(selectedIndex == 2) {
        	//numbers
        	iconPanel = new NumbersHandshapesPallete(values, panel, scheme);
        } else {
        	//unmarked
        	iconPanel = new UnmarkedHandshapesPalette(values, panel, scheme); 
        }
        
        removeAll();
        
        initUI();
        invalidate();
        revalidate();
	}
	
	private void initUI() {
		Dimension d = new Dimension(getPreferredSize().width+10, 50);
		panel.setPreferredSize(d);
		
		sp = new JScrollPane(panel, ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED,
				ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
		sp.getViewport().setScrollMode(JViewport.SIMPLE_SCROLL_MODE);

		JPanel p = new JPanel();
		p.setLayout(new BorderLayout());

		JScrollPane jsp = new JScrollPane(iconPanel, ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED,
				ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
		Dimension dim = new Dimension(450, 300);
		jsp.setMaximumSize(dim);
		jsp.setPreferredSize(dim);

//		Dimension spd = new Dimension(getPreferredSize().width - 50, 60);
//		//Dimension spd = new Dimension(getPreferredSize().width - 150, 60);
//
//		sp.setMaximumSize(spd);
//		sp.setPreferredSize(spd);
//		sp.setMinimumSize(spd);

		client = new JPanel();
		client.setLayout(new BorderLayout(10, 10));
		client.add(sp, BorderLayout.SOUTH);

//		p.add(iconPanel, BorderLayout.CENTER);   
		p.add(jsp, BorderLayout.NORTH);
		if (iconPanel instanceof LettersHandshapesPalette) 
			p.add(paletteUtil.getLettersTxtfld(), BorderLayout.CENTER);	
		else {
			JPanel padding = new JPanel();
			Dimension pref = new Dimension(padding.getPreferredSize().width, padding.getPreferredSize().height + 10);
			padding.setPreferredSize(pref);
			p.add(padding);
		}
		p.add(client, BorderLayout.SOUTH);
		p.setMinimumSize(p.getPreferredSize());

		ButtonPanel bp = new ButtonPanel();
		bp.add(clean);		
		clean.addActionListener(this);

		setLayout(new BorderLayout());

		add(p, BorderLayout.CENTER);
		add(bp, BorderLayout.SOUTH);
	}

	public void setSelectedHshImages(ArrayList<HandShapeImage> selectedHshImages) {
        // panel = new SelectedHandshapesPanel(selectedHshImages);
		this.selectedHshImages.clear();
		this.selectedHshImages.addAll(selectedHshImages);
        panel.update(this.selectedHshImages);
    }

	@Override
	public void actionPerformed(ActionEvent ae) {
		panel.removeAll();
		
		if(iconPanel instanceof LettersHandshapesPalette) {
			LettersHandshapesPalette p = (LettersHandshapesPalette)iconPanel;
			p.clearEnteredIcons();
		}
	}

	public ArrayList<HandShapeImage> getSelectedHandshapes() {
		setSelectedHshImages(panel.getHandshapes());	// sets selectedHshImages
		return selectedHshImages;
	}

	public SelectedHandshapesPanel getSelectedHandshapesPanel() {
		return panel;
	}
	
}
