package edu.bu.signstream.grepresentation.fields.handShapeField.dialogs;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.util.ArrayList;
import java.util.HashMap;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.JViewport;
import javax.swing.ScrollPaneConstants;

import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3FieldValue;

public class GeneralHandShapePallet extends JPanel {
	
	private static final long serialVersionUID = 1L;
	
	protected HashMap<String, SS3FieldValue> hm = new HashMap<String, SS3FieldValue>();
	protected SelectedHandshapesPanel panel = null;
	protected JPanel client = null;
	protected JTextField text;
	protected String fieldID = "";

	private JScrollPane sp = null;

	public GeneralHandShapePallet(ArrayList<SS3FieldValue> list, String fieldID,
			SS3CodingScheme scheme) {
		this.fieldID = fieldID;
		panel = new SelectedHandshapesPanel(scheme);

		HandShapePalette palette = new HandShapePalette(list, panel, scheme);

		for (int i = 0; i < list.size(); i++) {
			Object obj = list.get(i);
			SS3FieldValue value = (SS3FieldValue) obj;
			hm.put(value.getLabel(), value);
		}

		sp = new JScrollPane(panel,
				ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED,
				ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);

		sp.getViewport().setScrollMode(JViewport.SIMPLE_SCROLL_MODE);

		Dimension d = new Dimension(getPreferredSize().width, 50);
		Dimension spd = new Dimension(getPreferredSize().width - 50, 60);

		sp.setMaximumSize(spd);
		sp.setPreferredSize(spd);
		sp.setMinimumSize(spd);

		panel.setPreferredSize(d);

		client = new JPanel();
		client.setLayout(new BorderLayout(10, 10));
		client.add(sp, BorderLayout.SOUTH);

		setLayout(new BorderLayout(10, 10));
		add(palette, BorderLayout.CENTER);
		add(client, BorderLayout.SOUTH);
	}

	public ArrayList<HandShapeImage> getSelectedHandshapes() {
		return panel.getHandshapes();
	}

	public SelectedHandshapesPanel getSelectedHandshapesPanel() {
		return panel;
	}
}
