package edu.bu.signstream.grepresentation.fields.handShapeField.dialogs;

import java.io.*;
import java.awt.*;
import java.util.logging.Level;
import javax.imageio.*;

import edu.bu.signstream.common.files.SSResources;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.*;
import edu.bu.signstream.common.util.Util;
import edu.bu.signstream.ui.SS3SignStreamApplication;

public class HandShapeImage {

	private Image image;
	private SS3FieldValue value;

    private SS3CodingScheme scheme;
	
	private static final String path = SSResources.resourcesPath + "/images/handShapes/";

	public HandShapeImage(SS3FieldValue value, SS3CodingScheme scheme) {
		this.value = value;
        this.scheme = scheme;

		SS3FieldTypeImg img = scheme.getImage(value.getIid());
		String imgPath = path + img.getPath1();
		loadImage(imgPath);
	}

    public HandShapeImage cloneHandShapeImage() {
        SS3FieldValue clonedValue = value.cloneFieldValue();
        value.setId(Util.getUniqueNumber());
        return new HandShapeImage(clonedValue, scheme);
    }
   
   public SS3FieldValue getSS3FieldValue() {
      return value;
   }

    private void loadImage(String imgPath) {
		if (imgPath != null) {
			try {
				image = ImageIO.read(new File(imgPath));
			} catch (Exception ex) {
				ex.printStackTrace();
				SS3SignStreamApplication.logger.log(Level.SEVERE, "Exception", ex);
			}
		}
	}

	public Image getImage() {
		return image;
	}
}
