package edu.bu.signstream.grepresentation.fields.movementField;

import java.awt.Cursor;
import java.awt.Point;

import javax.swing.JPanel;

import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.time.TimeRange;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.EventsEntity;
import edu.bu.signstream.grepresentation.fields.FieldWrapper;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEvent;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class MovementFieldWrapper extends FieldWrapper {
	private MovementField mField;
	private int MOVE_DIRECTION;
	private int MOVE_START_POINT = 1;
	private int MOVE_END_POINT = 2;

	public MovementFieldWrapper(MovementField field, SignStreamSegmentPanel segmentPanel, TimeRange timeRange) {
		super(field, segmentPanel, timeRange);
		this.mField = field;
	}

	@Override
	public EventsEntity getEntityAt(int entityAt) {
		return mField.getEntityAt(entityAt);
	}

	@Override
	public void highlight(boolean highlight, String refID) {
		field.highlight(highlight, refID);
	}

	@Override
	public void addEventsEntity(EventsEntity entity) {
	}

	@Override
	public boolean contains(int Y) {
		return field.contains(Y);
	}

	// MouseListener
	@Override
	public void mouseClicked(Point point, JPanel panel) {
		//mField.selectEvent(point.x);
//		if (isEntitySelected()) {
//			EventsEntity entity = mField.getEntityAt(point.x);
//			if (entity != null)
//				entity.select();
//		} else {
			Event event = mField.getEventAt(point.x);

			if (event != null)
				event.select();
		//}
	}

	@Override
	public void mouseClickedAlt(Point point) {
	}
   
   @Override
public void mousePressedAlt(Point point, JPanel panel) {}

	@Override
	public void mouseRightClicked(Point point) {
	}

	@Override
	public void mouseLeftClicked(Point point) {
	}

	@Override
	public void mouseReleased(Point point, JPanel panel) {
	}

	@Override
	public void mouseDblLeftClicked(Point point, JPanel panel) {
		ChainedEvent event = (ChainedEvent) field.getEventAt(point.x);
		if (event != null) {
            SS3CodingScheme dbScheme = segmentPanel.getSS3Database().getSS3CodingScheme();
			NewMovementDialog d = new NewMovementDialog(event, dbScheme);
			d.show();
		}
	}

	@Override
	public void mouseDblRightClicked(Point point, JPanel panel) {
	}
/*
	public void mouseMoved(Point point, JPanel panel) {
		ChainedEvent event = (ChainedEvent) field.getEventAt(point.x);
		// --- //
		//System.err.println("MovementEvent = " + event);
		// --- //

		if (event != null) {
			event.getToolTipText();
			panel.setToolTipText(event.getToolTipText());
		} else {
			panel.setToolTipText("");
		}
	}

	public void mouseDragged(Point point, JPanel panel) {	
	}
*/	
	@Override
	public void mouseMoved(Point point, JPanel panel) {
			//if (!isEntitySelected()) {
			panel.setCursor(new Cursor(getCursorType(point)));

			Event event = mField.getEventAt(point.x);
			if (event != null) {
				panel.setToolTipText(event.getToolTipText());
			} else {
				panel.setToolTipText("");
			}
			//}
		}

		private int getCursorType(Point point) {
			int cursorType = Cursor.DEFAULT_CURSOR;
			Event event = mField.getSelectedEvent();

			if (event != null) {
				double startCoord = event.getStartTimeCoordinate();
				double endCoord = event.getEndTimeCoordinate();

				if (startCoord - 3 < point.x && point.x < startCoord + 3) {
					cursorType = Cursor.E_RESIZE_CURSOR;
					MOVE_DIRECTION = MOVE_START_POINT;
				}

				if (endCoord - 3 < point.x && point.x < endCoord + 3) {
					cursorType = Cursor.E_RESIZE_CURSOR;
					MOVE_DIRECTION = MOVE_END_POINT;
				}
			}
			return cursorType;
		}
	
		@Override
		public void mouseDragged(Point point, JPanel panel) {
			//MovementEntity entity = (MovementEntity)mField.getSelectedEntity();

			if (panel.getCursor().getType() != Cursor.E_RESIZE_CURSOR)
				return;

			if (MOVE_DIRECTION == MOVE_START_POINT) {
            mField.setSelectedEventStartCoordinate(point.x);
            //entity.detach();
			}
		
			if (MOVE_DIRECTION == MOVE_END_POINT) { 
            mField.setSelectedEventEndCoordinate(point.x);
				//entity.detach();
			}
		}

	@Override
	public void unselectAll() {
		field.unselect();
	}

	@Override
	public void mouseHoldReleased(Point point, JPanel panel) {
	}
}
