package edu.bu.signstream.grepresentation.fields.nonManualField;

import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;

import edu.bu.signstream.common.util.UserInterfaceUtil;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.customField.CustomChainedEventsEntity;
import edu.bu.signstream.grepresentation.fields.customField.CustomIntervalChainedEventsEntity;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;

public class MouseDblRightClickedDelegate {
   private NonManualField nmField = null;

   public MouseDblRightClickedDelegate(NonManualField nmField) {
      this.nmField = nmField;
   }

   public NonManualField getNonManualField() {
      return nmField;
   }

   public void dblClick(
      ChainedEvent event,
      final ChainedEventsEntity entity,
      final Point point,
      final JPanel panel) {

	   if(event == null)
		   return;
	   
      Event value = entity.getValueOrTextValueEvent();
      Event iHold = entity.getInitialHold();
      Event fHold = entity.getFinalHold();
      Event onset = entity.getOnset();
      Event offset = entity.getOffset();

      if (event.equals(value)) {
    	  if (entity instanceof CustomChainedEventsEntity)
        	  SS3Singleton.getCustomFieldDialogs().getAssociatedElelmentsMenu(entity, point, panel);
    	  else
    		  SS3Singleton.getNonManuelFieldDialogs().getAssociatedElelmentsMenu(entity, point, panel);
         //valueDblClick(event, entity, point, panel);
      } else {
         final JPopupMenu popup = new JPopupMenu();
         JMenuItem mi = null;

         if (event.equals(iHold)) {
            mi = new JMenuItem("Delete Initial Hold");
            mi.addActionListener(new ActionListener() {
            @Override
			public void actionPerformed(ActionEvent e) {
                  entity.deleteInitialHold(); 
                  SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
                  panel.repaint();
               }
            });
         } else if (event.equals(fHold)) {
            mi = new JMenuItem("Delete Final Hold");
            mi.addActionListener(new ActionListener() {
               @Override
			public void actionPerformed(ActionEvent e) {
                  entity.deleteFinalHold();
                  SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
                  panel.repaint();
               }
            });
         } else if (event.equals(onset)) {
            mi = new JMenuItem("Delete Onset");
            mi.addActionListener(new ActionListener() {
               @Override
			public void actionPerformed(ActionEvent e) {
                  entity.deleteOnset();
                  SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
                  panel.repaint();
               }
            });
         } else if (event.equals(offset)) {
            mi = new JMenuItem("Delete Offset");
            mi.addActionListener(new ActionListener() {
               @Override
			public void actionPerformed(ActionEvent e) {
                  entity.deleteOffset();
                  SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
                  panel.repaint();
               }
            });
         }
         UserInterfaceUtil.setMenuItemLNF(mi);
         popup.add(mi);
         JMenuItem cancel = new JMenuItem("Cancel");
         UserInterfaceUtil.setMenuItemLNF(cancel);
         popup.add(cancel);
         popup.setPreferredSize(popup.getPreferredSize());
         popup.show(panel, point.x, point.y);
         popup.setVisible(true);
 		
 		SS3Singleton.getSignStreamApplication().forcePopupInvisibleOnWindowLostFocus(popup);
      }
   }

   public void entityDblClick(
      final ChainedEventsEntity entity,
      final Point point,
      final JPanel panel) {

      final JPopupMenu popup = new JPopupMenu();

      JMenuItem delete = new JMenuItem("Delete");
      UserInterfaceUtil.setMenuItemLNF(delete);
      //delete.addActionListener(new DeleteActionListener(entity, panel));
      popup.add(delete);
      
      JMenuItem cancel = new JMenuItem("Cancel");
      UserInterfaceUtil.setMenuItemLNF(cancel);
      popup.add(cancel);

      popup.setPreferredSize(popup.getPreferredSize());
      popup.show(panel, point.x, point.y);
      popup.setVisible(true);
		
	  SS3Singleton.getSignStreamApplication().forcePopupInvisibleOnWindowLostFocus(popup);
   }
}
