package edu.bu.signstream.grepresentation.fields.nonManualField;

import edu.bu.signstream.time.Time;
import edu.bu.signstream.time.TimeRange;
import edu.bu.signstream.ui.popup.TextEntryPopupGenerator;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.EventsEntity;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.grepresentation.view.mediaControl.MediaToolBar;

import javax.swing.*;
import java.awt.*;

public class NonManualFreeTextFieldWrapper extends NonManualFieldWrapper {

    public NonManualFreeTextFieldWrapper(NonManualField field, SignStreamSegmentPanel segmentPanel, TimeRange timeRange) {
        super(field, segmentPanel, timeRange);
    }

	@Override
	public void mouseReleased(final Point point, final JPanel panel) {
		// clear the lastPoint since the user has finished dragging the mouse
		lastPoint = null;

		NewChainedEvent newEvent = nmField.getNewChainedEvent();
		if (newEvent != null) {
			Time start = newEvent.getStartTimeInfo();
			Time end = newEvent.getEndTimeInfo();

			if (end.lessThan(start)) {
				var temp = end;
				end = start;
				start = temp;
			}

//            var utterance = nmField.getParentField().getEventAt(point.x);
//            if (start.equals(end) || !utterance.interval().contains(start.to(end), Bound.INCLUSIVE)) {
//                nmField.setNewChainedEvent(null);
//                return;
//            }

            ChainedEvent event = new ChainedEvent(segmentPanel);
            event.setStartTimeInfo(start);
            event.setEndTimeInfo(end);
            event.select();

            ChainedEventsCollection collection = new ChainedEventsCollection();
            collection.setValueEvent(event);

            Point loc = new Point((int)event.getEndTimeCoordinate(), field.getY() - 11);
            
            TextEntryPopupGenerator.getInstance("", panel, loc, label -> {
                event.setText(label);

                ChainedEventsEntity entity = new ChainedEventsEntity(collection, segmentPanel, nmField);
                entity.updateParentEntity();

                nmField.addChainedEventEntity(entity);
                nmField.setNewChainedEvent(null);
                
                var bar = SS3Singleton.getMediaToolBar(segmentPanel);
                bar.selectEvent(event, entity, nmField);

                SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
                segmentPanel.repaint();
            }, () -> {
                nmField.setNewChainedEvent(null);
                segmentPanel.repaint();
            });
		}
	}

	@Override
	public void mouseDblLeftClicked(final Point point, final JPanel panel) {
		Event event = SS3Singleton.getMediaToolBar(null).selectedEvent();

		// if event is null by standard procedure, then try the procedure from
		// mouseClicked() before returning
		if (event == null) {
			MediaToolBar mediaTb = SS3Singleton.getMediaToolBar(null);

			EventsEntity entity = nmField.getEntityAt(point.x);
			event = nmField.getEventAt(point.x);
			if (event != null) {
				event.select();
				mediaTb.selectEvent(event, entity, nmField);
			} else {
				return;
			}
		}

		if (!isEntitySelected()) {
			final ChainedEvent cEvent = (ChainedEvent) event;

			ChainedEventsEntity entity = (ChainedEventsEntity) SS3Singleton.getMediaToolBar(null)
					.selectedEntity();

            Point loc = new Point(point.x, this.field.getY() - 11);
            
			if (cEvent.equals(entity.getValue())) {
				TextEntryPopupGenerator.getInstance(cEvent.getText(), panel, loc, label -> {
                    cEvent.setText(label);

                    nmField.setNewChainedEvent(null);

                    SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
                    segmentPanel.repaint();
                }, () -> {
                    nmField.setNewChainedEvent(null);
                    segmentPanel.repaint();
                });
			}
		}
	}
}