package edu.bu.signstream.grepresentation.fields.nonManualField.mouseDelegateListeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import edu.bu.signstream.common.util.ErrorMessages;
import edu.bu.signstream.time.Time;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.glossField.GlossChainedEventsEntity;
import edu.bu.signstream.grepresentation.fields.handShapeField.HandShapeEntity;
import edu.bu.signstream.grepresentation.fields.locationField.LocationEntity;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEventsEntity;
import edu.bu.signstream.grepresentation.fields.signTypeField.SignTypeEntity;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.grepresentation.view.mediaControl.MediaToolBar;
import edu.bu.signstream.grepresentation.view.mediaControl.MediaToolbarCommons;

public class AddFinalHoldActionListener implements ActionListener {

   private ChainedEventsEntity selectedEntity = null;
   
   public AddFinalHoldActionListener() {}

	public void setSelectedEntity(ChainedEventsEntity entity) {
		this.selectedEntity = entity;
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
//		MediaToolBar mediaToolBar = SS3Singleton.getMediaToolBar(null);
//		Event utterance = selectedEntity.getParentEntity().getEvent();

		SignStreamSegmentPanel segmentPanel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();

//		Time maxOffsetStartTimeInfo = segmentPanel.getMultipleMovieController()
//				.getFollowingFrameTimeInfo(
//						selectedEntity.getEndTimeInfo());
		
//		double frameDuration =  segmentPanel.getMultipleMovieController().getPacketDuration();

//		if (selectedEntity.getOffset() == null && maxOffsetStartTimeInfo.greaterThan(utterance.getEndTimeInfo())) {	
//			SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.EVENT_EXTEND_BEYOND_UTTERANCE);
//			return;
//
//		}
		if(selectedEntity.getOffset() == null) {
			ChainedEventsEntity nextEntity = selectedEntity.getNextEntity();
			if(nextEntity != null) {
				Time nextEntiyStartTimeInfo = nextEntity.getStartTimeInfo();
				Time maxOffsetTimeInfo = segmentPanel.getMultipleMovieController().getPrecedingFrameTimeInfo(nextEntiyStartTimeInfo);
				if(selectedEntity.getEndTimeInfo().greaterThan(maxOffsetTimeInfo)) {
					SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.CHAINS_CANNOT_OVERLAP);
					return;
				}
			}
		}
		
		String warning = selectedEntity.addFinalHoldEvent();
		if (warning != null) {
			SS3Singleton.getErrorMessages().showErrorMessage(warning);
			return;
		}
		Event selectedEvent = selectedEntity.getFinalHold();
		selectedEntity.getValueOrTextValueEvent().unselect();
		MediaToolBar mToolBar = SS3Singleton.getMediaToolBar();
        mToolBar.select(selectedEvent, selectedEntity);

		var currentTime = selectedEvent.getEndTimeInfo();
		SS3Singleton.getMediaPlayer().seek(currentTime);

		if (selectedEntity instanceof GlossChainedEventsEntity) {
			GlossChainedEventsEntity glsSelectedEntity = (GlossChainedEventsEntity) selectedEntity;
			boolean isLockedGlossAlignments = glsSelectedEntity.isLockedGlossPhonAlignments();
			boolean isLockedDomNdomAlignments = glsSelectedEntity.isLockedDomNdomAlignments();
		
			Time timeInfo = selectedEvent.getEndTimeInfo();
		
			if(isLockedGlossAlignments) {
				ChainedEventsEntity handEntity  = glsSelectedEntity.getDependentHandEntity();
				HandShapeEntity handShapeEntity = glsSelectedEntity.getDependentHandShapeEntity();
			
				if(handEntity != null) {
					ChainedEventsEntity nextHndEntity = handEntity.getNextEntity();

					if (nextHndEntity == null) {
						handEntity.getTextValue().setEndTimeInfo(timeInfo);
					} else if (nextHndEntity.getEndTimeInfo().lessThan(timeInfo)) {
						SS3Singleton.getErrorMessages().showErrorMessage(
							ErrorMessages.CHAINS_CANNOT_OVERLAP);
						return;
					} else {
						handEntity.getTextValue().setEndTimeInfo(timeInfo);
					}
				
					if(handShapeEntity != null) {
						Event valueOrTextEvent = selectedEntity.getValueOrTextValueEvent();
						Event startEvent = valueOrTextEvent, endEvent = valueOrTextEvent;
						
						Time startTimeInfo = startEvent.getStartTimeInfo();
						Time endTimeInfo = endEvent.getEndTimeInfo();
						
						Event initialHoldEvent = selectedEntity.getInitialHold();
						startTimeInfo = initialHoldEvent != null 
								? initialHoldEvent.getStartTimeInfo() 
										: valueOrTextEvent.getStartTimeInfo();
						
						Event finalHoldEvent = selectedEntity.getFinalHold();
						endTimeInfo = finalHoldEvent != null 
								? finalHoldEvent.getEndTimeInfo() 
										: valueOrTextEvent.getEndTimeInfo();
						
						if (handShapeEntity.getEvents().size() != 1) {
							handShapeEntity.getFirstHandShapeEvent().setStartTimeInfo(startTimeInfo);
							handShapeEntity.getFirstHandShapeEvent().setEndTimeInfo(startTimeInfo);

							handShapeEntity.getLastHandShapeEvent().setStartTimeInfo(endTimeInfo);
							handShapeEntity.getLastHandShapeEvent().setEndTimeInfo(endTimeInfo);
						} else {
							handShapeEntity.getFirstHandShapeEvent().setStartTimeInfo(startTimeInfo);
							handShapeEntity.getFirstHandShapeEvent().setEndTimeInfo(endTimeInfo);
						}

						MediaToolbarCommons.setHandshapeEndTime(
								handShapeEntity, endTimeInfo);
					}
				}
			}
		
			if(isLockedDomNdomAlignments) {
				GlossChainedEventsEntity depGlsEntity = glsSelectedEntity.getDependentGlossEntity();
				if(depGlsEntity != null && depGlsEntity.getFinalHold() == null) {
					ChainedEventsEntity nextDepGlsEntity = depGlsEntity.getNextEntity();

					if (depGlsEntity.getOffset() == null && nextDepGlsEntity != null) {
						Time minHoldMovieTimeInfo = segmentPanel.getMultipleMovieController().getPrecedingFrameTimeInfo(
								nextDepGlsEntity.getStartTimeInfo());
						Time selectedEntityStartMovieTimeInfo = depGlsEntity.getEndTimeInfo();

						if (selectedEntityStartMovieTimeInfo.greaterThan(minHoldMovieTimeInfo)) {
							SS3Singleton.getErrorMessages().showErrorMessage(
								ErrorMessages.CHAINS_CANNOT_OVERLAP);
							return;
						}
					}
				
					String depWarning = depGlsEntity.addFinalHoldEvent();
					if (depWarning != null) {
						SS3Singleton.getErrorMessages().showErrorMessage(depWarning);
						return;
					}
					if(depGlsEntity.isLockedGlossPhonAlignments()) {
						ChainedEventsEntity depHandEntity = depGlsEntity.getDependentHandEntity();
						HandShapeEntity depHandShapeEntity = depGlsEntity.getDependentHandShapeEntity();
					
						if(depHandEntity != null) {
							ChainedEventsEntity nextHndEntity = depHandEntity.getNextEntity();

							if (nextHndEntity == null) {
								depHandEntity.getTextValue().setEndTimeInfo(timeInfo);
							} else if (nextHndEntity.getStartTimeInfo().lessThan(timeInfo)) {
								SS3Singleton.getErrorMessages().showErrorMessage(
									ErrorMessages.CHAINS_CANNOT_OVERLAP);
								return;
							} else {
								depHandEntity.getTextValue().setEndTimeInfo(timeInfo);
							}
						
							if(depHandShapeEntity != null) {
								Event valueOrTextEvent = depGlsEntity.getValueOrTextValueEvent();
								Event startEvent = valueOrTextEvent, endEvent = valueOrTextEvent;
								
								Time startTimeInfo = startEvent.getStartTimeInfo();
								Time endTimeInfo = endEvent.getEndTimeInfo();
								
								Event initialHoldEvent = depGlsEntity.getInitialHold();
								startTimeInfo = initialHoldEvent != null 
										? initialHoldEvent.getStartTimeInfo() 
												: valueOrTextEvent.getStartTimeInfo();
								
								Event finalHoldEvent = depGlsEntity.getFinalHold();
								endTimeInfo = finalHoldEvent != null 
										? finalHoldEvent.getEndTimeInfo() 
												: valueOrTextEvent.getEndTimeInfo();
										
								if (depHandShapeEntity.getEvents().size() != 1) {
									depHandShapeEntity.getFirstHandShapeEvent().setStartTimeInfo(startTimeInfo);
									depHandShapeEntity.getFirstHandShapeEvent().setEndTimeInfo(startTimeInfo);

									depHandShapeEntity.getLastHandShapeEvent().setStartTimeInfo(endTimeInfo);
									depHandShapeEntity.getLastHandShapeEvent().setEndTimeInfo(endTimeInfo);
								} else {
									depHandShapeEntity.getFirstHandShapeEvent().setStartTimeInfo(startTimeInfo);
									depHandShapeEntity.getFirstHandShapeEvent().setEndTimeInfo(endTimeInfo);
								}

								MediaToolbarCommons.setHandshapeEndTime(
										depHandShapeEntity, endTimeInfo);
							}
						}
					}
				}
			}

			LocationEntity depLocEntity = glsSelectedEntity.getDependentLocationEntity();
			if (depLocEntity != null) {
				depLocEntity.updateTimes();
			}
			
			SignTypeEntity depSignTypeEnt = glsSelectedEntity.getDependentSignTypeEntity();
			if (depSignTypeEnt != null) {
				depSignTypeEnt.updateTimes();
			}
		}
		
		SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
		
		segmentPanel.repaint();
	}
}