package edu.bu.signstream.grepresentation.fields.presentation.dialog;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;

import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.ui.panels.GenaricOneTxtFldPanel;

public class RenameTemporalPartitionDialog extends JDialog implements ActionListener {
	private static final long serialVersionUID = 1L;
	private final int CANCEL = 4;
	private final int OK = 5;

	private GenaricOneTxtFldPanel renameTemporalPartitionPanel;
	private String text = "";

	private JButton btnCancel = new JButton(" Cancel ");
	private JButton btnOk = new JButton(" OK ");

	GridBagLayout gbl = new GridBagLayout();
	GridBagConstraints gbc = new GridBagConstraints();

	public RenameTemporalPartitionDialog(SignStreamSegmentPanel temporalPartionPanel) {
		// since we are passing true in for modal here,
		// it means execution of other code will not proceed until this is done
		super(SS3Singleton.getSignStreamApplication(), "Rename Temporal Partition", true);
		renameTemporalPartitionPanel = new GenaricOneTxtFldPanel("Rename Temporal Partition");

		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				dispose();
			}
		});

		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout(50, 50));
		contentPane.add(createPanel(), BorderLayout.CENTER);
		this.pack();
	}

	public JPanel createPanel() {
		btnCancel.setToolTipText("Check this to cancel.");
		btnCancel.setActionCommand("" + CANCEL);

		btnOk.setToolTipText("Check this to add new field.");
		btnOk.setActionCommand("" + OK);

		btnCancel.addActionListener(this);
		btnOk.addActionListener(this);

		Dimension dim = new Dimension(80, 21);
		btnCancel.setPreferredSize(dim);
		btnOk.setPreferredSize(dim);

		ButtonPanel btnPanel = new ButtonPanel();
		btnPanel.add(btnCancel);
		btnPanel.add(btnOk);

		int width = (int) (renameTemporalPartitionPanel.getPreferredSize().getWidth() + 30);
		int height = (int) renameTemporalPartitionPanel.getPreferredSize().getHeight() + 20;

		renameTemporalPartitionPanel.setPreferredSize(new Dimension(width, height));

		JPanel panel = new JPanel();
		panel.setLayout(new BorderLayout());
		panel.add(renameTemporalPartitionPanel, BorderLayout.CENTER);
		panel.add(btnPanel, BorderLayout.SOUTH);

		return panel;
	}

	@Override
	public void actionPerformed(ActionEvent ae) {
		String str = ae.getActionCommand();

		switch (Integer.parseInt(str)) {
			case CANCEL :
				break;
			case OK :
				text = renameTemporalPartitionPanel.getLabel();
				break;
		}
		
		// done after this
		this.dispose();
	}
	
	public String getText() {
		return text;
	}
	
}
