package edu.bu.signstream.grepresentation.listener;

import edu.bu.signstream.ui.SS3SignStreamApplication;

import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.lang.ref.WeakReference;
import java.lang.reflect.Method;
import java.util.logging.Level;

public class WeakItemListener implements ItemListener {

	private WeakReference<ItemListener> weakListenerReference;
	private Object source;

	public WeakItemListener(ItemListener listener, Object source) {
		this.weakListenerReference = new WeakReference<ItemListener>(listener);
		this.source = source;
	}

	public void itemStateChanged(ItemEvent itemEvent) {
		ItemListener itemListener = (ItemListener) this.weakListenerReference
				.get();
		if (itemListener == null) {
			this.removeListener();
		} else {
			itemListener.itemStateChanged(itemEvent);
		}
	}

	private void removeListener() {
		try {
			Method method = source.getClass().getMethod("removeItemListener",
					new Class[] { ItemListener.class });
			method.invoke(source, new Object[] { this });
		} catch (Exception ex) {
			ex.printStackTrace();
			SS3SignStreamApplication.logger.log(Level.SEVERE, "Exception", ex);
		}
	}
}
