package edu.bu.signstream.grepresentation.view;

import java.util.ArrayList;

public class RootLabelObject {

   private LabelObject nonManuelLabelObject = new LabelObject();
   private LabelObject glossLabelObject = new LabelObject();
   private LabelObject customLabelObject = new LabelObject();
   private LabelObject gestureLabelObject = new LabelObject();
   private LabelObject presentationLabelObject = new LabelObject();
   private LabelObject graphLabelObject = new LabelObject();
   
   public RootLabelObject() {}

   public LabelObject getNonManuelLabelObject() {
      return nonManuelLabelObject;
   }

   public void setNonManuelLabelObject(LabelObject object) {
      nonManuelLabelObject = object;
   }

   public LabelObject getCustomLabelObject() {
      return customLabelObject;
   }

   public void setCustomLabelObject(LabelObject object) {
	   customLabelObject = object;
   }

   public ArrayList<LabelObject> getAllLabelObjects() {
      if (presentationLabelObject != null
         && presentationLabelObject.getAllChildren().size() > 0) {
         return presentationLabelObject.getAllChildren();
      } else {
         try {
            
        	 	ArrayList<LabelObject> list = graphLabelObject.getAllChildren();
            list.addAll(nonManuelLabelObject.getAllChildren());
            list.addAll(customLabelObject.getAllChildren());
            list.addAll(glossLabelObject.getAllChildren());
            list.addAll(gestureLabelObject.getAllChildren());
            return list;
         } catch (NullPointerException ex) {
            return new ArrayList<LabelObject>();
         }
      }
   }

   public LabelObject getGlossLabelObject() {
      return glossLabelObject;
   }

   public LabelObject getPresentationLabelObject() {
      return presentationLabelObject;
   }
   
   public LabelObject getGraphLabelObject() {
	      return graphLabelObject;
   }

   public void setGlossLabelObject(LabelObject object) {
      glossLabelObject = object;
   }

   public void setPresentationLabelObject(LabelObject object) {
      presentationLabelObject = object;
   }
   
   public void setGraphLabelObject(LabelObject obj) {
	   graphLabelObject = obj;
   }

	public LabelObject getGestureLabelObject() {
		return gestureLabelObject;
	}
	
	public void setGestureLabelObject(LabelObject gestureNRelatedLabelObject) {
		this.gestureLabelObject = gestureNRelatedLabelObject;
	}
}
