package edu.bu.signstream.grepresentation.view;

import java.awt.*;

import javax.swing.*;

import edu.bu.signstream.common.files.SSResources;
import edu.bu.signstream.common.util.SegmentGraphReprUtil;
import edu.bu.signstream.common.util.vo.Palette;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class ScrollBarView extends JPanel {

	private static final long serialVersionUID = 1L;
	
	   protected JScrollBar pictureScrollBar;

	   private SignStreamSegmentPanel panel;
	   private JPanel buttonPanel = null;

	   private JSplitPane sp;

	   public ScrollBarView(
	      SignStreamSegmentPanel panel) {
	      this.panel = panel;

	      createUI();
	   }

	   public void createUI() {
		   setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
		   
		   sp = new JSplitPane();

		   buttonPanel = new JPanel(new FlowLayout(FlowLayout.CENTER));
		   buttonPanel.setBackground(Palette.BACKGROUND_COLOR);
		   buttonPanel.setPreferredSize(new Dimension(
				   SegmentGraphReprUtil.UTTERANCE_VIEW_LABEL_PANEL_WIDTH,
				   SegmentGraphReprUtil.UTTERANCE_VIEW_HEADER_FOOTER_HEIGHT));
		   buttonPanel.setMinimumSize(new Dimension(
				   SegmentGraphReprUtil.UTTERANCE_VIEW_LABEL_PANEL_WIDTH,
				   SegmentGraphReprUtil.UTTERANCE_VIEW_HEADER_FOOTER_HEIGHT));

		   var buttonLabel = new JLabel("Field Visibility");
           buttonLabel.setFont(new Font(buttonLabel.getFont().getName(), Font.PLAIN, 12));
//		   buttonPanel.add(buttonLabel);

           var displaySelected = new JButton();
           var iconChecked = SSResources.icon("checked.gif");
           var iconUnchecked = SSResources.icon("unchecked.gif");
           displaySelected.addActionListener(e -> {
               var panel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();

               var display = !panel.displaySelected();
               panel.setDisplaySelected(display);

               if (display) {
                   displaySelected.setIcon(iconChecked);
                   displaySelected.setToolTipText("Include Selected Fields in Visibility");
               } else {
                   displaySelected.setIcon(iconUnchecked);
                   displaySelected.setToolTipText("Ignore Selected Fields in Visibility");
               }
           });
           setButtonLNF(displaySelected);
//           buttonPanel.add(displaySelected);
           // Refresh the selected value
           displaySelected.doClick();
           displaySelected.doClick();

           var displayAnnotated = new JButton();
           var iconCheckedPurple = SSResources.icon("checked_purple.gif");
           var iconUncheckedPurple = SSResources.icon("unchecked_purple.gif");
           displayAnnotated.addActionListener(e -> {
               var panel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();

               var display = !panel.displayAnnotated();
               panel.setDisplayAnnotated(display);

               if (display) {
                   displayAnnotated.setIcon(iconCheckedPurple);
                   displayAnnotated.setToolTipText("Include Annotated Fields in Visibility");
               } else {
                   displayAnnotated.setIcon(iconUncheckedPurple);
                   displayAnnotated.setToolTipText("Ignore Annotated Fields in Visibility");
               }
           });
           setButtonLNF(displayAnnotated);
//           buttonPanel.add(displayAnnotated);
           // Refresh the selected value
           displayAnnotated.doClick();
           displayAnnotated.doClick();

           pictureScrollBar = new JScrollBar(JScrollBar.HORIZONTAL);
		   pictureScrollBar.setPreferredSize(new Dimension(
				   SegmentGraphReprUtil.UTTERANCE_VIEW_GRAPH_PANEL_WIDTH, 
				   SegmentGraphReprUtil.UTTERANCE_VIEW_HEADER_FOOTER_HEIGHT));
		   pictureScrollBar.setMinimumSize(new Dimension(
				   SegmentGraphReprUtil.UTTERANCE_VIEW_GRAPH_PANEL_WIDTH, 
				   SegmentGraphReprUtil.UTTERANCE_VIEW_HEADER_FOOTER_HEIGHT));

		   sp.setLeftComponent(buttonPanel);
		   sp.setRightComponent(pictureScrollBar);
		   
		   add(sp);
	   }

	   private void setButtonLNF(JButton btn) {
//           btn.setFont(new Font(btn.getFont().getName(), Font.PLAIN, 18));

           var size = new Dimension(16, 16);
           btn.setMaximumSize(size);
           btn.setPreferredSize(size);
           btn.setMaximumSize(size);
       }

	   public JScrollBar getJScrollBar() {
		   return pictureScrollBar;
	   }
	   
	   public JSplitPane getSplitPane() {
		   return sp;
	   }
	}
