package edu.bu.signstream.grepresentation.view.mediaControl;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import edu.bu.signstream.common.util.Util;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationEvent;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.time.Time;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.time.TimeUnit;

public abstract class EndFrameListener extends BaseListener implements ActionListener {

	public EndFrameListener(MediaToolBar bar) { super(bar); }

	@Override
	public void actionPerformed(ActionEvent e) {
        var event = bar.selectedEvent();
        var entity = bar.selectedEntity();
        var field = bar.selectedField();

        if (event == null)
            return;

        var time = getNewTime(event)
            .clamp(SS3Singleton.getMediaPlayer().interval());

        var success = false;
        if (event instanceof PresentationEvent) {
            MediaToolbarCommons.setPresentationEventEndTime(time, event, entity);
            success = true;
        } else {
            success = MediaToolbarCommons.setSelectedEventEndTime(time);
        }

        if (success) {
            bar.update();
            panel.repaint();

            // setVisible with some padding manually here to avoid paging after seeking
            Util.dragging(true);
            var coord = time.as(TimeUnit.COORDINATE) + 2;
            panel.setVisible(coord, coord);
            Util.dragging(false);

            player.seek(time);
        }
    }

    abstract Time getNewTime(Event event);
}
