package edu.bu.signstream.grepresentation.view.mediaControl;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import edu.bu.signstream.common.util.ErrorMessages;
import edu.bu.signstream.common.util.Util;
import edu.bu.signstream.grepresentation.fields.*;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationEvent;
import edu.bu.signstream.time.Rounding;
import edu.bu.signstream.time.Time;
import edu.bu.signstream.time.TimeUnit;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureEnteredText;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureEventsEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureField;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureText;
import edu.bu.signstream.grepresentation.fields.glossField.Compoundable;
import edu.bu.signstream.grepresentation.fields.glossField.EnteredText;
import edu.bu.signstream.grepresentation.fields.glossField.GlossChainedEventsEntity;
import edu.bu.signstream.grepresentation.fields.glossField.GlossField;
import edu.bu.signstream.grepresentation.fields.glossField.Text;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationEventsEntity;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.media.MediaPlayer;

public class SetStartTimeListener implements ActionListener {

	private MediaToolBar bar;
	protected final MediaPlayer player;

	public SetStartTimeListener(MediaToolBar bar) {
		this.bar = bar;
	    this.player = SS3Singleton.getMediaPlayer();
	}

	@Override
	public void actionPerformed(ActionEvent e) {

	    // TODO: DISASTER! REWRITE ALL OF THIS!

		Event event = bar.selectedEvent();
		
		Field field = bar.selectedField();
		SignStreamSegmentPanel panel = bar.segmentPanel();

		var success = false;

		MediaToolbarVideoController.stopPlayingVideo(panel);

		EventsEntity selectedEntity = bar.selectedEntity();
//		EventsEntity parentEntity = null;

        var time = SS3Singleton.getMediaPlayer().time();
        if (event.getStartTimeInfo() != null)
            time = time.in(event.getStartTimeInfo().range());
        else
            time = time.in(Util.getCurrentRange(field));
        System.out.println("SetStartTime " + time);

//		if (selectedEntity != null) {
//			parentEntity = selectedEntity.getParentEntity();
//		} else {
//			PresentationField parentField = field.getParentField();
//			parentEntity = (EventsEntity) parentField.getEventAt(coord);
//		}
		
		if (field instanceof GlossField) {
		    if (event instanceof TextEventsEntity) {
		    	GlossChainedEventsEntity prevEntity = ((GlossField) field).getPreviousEntity(time);
		    	GlossChainedEventsEntity nextEntity = ((GlossField) field).getNextEntity(time);
		    	
		    	if (prevEntity != null && nextEntity != null) {
		    		Compoundable endCompound = prevEntity.getEndCompound();
		    		Compoundable startCompound = nextEntity.getStartCompound();
		    		
		    		if (endCompound != null && startCompound != null) {
						SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.CANT_ADD_GLOSS_BETWEEN_COMPOUNDS);
		    			return;
		    		}
		    	}
		    	
                event.setStartTimeInfo(time);
                success = true;
		    }
		    else
                success = MediaToolbarCommons.setSelectedEventStartTime(time);
//			GlossField glsField = (GlossField) field;
//
//			// enforce that a one-frame gloss occupies its frame all by itself with no other gloss entities intersecting
//			for (Object ent: glsField.getEntities()) {
//				GlossChainedEventsEntity glsFieldEntity = (GlossChainedEventsEntity) ent;
//
//				Time glsFieldEntityStartTimeInfo = glsFieldEntity.getStartTimeInfo();
//				Time glsFieldEntityEndTimeInfo = glsFieldEntity.getEndTimeInfo();
//
//				if (time.equals(glsFieldEntityStartTimeInfo) && glsFieldEntityStartTimeInfo.equals(glsFieldEntityEndTimeInfo)) {
//					SS3Singleton.getErrorMessages().showErrorMessage(
//							ErrorMessages.CHAINS_CANNOT_OVERLAP);
//					return;
//				}
//			}
//
//			EnteredText enteredText = glsField
//					.getGlossChainedEventsEntityCollection().getEnteredText();
//
//			ArrayList<Text> selectedText = enteredText.getSelectedText();
//
//			if (selectedText.isEmpty()) {
//				if (event == null)
//				{
//					SS3Singleton.getErrorMessages().showErrorMessage(
//							ErrorMessages.EVENT_NOT_SELECTED);
//					return;
//				}
//
//				MediaToolbarCommons.setSelectedEventStartTime(time);
////			} else if (parentEntity != null) {
//			} else {
////				Time utteranceStartTimeInfo = parentEntity.getStartTimeInfo();
////				Time utteranceEndTimeInfo = parentEntity.getEndTimeInfo();
////
////				if (time.lessThan(utteranceStartTimeInfo) && time.lessThan(utteranceEndTimeInfo)) {
////					SS3Singleton.getErrorMessages().showErrorMessage(
////							ErrorMessages.EVENT_EXTEND_BEYOND_UTTERANCE);
////					return;
////				}
//
//				GlossChainedEventsEntity glsEntity = (GlossChainedEventsEntity) selectedEntity;
//				MediaToolbarCommons.setTextStartEndTime(glsField, glsEntity,
//						time, coord, bar);
//			}
		} else if (field instanceof GestureField) {
            if (event instanceof GestureTextEventsEntity) {
                event.setStartTimeInfo(time);
                success = true;
            }
            else
                success = MediaToolbarCommons.setSelectedEventStartTime(time);
//
//
//
//            GestureField glsField = (GestureField) field;
//
//			// enforce that a one-frame gloss occupies its frame all by itself with no other gloss entities intersecting
//			for (Object ent: glsField.getEntities()) {
//				GestureEventsEntity glsFieldEntity = (GestureEventsEntity) ent;
//
//				Time glsFieldEntityStartTimeInfo = glsFieldEntity.getStartTimeInfo();
//				Time glsFieldEntityEndTimeInfo = glsFieldEntity.getEndTimeInfo();
//
//				if (time.equals(glsFieldEntityStartTimeInfo) && glsFieldEntityStartTimeInfo.equals(glsFieldEntityEndTimeInfo)) {
//					SS3Singleton.getErrorMessages().showErrorMessage(
//							ErrorMessages.CHAINS_CANNOT_OVERLAP);
//					return;
//				}
//			}
//
//			EnteredText_XYZ enteredText = glsField
//					.getGestureEventsEntityCollection().getEnteredText();
//
//			ArrayList<Text_XYZ> selectedText = enteredText.getSelectedText();
//
//			if (selectedText.isEmpty()) {
//				if (event == null)
//				{
//					SS3Singleton.getErrorMessages().showErrorMessage(
//							ErrorMessages.EVENT_NOT_SELECTED);
//					return;
//				}
//
//				MediaToolbarCommons.setSelectedEventStartTime(time);
////			} else if (parentEntity != null) {
//			} else {
////				Time utteranceStartTimeInfo = parentEntity.getStartTimeInfo();
////				Time utteranceEndTimeInfo = parentEntity.getEndTimeInfo();
////
////				if (time.lessThan(utteranceStartTimeInfo) && time.lessThan(utteranceEndTimeInfo)) {
////					SS3Singleton.getErrorMessages().showErrorMessage(
////							ErrorMessages.EVENT_EXTEND_BEYOND_UTTERANCE);
////					return;
////				}
//
//				GestureEventsEntity glsEntity = (GestureEventsEntity) selectedEntity;
//				MediaToolbarCommons.setTextStartEndTime(glsField, glsEntity,
//						time, coord, bar);
//			}
		} else if (event instanceof PresentationEvent) {
            success = MediaToolbarCommons.setPresentationEventStartTime(time, event, selectedEntity);
		} else {
			success = MediaToolbarCommons.setSelectedEventStartTime(time);
		}

        if (success) {
            bar.update();
            panel.setVisible(time);
            panel.repaint();

            player.seek(time);
        }
	}
}
