package edu.bu.signstream.grepresentation.view.mediaControl;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import edu.bu.signstream.common.util.Util;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationEvent;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationEventsEntity;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.time.Rounding;
import edu.bu.signstream.time.Time;
import edu.bu.signstream.grepresentation.fields.Event;

public abstract class StartFrameListener extends BaseListener implements ActionListener{

	public StartFrameListener(MediaToolBar bar) { super(bar); }

	@Override
	public void actionPerformed(ActionEvent e) {
		var event = bar.selectedEvent();
        var entity = bar.selectedEntity();
        var field = bar.selectedField();

        if (event == null)
			return;

		var time = getNewTime(event)
            .clamp(SS3Singleton.getMediaPlayer().interval());

		var success = false;
		if (event instanceof PresentationEvent) {
            MediaToolbarCommons.setPresentationEventStartTime(time, event, entity);
            success = true;
		} else {
			success = MediaToolbarCommons.setSelectedEventStartTime(time);
		}

		if (success) {
            bar.update();
            panel.repaint();

            player.seek(time);
        }
	}

	abstract Time getNewTime(Event event);
}
