package edu.bu.signstream.grepresentation.view.mediaControl;

import edu.bu.signstream.common.util.Util;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.time.TimeRange;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

public class TimeRangeCycleListener extends BaseListener implements ActionListener {

    public TimeRangeCycleListener(MediaToolBar bar) { super(bar); }

    @Override
    public void actionPerformed(ActionEvent e) {
        var ranges = new ArrayList<TimeRange>();
        if (SS3Singleton.getRealVideoTimeRange() != null)
            ranges.add(SS3Singleton.getVideoTimeRange());
        if (SS3Singleton.getAudioTimeRange() != null)
            ranges.add(SS3Singleton.getAudioTimeRange());
        for (var g : panel.getSS3Database().getGraphs())
            ranges.add(g.range());
        ranges.add(TimeRange.ABSOLUTE);

        var range = Util.getSelectedRange();
        var idx = ranges.indexOf(range);

        if (range == null)
            range = ranges.get(0);
        else if (idx != -1 && idx < ranges.size() - 1)
            range = ranges.get(idx + 1);
        else
            range = null;

        Util.setUnitStep(Util.UnitStep.DEFAULT);
        Util.setSelectedRange(range);
        bar.update();
    }
}
