package edu.bu.signstream.navigation;

import edu.bu.signstream.common.util.SegmentGraphReprUtil;
import edu.bu.signstream.common.util.vo.Excerpt;
import edu.bu.signstream.common.util.vo.ss3.db.*;
import edu.bu.signstream.time.TimeRange;
import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.grepresentation.view.mediaControl.MediaToolBar;
import edu.bu.signstream.ui.SS3SignStreamApplication;

import javax.swing.*;
import javax.swing.tree.DefaultMutableTreeNode;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.logging.Level;

class TreeMouseListener implements MouseListener {
    private final DbNavigationPanel panel;

    public TreeMouseListener(DbNavigationPanel panel) {
        this.panel = panel;
    }

    @Override
    public void mousePressed(MouseEvent e) {
    }

    @Override
    public void mouseReleased(MouseEvent e) {
    }

    @Override
    public void mouseEntered(MouseEvent e) {
    }

    @Override
    public void mouseExited(MouseEvent e) {
    }

    @Override
    public void mouseClicked(MouseEvent e) {

        if (e.getClickCount() >= 2) {

            final JTree tree = panel.getJTree();

            DefaultMutableTreeNode node = (DefaultMutableTreeNode) tree
                    .getLastSelectedPathComponent();

            SS3SignStreamApplication.logger.log(Level.INFO, "Node [" + node
                    + "] had been selected.");

            SignStreamSegmentPanel segmentPanel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();

            if (node != null) {
                // JACK TODO: Why zero here??
//                SegmentGraphReprUtil.utteranceMovieTimeOnset = 0;
//                SegmentGraphReprUtil.utteranceMovieTimeOffset = -1;
                SegmentGraphReprUtil.utteranceStart = TimeRange.ABSOLUTE.zero();
                SegmentGraphReprUtil.utteranceEnd = null;

                segmentPanel.updateLoadedDatabase();

                Object obj = node.getUserObject();

                if (obj instanceof Excerpt) {
                    Excerpt excerpt = (Excerpt) obj;
                    SS3DatabaseCollection dbCol = SS3Singleton
                            .getSS3DatabaseCollection();
                    SS3Database db = dbCol.getSS3Database(excerpt);

                    panel.getSignStreamSegmentPanel().loadDatabase(db);

                    // // calculate coef that will allow users to see entire
                    // // duration of a video file on a screen
//                    int movieDuration = panel.getSignStreamSegmentPanel()
//                            .getMultipleMovieController().getMovieDuration();
//                    int packetDuration = (int) panel
//                            .getSignStreamSegmentPanel()
//                            .getMultipleMovieController().getPacketDuration();

                    try {
                        MediaToolBar mToolBar = SS3Singleton.getMediaToolBar();
                        mToolBar.exitUtterance();
                    } catch(Exception ex) {
                        ;
                    }

//                    if (movieDuration == 0) {
//                        movieDuration = db.getMovieDuration();
//                        packetDuration = db.getPacketDuration();
//                    }
//
//                    if (movieDuration == 0) {
//                        SS3GlossWindow glossWindow = db.getSS3GlossWindow();
//                        ArrayList<SS3TemporalPartition> temporalPartitions = glossWindow
//                                .getTemporalPartitions();
//                        for (SS3TemporalPartition temporalPartition : temporalPartitions) {
//                            SS3GlossWindowSegment segment = temporalPartition
//                                    .getGlossWindowSegment();
//                            ArrayList<SS3GlossWindowItem> items = segment
//                                    .getSS3GlossWindowItems();
//                            for (SS3GlossWindowItem item : items) {
//                                int time = item.getEndTimeInfo().getMovieTime();
//                                if (time > movieDuration)
//                                    movieDuration = time;
//                            }
//                        }
//                        packetDuration = 1001;
//                        movieDuration = movieDuration + 20 * packetDuration;
//                    }
//
//                    panel.getSignStreamSegmentPanel().getZoomer()
//                            .getCoordinateTimeConvertor()
//                            .setPacketDuration(packetDuration);
//
//                    double pixelsInTimeframe = db
//                            .getTemporalPartitionPixelInTimeFrame();
//
//                    int width = panel.getsignstreamsegmentpanel()
//                            .getdatabaseview().getvisiblewidth2();
//
//                    if (pixelsInTimeframe <= 0) {
//                        panel.getSignStreamSegmentPanel()
//                                .getZoomer()
//                                .fillEntirePage(movieDuration, packetDuration,
//                                        width);
//                    } else {
//                        panel.getSignStreamSegmentPanel().getZoomer()
//                                .getCoordinateTimeConvertor()
//                                .setPixelInTimeFrame(pixelsInTimeframe);
//                    }
//
//                    int movieTime = SS3Singleton.getVideoControlManager()
//                            .getMultipleMovieController().getCurrentTime();
//                    panel.getSignStreamSegmentPanel().getSlider()
//                            .setSliderPositionTime(movieTime);

//                    int width = panel.getSignStreamSegmentPanel().getDatabaseView().getVisibleWidth2();
//                    panel.getSignStreamSegmentPanel().getZoomer().getCoordinateTimeConvertor().resize(width);
//
//                    var contr = SS3Singleton.getVideoControlManager().getMultipleMovieController();
//                    panel.getSignStreamSegmentPanel().getZoomer().getCoordinateTimeConvertor().setTimeScale(contr.getPacketDuration(), contr.getMovieDuration());
                }
            }
        }
    }
}

