package edu.bu.signstream.ui.frame.dialog;

import edu.bu.signstream.grepresentation.reguestsHandler.SS3Singleton;
import edu.bu.signstream.ui.SS3SignStreamApplication;

import javax.swing.*;
import java.awt.*;

public class SaveDialog extends Dialog {
    public SaveDialog(Runnable onRun, Runnable onCancel) {
        var app = SS3Singleton.getSignStreamApplication();

        var panel = new JPanel(new FlowLayout(FlowLayout.LEFT, 5, 0));

        var dontSave = new JButton("Don't Save");
        dontSave.addActionListener(l -> {
            setVisible(false);
            onRun.run();
        });
        panel.add(dontSave);

        var cancel = new JButton("Cancel");
        cancel.addActionListener(l -> {
            setVisible(false);
            onCancel.run();
        });
        panel.add(cancel);

        var save = new JButton("Save");
        save.addActionListener(l -> {
            setVisible(false);
            app.saveCollection(SS3SignStreamApplication.SAVE);
            onRun.run();
        });
        panel.add(save);

        var label = new JPanel();
        label.add(new JLabel("Save changes before proceeding?"));

        add(label);
        add(panel);

        SwingUtilities.invokeLater(save::requestFocus);
    }
}
